(function($){

$.widget("ui.sbip_schedule", { 
   options: {
     scheduleItem: '',
     dateFormat: 'mm/dd/yy',
     use24hTime: 'N',
     incStartTime: 'Y',
     incEndTime: 'Y',
     incAllDay: 'Y',
     incSingle: 'Y',
     incDaily: 'Y',
     incWeekly: 'Y',
     incMonthy: 'Y',
     incYearly: 'Y',
     am: 'am',
     pm: 'pm'
   },
   values: {
      asv1: '',
      asv2: '',
      asv3: '',
      asv4: '',
      use24hTime: '',
      startDate: '',
      startDateFmt: '',
      startHour: '',
      startMin: '',
      startTimeFmt: '',
      endDate: '',
      endDateFmt: '',
      endHour: '',
      endMin: '',
      endTimeFmt: '',
      durationSeconds: '', //86400: allDayOn = true
      calendarString: {
         freq: '',
         interval: '',
         byday: '',
         bymonth: '',
         bymonthday: ''
      },
      parseError: false
   },
   elements: {
      $dialog: {},
      $scheduleTable: {},
      $validationErrors: {},
      $errorMessages: {},
      $startTime: {},
      $endTime: {},
      $allDay: {},
      $focusedTime: {},
      $timePicker: {},
      $frequency: {},
      $interval: {},
      $startDate: {},
      $endDate: {}
   },
   _init: function() {
      var uiw = this;
         
      uiw.element
         .hover(function() {
            $(this).css({
               'opacity':'0.4',
               'filter':'alpha(opacity=40)',
               'cursor':'pointer'
            });
         }, function() {
            $(this).css({
               'opacity':'1',
               'filter':'none',
               'cursor':'default'
            });
         })
         .click(function(){
            $(this).sbip_schedule('showDialog');
         });
         
      uiw._parseItemValues();
      uiw.resetDisplayView();
   },
   _isNull: function(value) {
      if (value === undefined || value === '') {
         return true;
      } else {
         return false;
      }
   },
   _isNotNull: function(value) {
      if (value === undefined || value === '') {
         return false;
      } else {
         return true;
      }
   },
   _isBoolean: function(value) {
      if (value === true || value === false) {
         return true;
      } else {
         return false;
      }
   },
   _isValidDate: function(dateStr, formatStr) {
      var uiw = this;
      var retval = true;
      
      try {
         var dateTest = $.datepicker.parseDate(formatStr, dateStr);
      } catch (errorObj) {
         retval = false;
      }
      
      return retval;
   },
   _isValidTime: function(timeStr, use24hTime) {
      var uiw = this;
      var amPm;
      var hour;
      var minute;
      var separator;
      
      if (uiw._isNull(use24hTime)) {
         return false;
      }

      if (use24hTime === false) {
         if (timeStr.length != 7) {
            return false;
         }
      
         amPm = timeStr.substring(5, 7);
         
         if (amPm != uiw.options.am && amPm != uiw.options.pm) {
            return false;
         }
         
         hour = timeStr.substring(0, 2);
         
         if (isNaN(hour)) {
            return false;
         }
         
         hour = parseInt(hour, 10);
         
         if (hour < 1 || hour > 12) {
            return false;
         }
         
         minute = timeStr.substring(3, 5);
         
         if (isNaN(minute)) {
            return false;
         }
         
         minute = parseInt(minute, 10);
         
         if (minute < 0 || minute > 59) {
            return false;
         }
         
         separator = timeStr.substring(2, 3);
         
         if (separator != ':') {
            return false;
         }
         
         return true;
      } else {//Using 24 hour format   
         if (timeStr.length != 5) {
            return false;
         }
         
         hour = timeStr.substring(0, 2);
         
         if (isNaN(hour)) {
            return false;
         }
         
         hour = parseInt(hour, 10);
         
         if (hour < 1 || hour > 12) {
            return false;
         }
         
         minute = timeStr.substring(3, 5);
         
         if (isNaN(minute)) {
            return false;
         }
         
         minute = parseInt(minute, 10);
         
         if (minute < 0 || minute > 59) {
            return false;
         }
         
         separator = timeStr.substring(2, 3);
         
         if (separator != ':') {
            return false;
         }
         
         return true;
      }
   },
   _showDurationWarning: function() {
      var uiw,   
         hours12,
         $warning,
         durSeconds;
         
      uiw = this;

      if (
         !uiw._isValidTime(uiw.elements.$startTime.val(), uiw.values.use24hTime)
         || !uiw._isValidTime(uiw.elements.$endTime.val(), uiw.values.use24hTime)
      ) {
         return;
      }
      
      hours12 = 43200;
      $warning = $('tr#duration_warning');
      durSeconds = uiw._getDuration('seconds');
      
      if (
         !uiw.elements.$allDay.attr('checked') 
         && durSeconds > hours12
         && !$warning.length
      ) {
         $('table#sbip_edit_table > tbody > tr:eq(1)').after(
              '<tr id="duration_warning">   <td>&nbsp;</td><td align="left" colspan="2" rowspan="1">'
            + '   <div style="" class="ui-widget">'
            + '   <div class="ui-state-highlight ui-corner-all" style="padding: 0pt 0.7em;">'
            + '      <span class="ui-icon ui-icon-info" style="float: left; margin-right: 0.3em;"></span>'
            + '      Warning: Duration over 12 hours'
            + '   </div>'
            + '   </div></td></tr>'
         );
      } else if (
         (uiw.elements.$allDay.attr('checked') 
         || durSeconds <= hours12)
         && $warning.length
      ){
         $warning.remove();
      }
   }, 
   _shiftEndTime: function(){
      var uiw = this;
      var orgTime24;
      var newTime24;
      var endTime24;
      var startDate1;
      var startDate2;
      var endDate;
      var duration_ms;
      var hours;
      var minutes;

      if (
         uiw.elements.$startTime.val() == uiw.elements.$startTime.attr('data-org-time')
         || !uiw._isValidTime(uiw.elements.$startTime.val(), uiw.values.use24hTime)
         || !uiw._isValidTime(uiw.elements.$startTime.attr('data-org-time'), uiw.values.use24hTime)
         || !uiw._isValidTime(uiw.elements.$endTime.val(), uiw.values.use24hTime)
      ) {
         return;
      }
      
      if (!uiw.values.use24hTime) {
         orgTime24 = uiw._getTime12to24(uiw.elements.$startTime.attr('data-org-time'));
         newTime24 = uiw._getTime12to24(uiw.elements.$startTime.val());
         endTime24 = uiw._getTime12to24(uiw.elements.$endTime.val());
      } else {
         orgTime24 = uiw.elements.$startTime.attr('data-org-time');
         newTime24 = uiw.elements.$startTime.val();
         endTime24 = uiw.elements.$endTime.val();
      }

      startDate1 = new Date(2000, 1, 1, newTime24.substring(0, 2), newTime24.substring(3, 5), 0, 0);
      startDate2 = new Date(2000, 1, 1, orgTime24.substring(0, 2), orgTime24.substring(3, 5), 0, 0);
      duration_ms = startDate2 - startDate1;
      
      hours = parseInt(duration_ms/(1000*60*60));
      minutes = parseInt((duration_ms/(1000*60))%60);
      
      endDate = new Date(2000, 1, 1, endTime24.substring(0, 2), endTime24.substring(3, 5), 0, 0);
      endDate.setHours(endDate.getHours() - hours);
      endDate.setMinutes(endDate.getMinutes() - minutes);
      
      hours = endDate.getHours();
      hours = (hours < 10) ? '0' + hours : hours;
      
      minutes = endDate.getMinutes();
      minutes = (minutes < 10) ? '0' + minutes : minutes;
      
      endTime24 = hours + ':' + minutes;
      
      if (!uiw.values.use24hTime) {
         uiw.elements.$endTime.val(uiw._getTime24to12(endTime24));
      } else {
         uiw.elements.$endTime.val(endTime24);
      }
   },
   _getTime12to24: function(time12) {
      var uiw = this;
      var hour12;
      var min;
      var amPm;
      var time24;
      
      if (!uiw._isValidTime(time12, uiw.values.use24hTime)) {
         return;
      }
      
      hour12 = parseInt(time12.substring(0, time12.indexOf(':')), 10);
      min = time12.substr(time12.indexOf(':') + 1, 2);
      amPm = time12.substr(time12.indexOf(':') + 3, 2);
      
      if (amPm == uiw.options.pm && hour12 != 12) {
         time24 = (hour12 + 12) + ':' + min;
      } else if (amPm == uiw.options.am && hour12 == '12') {
         time24 = '00' + ':' + min;
      } else {
         time24 = (hour12 < 10) ? '0' + hour12 : hour12;
         time24 = time24 + ':' + min;
      }
      
      return time24;   
   },
   _getTime24to12: function(time24) {
      var uiw = this;
      var hour24;
      var min;
      var time12;
      
      hour24 = parseInt(time24.substring(0, time24.indexOf(':')), 10);
      min = time24.substr(time24.indexOf(':') + 1, 2);
      
      if (hour24 == 12) {
         time12 = '12:' + min + uiw.options.pm;
      } else if (hour24 > 12) {
         time12 = hour24 - 12;
         time12 = (time12 < 10) ? '0' + time12 : time12;
         time12 = time12 + ':' + min + uiw.options.pm;
      } else {
         time12 = (hour24 == 0) ? '12' : hour24;
         time12 = (time12 < 10) ? '0' + time12 : time12;
         time12 = time12 + ':' + min + uiw.options.am;
      }
      
      return time12; 
   },
   _getDuration: function(measure) {
      var uiw;
      var durationString;
      var startDate;
      var endDate;
      var startHour;
      var startMin;
      var endTime;
      var endHour;
      var endMin;
      var secondsAllDay;
      
      uiw = this;
      measure = (measure) ? measure : 'seconds';
      startDate = $.datepicker.parseDate('yymmdd', '20010101');
      endDate = $.datepicker.parseDate('yymmdd', '20010101');
      secondsAllDay = '86400';
      
      if (uiw.elements.$allDay.attr('checked')) {
         durationString = secondsAllDay; 
      } else {
         startTime = uiw._getTime12to24(uiw.elements.$startTime.val());
         startHour = startTime.substring(0,2);
         startMin = startTime.substring(3,5);
         startDate.setHours(startHour, startMin, 0, 0); 
      
         endTime = uiw._getTime12to24(uiw.elements.$endTime.val());
         endHour = endTime.substring(0,2);
         endMin = endTime.substring(3,5);
     
         endDate.setHours(endHour, endMin, 0, 0);
         
         if (measure = 'seconds'){
            divisor = 1000;
         }
         
         if (endDate < startDate) {
            endDate.setHours(endDate.getHours() + 24);
            durationString = ((endDate-startDate)/divisor);
         } else {
            durationString = ((endDate-startDate)/divisor);
         }
      }
      
      return parseInt(durationString);
   },
   _parseItemValues: function() {
      var uiw = this;
      var schedule = $('input#' + uiw.options.scheduleItem).val();
      
      if (schedule) {
         var scheduleValues = schedule.split('|');
         var startDate2; //dummy start date to calc time/duration
         var startTime24;
         var endTime24;
         
         uiw.values.sv1 = scheduleValues[0];
         uiw.values.sv2 = scheduleValues[1];
         uiw.values.sv3 = scheduleValues[2];
         uiw.values.sv4 = scheduleValues[3];
         
         uiw.values.durationSeconds = parseInt(uiw.values.sv3);
         
         uiw.values.use24hTime = (uiw.options.use24hTime == 'Y') ? true : false;
         
         uiw.values.startHour = parseInt(uiw.values.sv1.substring(8,10), 10);
         uiw.values.startMin = parseInt(uiw.values.sv1.substring(10,12), 10);
      
         uiw.values.startDate = $.datepicker.parseDate('yymmdd', uiw.values.sv1.substring(0,8));
         uiw.values.startDate.setHours(uiw.values.startHour, uiw.values.startMin, 0, 0);
         uiw.values.startDateFmt = $.datepicker.formatDate(uiw.options.dateFormat, uiw.values.startDate);
         
         startDate2 = $.datepicker.parseDate('yymmdd', uiw.values.sv1.substring(0,8));
         startDate2.setHours(uiw.values.startHour, uiw.values.startMin, 0, 0);
         startDate2.setHours(startDate2.getHours() + (uiw.values.sv3/60/60));
         startDate2.setMinutes(startDate2.getMinutes() + ((uiw.values.sv3/60)%60));
         uiw.values.endHour = startDate2.getHours();
         uiw.values.endMin = startDate2.getMinutes();
         
         if (uiw.values.sv2) {
            if (uiw._isValidDate(uiw.values.sv1.substring(0,8), 'yymmdd')) {
               uiw.values.endDate = $.datepicker.parseDate('yymmdd', uiw.values.sv2.substring(0,8));
               uiw.values.endDate.setHours(uiw.values.endHour, uiw.values.endMin, 0, 0);
               uiw.values.endDateFmt = $.datepicker.formatDate(uiw.options.dateFormat, uiw.values.endDate);
            } else {
               uiw.values.endDate = '';
               uiw.values.endDateFmt = 'Error';
            }
         } else {
            uiw.values.endDate = '';
            uiw.values.endDateFmt = '-';
         }
         
         startTime24 = uiw.values.startHour + ':';
         startTime24 = (uiw.values.startMin == 0) ? startTime24 + '0' + uiw.values.startMin : startTime24 + uiw.values.startMin;
         
         uiw.values.startTimeFmt = uiw._getTime24to12(startTime24);
         
         endTime24 = uiw.values.endHour + ':';
         endTime24 = (uiw.values.endMin == 0) ? endTime24 + '0' + uiw.values.endMin : endTime24 + uiw.values.endMin;
         
         uiw.values.endTimeFmt = uiw._getTime24to12(endTime24);
         
         uiw.values.calendarString.freq = uiw.values.sv4.substring(uiw.values.sv4.indexOf('FREQ=')+5,uiw.values.sv4.indexOf(';', uiw.values.sv4.indexOf('FREQ=')));
         uiw.values.calendarString.interval = parseInt(uiw.values.sv4.substring(uiw.values.sv4.indexOf('INTERVAL=')+9,uiw.values.sv4.indexOf(';', uiw.values.sv4.indexOf('INTERVAL='))));
         
         if (uiw.values.sv4.indexOf('BYDAY=') != -1) {
            uiw.values.calendarString.byday = uiw.values.sv4.substring(uiw.values.sv4.indexOf('BYDAY=')+6,uiw.values.sv4.indexOf(';', uiw.values.sv4.indexOf('BYDAY=')));
         } else {
            uiw.values.calendarString.byday = '';
         }
         if (uiw.values.sv4.indexOf('BYMONTH=') != -1) {
            uiw.values.calendarString.bymonth = uiw.values.sv4.substring(uiw.values.sv4.indexOf('BYMONTH=')+8,uiw.values.sv4.indexOf(';', uiw.values.sv4.indexOf('BYMONTH=')));
         } else {
            uiw.values.calendarString.bymonth = '';
         }
         if (uiw.values.sv4.indexOf('BYMONTHDAY=') != -1) {
            uiw.values.calendarString.bymonthday = uiw.values.sv4.substring(uiw.values.sv4.indexOf('BYMONTHDAY=')+11,uiw.values.sv4.indexOf(';', uiw.values.sv4.indexOf('BYMONTHDAY=')));
         } else {
            uiw.values.calendarString.bymonthday = '';
         }
      } else {
         uiw.values.sv1 = '';
         uiw.values.sv2 = '';
         uiw.values.sv3 = '';
         uiw.values.sv4 = '';
         uiw.values.durationSeconds = '';
         uiw.values.use24hTime = (uiw.options.use24hTime == 'Y') ? true : false;
         uiw.values.startHour = '';
         uiw.values.startMin = '';
         uiw.values.startDate = '';
         uiw.values.startDateFmt = '';         
         uiw.values.endHour = '';
         uiw.values.endMin = '';
         uiw.values.endDate = '';
         uiw.values.endDateFmt = '';
         uiw.values.startTimeFmt = '';
         uiw.values.endTimeFmt = '';
         uiw.values.calendarString.freq = '';
         uiw.values.calendarString.interval = '';
         uiw.values.calendarString.byday = '';
         uiw.values.calendarString.bymonth = '';
         uiw.values.calendarString.bymonthday = '';
         
      }
   },
   _initElements: function() {
      var uiw = this;
      
      uiw.elements.$dialog = $('div#sbip_dialog');
      uiw.elements.$scheduleTable = $('table#sbip_edit_table');
      uiw.elements.$validationErrors = $('div#sbip_validation_errors');
      uiw.elements.$errorMessages = $('ul#sbip_error_messages');
      uiw.elements.$startTime = $('input#sbip_schedule_start_time');
      uiw.elements.$endTime = $('input#sbip_schedule_end_time');
      uiw.elements.$allDay = $('input#sbip_schedule_time_ad');
      //uiw.elements.$timePicker is transient and set when added
      //uiw.elements.$focusedTime is transient and set when clicked
      uiw.elements.$frequency = $('select#sbip_schedule_frequency');
      uiw.elements.$interval = $('select#sbip_schedule_interval');
      uiw.elements.$startDate = $('input#sbip_schedule_start_date');
      uiw.elements.$endDate = $('input#sbip_schedule_end_date');
   },
   resetDisplayView: function() {
      var uiw = this;
      var scheduleHtml;
      
      if (uiw.values.startDate) {
         scheduleHtml =
              '<table class="ui-widget">'
            + '<tbody>'
            + '   <tr>'
            + '      <th class="ui-widget-header">Starts On:</th>'
            + '      <td class="ui-widget-content">' + uiw.values.startDateFmt + '</td>'
            + '   </tr>'
            + '   <tr>'
            + '      <th class="ui-widget-header">Time:</th>';
            
         if (uiw.values.durationSeconds == 86400) {
            scheduleHtml += '      <td class="ui-widget-content">All Day</td>';
         } else {
            scheduleHtml += '      <td class="ui-widget-content">' + uiw.values.startTimeFmt + ' to ' + uiw.values.endTimeFmt + '</td>';
         }
         
         scheduleHtml += 
              '   </tr>'
            + '   <tr>'
            + '      <th class="ui-widget-header">Repeats:</th>'
            + '      <td class="ui-widget-content">' + uiw._calendarSummary(uiw.values.sv4) + '</td>'
            + '   </tr>'
            + '   <tr>'
            + '      <th class="ui-widget-header">Ends:</th>'
            + '      <td class="ui-widget-content">' + uiw.values.endDateFmt + '</td>'
            + '   </tr>'
            + '</tbody>'
            + '</table>';
      } else {
         scheduleHtml =
              '<table class="ui-widget">'
            + '<tbody>'
            + '   <tr>'
            + '      <th class="ui-widget-header">Click to define schedule...</th>'
            + '   </tr>'
            + '</tbody>'
            + '</table>';
      }
         
      uiw.element.html(scheduleHtml);
   },
   _calendarSummary: function() {
      var uiw = this;
      var retval;
      
      function ordinal(num) {
         var lastNum = parseInt(num.toString().substr(-1));
         if (lastNum > 3 || lastNum == 0 || num == 11 || num == 12 || num == 13) {
            return num + 'th';
         } else if (lastNum == 1) {
            return num + 'st';
         } else if (lastNum == 2) {
            return num + 'nd';
         } else if (lastNum == 3) {
            return num + 'rd';
         }
      }
      
      if (!uiw.values.sv4) {
         retval = '-';
      } else {         
         if (uiw.values.calendarString.freq == 'DAILY') {
            if (uiw.values.calendarString.interval == 1) {
               retval = 'Daily';
            } else {
               retval = 'Every ' + uiw.values.calendarString.interval + ' days';
            }
         } else if (uiw.values.calendarString.freq == 'WEEKLY') {
            var byDayDisplay = '';
            var days = uiw.values.calendarString.byday.split(',');
                           
            if (uiw.values.calendarString.interval == 1) {
               retval = 'Weekly on ';
            } else {
               retval = 'Every ' + uiw.values.calendarString.interval + ' weeks on ';
            }
            
            $.each(days, function(i) {
               if (days.length > 1 && days.length-1 == i){
                  byDayDisplay += 'and ';
               }
               
               if (this == 'SUN') {
                  byDayDisplay += 'Sunday, ';
               } else if (this == 'MON') {
                  byDayDisplay += 'Monday, ';
               } else if (this == 'TUE') {
                  byDayDisplay += 'Tuesday, ';
               } else if (this == 'WED') {
                  byDayDisplay += 'Wednesday, ';
               } else if (this == 'THU') {
                  byDayDisplay += 'Thursday, ';
               } else if (this == 'FRI') {
                  byDayDisplay += 'Friday, ';
               } else if (this == 'SAT') {
                  byDayDisplay += 'Saturday, ';
               }
            });
               
            retval += byDayDisplay.replace(/,\s$/,'');
            
            if (days.length == 2) {
               retval = retval.replace(/,/,'');
            }
         } else if (uiw.values.calendarString.freq == 'MONTHLY') {
            if (uiw.values.calendarString.interval == 1) {
               retval = 'Monthly on the ';
            } else {
               retval = 'Every ' + uiw.values.calendarString.interval + ' months on the ';
            }
            
            if (uiw.values.calendarString.bymonthday) {
               if (uiw.values.calendarString.bymonthday == -1) { 
                  retval += 'last day';
               } else {
                  retval += ordinal(uiw.values.calendarString.bymonthday);
               }
            } else if (uiw.values.calendarString.byday) {
               if (parseInt(uiw.values.calendarString.byday) == -1) {
                  retval += 'last ';
               } else {
                  retval += ordinal(parseInt(uiw.values.calendarString.byday)) + ' ';
               }
               
               retval += $.datepicker.formatDate('DD', uiw.values.startDate);
            }
         } else if (uiw.values.calendarString.freq == 'YEARLY') {
            retval = 'Yearly on the '
               + ordinal(uiw.values.calendarString.bymonthday)
               + ' of '
               + $.datepicker.formatDate('MM', uiw.values.startDate);
         }
      }
      
      return retval;
   },
   showDialog: function() {      
      var uiw = this;
      
      var dialogHtml =
         '<div id="sbip_dialog" title="Schedule" style="display:none;"><table id="sbip_edit_table">'
         + '<tbody>'
         + '<tr>'
         + '   <td colspan="2">'
         + '      <div id="sbip_validation_errors" class="ui-state-error ui-corner-all" style="display:none">'
         + '         <ul id="sbip_error_messages"></ul>'
         + '      </div>'
         + '   </td>'
         + '</tr>'
         + '<tr>'
         + '   <td nowrap="nowrap" align="right" style="width:120px;">'
         + '      <label for="sbip_schedule_start_time">* Time</label>'
         + '   </td>'
         + '   <td align="left">'
         + '      <div id="sbip_schedule_start_and_end_times">'
         + '         <input type="text" id="sbip_schedule_start_time" maxlength="8" size="8" autocomplete="OFF">'
         + '         <span>to</span>'
         + '         <input type="text" id="sbip_schedule_end_time" maxlength="8" size="8" autocomplete="OFF">'
         + '         <input type="checkbox" id="sbip_schedule_time_ad" value="ALLDAY">'
         + '         <label for="sbip_schedule_time_ad">All Day</label>'
         + '      </div>'
         + '   </td>'
         + '</tr>'
         + '<tr>'
         + '   <td nowrap="nowrap" align="right">'
         + '      <label tabindex="999" for="sbip_schedule_frequency">* Frequency</label>'
         + '   </td>'
         + '   <td align="left">'
         + '      <select id="sbip_schedule_frequency" size="1">'
         + '         <option value="ONCE">Just Once</option>'
         + '         <option value="DAILY">Daily</option>'
         + '         <option value="WEEKLY">Weekly</option>'
         + '         <option value="MONTHLY">Monthly</option>'
         + '         <option value="YEARLY">Yearly</option>'
         + '      </select>'
         + '   </td>'
         + '</tr>'
         + '<tr id="sbip_schedule_interval_row">'
         + '   <td nowrap="nowrap" align="right">'
         + '      <label tabindex="999" for="sbip_schedule_interval">* Recurs every</label>'
         + '   </td>'
         + '   <td align="left">'
         + '      <select id="sbip_schedule_interval" size="1">'
         + '         <option value="1">1</option>'
         + '         <option value="2">2</option>'
         + '         <option value="3">3</option>'
         + '         <option value="4">4</option>'
         + '         <option value="5">5</option>'
         + '         <option value="6">6</option>'
         + '         <option value="7">7</option>'
         + '         <option value="8">8</option>'
         + '         <option value="9">9</option>'
         + '         <option value="10">10</option>'
         + '         <option value="11">11</option>'
         + '         <option value="12">12</option>'
         + '         <option value="13">13</option>'
         + '         <option value="14">14</option>'
         + '         <option value="15">15</option>'
         + '         <option value="16">16</option>'
         + '         <option value="17">17</option>'
         + '         <option value="18">18</option>'
         + '         <option value="19">19</option>'
         + '         <option value="20">20</option>'
         + '         <option value="21">21</option>'
         + '         <option value="22">22</option>'
         + '         <option value="23">23</option>'
         + '         <option value="24">24</option>'
         + '         <option value="25">25</option>'
         + '         <option value="26">26</option>'
         + '         <option value="27">27</option>'
         + '         <option value="28">28</option>'
         + '         <option value="29">29</option>'
         + '         <option value="30">30</option>'
         + '      </select>'
         + '      <span id="sbip_schedule_interval_post_text"> week(s)</span>'
         + '   </td>'
         + '</tr>'
         + '<tr id="sbip_schedule_days_row"">'
         + '   <td nowrap="nowrap" align="right">'
         + '      <label tabindex="999" for="sbip_schedule_byday_w">* Day(s)</label>'
         + '   </td>'
         + '   <td align="left">'
         + '      <fieldset class="checkbox_group" id="sbip_schedule_byday_w">'
         + '         <table>'
         + '         <tbody>'
         + '         <tr>'
         + '            <td>'
         + '               <input type="checkbox" id="sbip_schedule_byday_w_0" value="SUN">'
         + '               <label for="sbip_schedule_byday_w_0">Sun</label>'
         + '            </td>'
         + '            <td>'
         + '               <input type="checkbox" id="sbip_schedule_byday_w_1" value="MON">'
         + '               <label for="sbip_schedule_byday_w_1">Mon</label>'
         + '            </td>'
         + '            <td>'
         + '               <input type="checkbox" id="sbip_schedule_byday_w_2" value="TUE">'
         + '               <label for="sbip_schedule_byday_w_2">Tue</label>'
         + '            </td>'
         + '            <td>'
         + '               <input type="checkbox" id="sbip_schedule_byday_w_3" value="WED">'
         + '               <label for="sbip_schedule_byday_w_3">Wed</label>'
         + '            </td>'
         + '         </tr>'
         + '         <tr>'
         + '            <td>'
         + '               <input type="checkbox" id="sbip_schedule_byday_w_4" value="THU">'
         + '               <label for="sbip_schedule_byday_w_4">Thu</label>'
         + '            </td>'
         + '            <td>'
         + '               <input type="checkbox" id="sbip_schedule_byday_w_5" value="FRI">'
         + '               <label for="sbip_schedule_byday_w_5">Fri</label>'
         + '            </td>'
         + '            <td>'
         + '               <input type="checkbox" id="sbip_schedule_byday_w_6" value="SAT">'
         + '               <label for="sbip_schedule_byday_w_6">Sat</label>'
         + '            </td>'
         + '         </tr>'
         + '         </tbody>'
         + '         </table>'
         + '      </fieldset>'
         + '   </td>'
         + '</tr>'
         + '<tr id="sbip_schedule_monthly_type_row">'
         + '   <td nowrap="nowrap" align="right">'
         + '      <label tabindex="999" for="sbip_monthly_by">* By</label>'
         + '   </td>'
         + '   <td align="left">'
         + '      <fieldset class="checkbox_group" id="sbip_monthly_by">'
         + '         <table>'
         + '         <tbody>'
         + '         <tr>'
         + '            <td>'
         + '               <input name="monthly_type" id="sbip_schedule_monthly_type_dom" type="radio" value="BYMONTHDAY">'
         + '               <label for="sbip_schedule_monthly_type_dom">Day of the month</label>'
         + '            </td>'
         + '         </tr>'
         + '         <tr id="sbip_schedule_monthly_type_ldom_row">'
         + '            <td>'
         + '               <input name="monthly_type" id="sbip_schedule_monthly_type_ldom" type="radio" value="BYMONTHDAY">'
         + '               <label for="sbip_schedule_monthly_type_ldom">Last day of the month</label>'
         + '            </td>'
         + '         </tr>'
         + '         <tr>'
         + '            <td>'
         + '               <input name="monthly_type" id="sbip_schedule_monthly_type_dow" type="radio" value="BYDAY">'
         + '               <label for="sbip_schedule_monthly_type_dow">Day of the week</label>'
         + '            </td>'
         + '         </tr>'
         + '         </tbody>'
         + '         </table>'
         + '      </fieldset>'
         + '   </td>'
         + '</tr>'
         + '<tr>'
         + '   <td align="right">'
         + '      <label tabindex="999" for="sbip_schedule_start_date">* Start Date</label>'
         + '   </td>'
         + '   <td align="left">'
         + '      <input type="text" id="sbip_schedule_start_date" size="15">'
         + '   </td>'
         + '</tr>'
         + '<tr id="sbip_schedule_end_date_row">'
         + '   <td nowrap="nowrap" align="right">'
         + '      <label tabindex="999" for="sbip_schedule_end_date">End Date</label>'
         + '   </td>'
         + '   <td align="left">'
         + '      <input type="text" id="sbip_schedule_end_date" size="15">'
         + '   </td>'
         + '</tr>'
         + '</tbody>'
         + '</table></div>';
         
      $('body').append(
         dialogHtml
      );
      
      uiw._parseItemValues();
      uiw._initElements();
      
      if (uiw.values.durationSeconds == 86400) {
         uiw.elements.$allDay.attr('checked', 'checked');
         $('div#sbip_schedule_start_and_end_times > *:not(input#sbip_schedule_time_ad,label)').hide();
      } else {
         uiw.elements.$startTime.val(uiw.values.startTimeFmt);
         uiw.elements.$endTime.val(uiw.values.endTimeFmt);
      }
          
      uiw.elements.$allDay.click(function() {
         $allDay = $(this);
         
         if ($allDay.attr('checked') === true) {
            $('div#sbip_schedule_start_and_end_times > *:not(input#sbip_schedule_time_ad,label)').hide();
         } else {
            $('div#sbip_schedule_start_and_end_times > *:not(input#sbip_schedule_time_ad,label)').show();
         }
         
         uiw._showDurationWarning();
      });
      
      uiw.elements.$frequency
         .val(uiw.values.calendarString.freq)
         .bind('change', function() {
            uiw._resetEditView();
         });
         
      uiw.elements.$interval.val(uiw.values.calendarString.interval);
      
      if (uiw.values.calendarString.freq == 'WEEKLY') {
         var days = uiw.values.calendarString.byday.split(',');
         
         $.each(days, function(i, val){
            $(':input[id^="sbip_schedule_byday_w"][value="' + val + '"]').attr('checked','checked');
         });
      } else if (uiw.values.calendarString.freq == 'MONTHLY') {         
         if (uiw.values.calendarString.bymonthday) {
            if (parseInt(uiw.values.calendarString.bymonthday) == -1) {
               $('#sbip_schedule_monthly_type_ldom').attr('checked','checked');
            } else {
               $('#sbip_schedule_monthly_type_dom').attr('checked','checked');
            }
         } else if (uiw.values.calendarString.byday) {
            $('#sbip_schedule_monthly_type_dow').attr('checked','checked');
         }
      }
         
      uiw.elements.$startDate
         .val(uiw.values.startDateFmt)
         .change(function() {
            uiw._resetEditView();
         });
      
      if (uiw.values.endDate) {
         uiw.elements.$endDate.val(uiw.values.endDateFmt);
      }
      
      uiw._resetEditView();
      
      $('input#sbip_schedule_start_date, input#sbip_schedule_end_date').datepicker({
         dateFormat: uiw.options.dateFormat
      });
      
      uiw.elements.$dialog.dialog({
         resizable: false,
         modal: true,
         width: 450,
			buttons: {
				'Ok': function() {
               uiw._validateInputs();
               
               if ($('ul#sbip_error_messages li').length) {
                  uiw.elements.$validationErrors
                     .show()
                     .effect('pulsate', {times: 3}, 'slow');
               } else {
                  uiw._updateApexItem();
                  uiw._parseItemValues();
                  uiw.resetDisplayView();
                  $(this).dialog('close');
               }
				},
				Cancel: function() {
					$(this).dialog('close');
				}
			},
         close: function() {
            uiw.elements.$startDate.datepicker('destroy');
            uiw.elements.$endDate.datepicker('destroy');
            uiw._closeTimePicker();
            $(this).dialog('destroy');
            uiw.elements.$dialog.remove();
         }
      });
      
      $('input#sbip_schedule_start_time,input#sbip_schedule_end_time')
         .trigger('blur') //dialog likes to set focus
         .focus(function() {
            $(this).trigger('click'); 
            return false;
         })
         .click(function() {
            uiw.elements.$focusedTime = $(this);
            uiw.elements.$focusedTime.attr('data-org-time', uiw.elements.$focusedTime.val());
            uiw._showTimePicker();
         })
         .blur(function() {//Remove spacess and add leading "0" if omitted
            var $time = $(this);
            var timeStr = $time.val();
            var newTimeStr;
            
            timeStr = timeStr.replace(/\s/g, '');
            $time.val(timeStr);
            
            try {
               if (
                  timeStr.substr(0,1) != 0
                  && parseInt(timeStr.substr(0,2), 10) >= 0 
                  && parseInt(timeStr.substr(0,2), 10) < 10 
               ) {
                  newTimeStr = '0' + timeStr;
                  
                  if (uiw._isValidTime(newTimeStr, uiw.values.use24hTime)) {
                     $time.val(newTimeStr);
                  }
               }
            } catch (error) {
               null;
            }            
         });
         
      uiw.elements.$startTime.change(function() {
         uiw._shiftEndTime();
         uiw._showDurationWarning();
      });
      
      uiw.elements.$endTime.change(function() {
         uiw._showDurationWarning();
      });
      
      $('#ui-datepicker-div').css('z-index',1100);
   },
   _showTimePicker: function() {
      var uiw = this;
      var $selectedTime;
      var timeHeight;
      var timeIndex;
      var scrollTop;
      
      if ($('div#sbip_time_picker').length == 0) {
         $('body').append('<div id="sbip_time_picker" data-for="' + 
            uiw.elements.$focusedTime.attr('id') + 
            '" class="ui-widget" style="visibility:hidden"></div>');
         
         uiw.elements.$timePicker = $('div#sbip_time_picker');
         
         uiw._loadTpTimes();
         
         $('div#sbip_time_picker div.time')
            .button()
            .mouseout(function() {
               if (!$('div#sbip_time_picker div.active').hasClass('ui-state-active')) {
                  $('div#sbip_time_picker div.active').addClass('ui-state-active')
               }
            });
         
         uiw._setTpActiveTime();
         
         $selectedTime = $('div#sbip_time_picker div.active');
         timeHeight = $selectedTime.outerHeight(true);
         
         uiw.elements.$timePicker
            .css({
               'top': uiw.elements.$focusedTime.offset().top + uiw.elements.$focusedTime.outerHeight(),
               'left': uiw.elements.$focusedTime.offset().left,
               'height': timeHeight * 7 + 'px',
               'visibility': 'visible'
            });
            
         uiw._focusTpActiveTime('center');
         
         $('body').bind('mousedown', {uiw: uiw}, uiw._handleTpMousedown);
         $('body').bind('mouseup', {uiw: uiw}, uiw._handleTpMouseup);
         $('body').bind('keydown', {uiw: uiw}, uiw._handleTpKeydown);
      }
   },
   _loadTpTimes: function() {
      var uiw = this;
      var date;
      var hour;
      var min;
      var ampm;
      
      if (uiw.elements.$focusedTime.val() 
         && uiw._isValidTime(uiw.elements.$focusedTime.val(), uiw.values.use24hTime)
      ) {
         date = new Date(2000, 1, 1, 0, uiw.elements.$focusedTime.val().substring(3, 5), 0, 0);
      } else if (uiw.elements.$focusedTime.attr('id') == 'sbip_schedule_end_time' 
         && uiw.elements.$startTime.val() 
         && uiw._isValidTime(uiw.elements.$startTime.val(), uiw.values.use24hTime)
      ) {
         date = new Date(2000, 1, 1, 0, uiw.elements.$startTime.val().substring(3, 5), 0, 0);
      } else {
         date = new Date(2000, 1, 1, 0, 0, 0, 0);
      }

      if (date.getMinutes() >= 30) {
         date.setMinutes(date.getMinutes() - 30);
      }
      
      for (x=0; x<=47; x++) {
         hour = date.getHours();
         ampm = hour <= 11 ? uiw.options.am : uiw.options.pm;
         hour = hour <= 11 ? hour : hour - 12;
         hour = hour == 0 ? 12 : hour;
         hour = hour.toString().length == 2 ? hour.toString() : '0' + hour.toString();
         min = date.getMinutes().toString().length == 2 ? date.getMinutes().toString() : '0' + date.getMinutes().toString();
         
         uiw.elements.$timePicker.append('<div class="time">' + hour + ':' + min + ampm + '</div>');
         
         date.setMinutes(date.getMinutes() + 30);
      }
   },
   _setTpActiveTime: function() {
      var uiw = this;
      var timeString;
      
      if (uiw.elements.$focusedTime.val() 
         && uiw._isValidTime(uiw.elements.$focusedTime.val(), uiw.values.use24hTime)) {//Focus the time in the input
         timeString = uiw.elements.$focusedTime.val();
      } else if (uiw.elements.$focusedTime.attr('id') == 'sbip_schedule_end_time'
         && uiw.elements.$startTime.val() 
         && uiw._isValidTime(uiw.elements.$startTime.val(), uiw.values.use24hTime)
      ) {//Focus the time from the start input + one hour
         var time24 = uiw._getTime12to24(uiw.elements.$startTime.val());
         var startHour = time24.substring(0, 2);
         var startMin = time24.substring(3, 5);
         var currDate = new Date(2000, 1, 1, startHour, startMin, 0, 0);
         startMin = startMin.toString().length == 2 ? startMin : "0" + startMin;
         currDate.setHours(currDate.getHours() + 1);
         var currOrNextHour = currDate.getHours();
         var nextAmPm = currOrNextHour <= 11 ? uiw.options.am : uiw.options.pm;
         currOrNextHour = currOrNextHour <= 11 ? currOrNextHour : currOrNextHour - 12;
         currOrNextHour = currOrNextHour == 0 ? 12 : currOrNextHour;
         currOrNextHour = currOrNextHour.toString().length == 2 ? currOrNextHour : "0" + currOrNextHour;
         timeString = currOrNextHour + ':' + startMin + nextAmPm;
      } else {//Focus the current full or half hour; add an hour for the end time
         var currDate = new Date();
         var currMin = currDate.getMinutes();
         var currOrNextHour = (currMin > 30) ? (currDate.getHours() == 23) ? 0 : currDate.getHours() + 1 : currDate.getHours();
         var nextAmPm = currOrNextHour <= 11 ? uiw.options.am : uiw.options.pm;
         currOrNextHour = (currOrNextHour <= 11) ? currOrNextHour : currOrNextHour - 12;
         currOrNextHour = (currOrNextHour == 0) ? 12 : currOrNextHour;
         currOrNextHour = (uiw.elements.$focusedTime.attr('id') == 'sbip_schedule_end_time') ? (currOrNextHour == 12) ? 1 : currOrNextHour + 1 : currOrNextHour;
         currOrNextHour = currOrNextHour.toString().length == 2 ? currOrNextHour.toString() : '0' + currOrNextHour.toString();
         var nextMin = (currMin > 30) ? '00' : '30';
         timeString = currOrNextHour + ':' + nextMin + nextAmPm;
      } 
      
      $('div#sbip_time_picker div.time:contains("' + timeString + '")').addClass('active ui-state-active');
   },
   _focusTpActiveTime: function(location) {
      var uiw = this;
      var $actTime = $('div#sbip_time_picker div.active');
      var actTimeIndex = $('div#sbip_time_picker div.time').index($actTime);
      var actTimeHeight = $actTime.outerHeight(true);
      var scrollTop;
      
      if (location == 'center') {
         if (actTimeIndex <= 2) {
            scrollTop = 0;
         } else {
            scrollTop = (actTimeIndex - 3) * actTimeHeight;
         }
      } else if (location == 'bottom') {
         if (actTimeIndex == 0) {
            uiw._focusTpActiveTime('top');
         } else {
            var timePickerBottom = uiw.elements.$timePicker.offset().top + uiw.elements.$timePicker.height();
            var actTimeBottom = $actTime.offset().top + actTimeHeight
            
            if (timePickerBottom - actTimeBottom < 0) {
               uiw.elements.$timePicker.scrollTop((actTimeIndex - 6) * actTimeHeight)
            }
         }
      } else if (location == 'top') {
         if (actTimeIndex == 47) {
            uiw._focusTpActiveTime('bottom');
         } else {
            var timePickerTop = uiw.elements.$timePicker.offset().top;
            var actTimeTop = $actTime.offset().top;
            
            if (timePickerTop - actTimeTop > 0) {
               uiw.elements.$timePicker.scrollTop((actTimeIndex) * actTimeHeight)
            }
         }
      }
      
      uiw.elements.$timePicker.scrollTop(scrollTop);
   },
   _handleTpMousedown: function(eventObj) {
      var uiw = eventObj.data.uiw;
      var $target = $(eventObj.target);
      
      if ($target.parents('div#sbip_time_picker').length
         || $target.attr('id') == 'sbip_time_picker') {
         return true;
      } else if ($target.attr('id') == uiw.elements.$focusedTime.attr('id')) {
         $target.focus();
         return true;
      } else {
         uiw._closeTimePicker();
         uiw.elements.$focusedTime.blur();
         return true;
      }
   },
   _handleTpMouseup: function(eventObj) {
      var uiw = eventObj.data.uiw;
      var $target = $(eventObj.target);
      
      if ($target.parents('div#sbip_time_picker').length) {
         uiw.elements.$focusedTime.val($target.text());
         uiw._closeTimePicker();
         uiw.elements.$focusedTime.trigger('change');
         return true;
      } else {
         return true;
      }
   },
   _handleTpKeydown: function(eventObj) {
      var uiw = eventObj.data.uiw;
      var $actTime = $('div#sbip_time_picker div.active');
      
      if (eventObj.which == 40) {
         var $nextActTime = ($actTime.next('div').length > 0) ? $actTime.next('div') : $('div#sbip_time_picker div:first');

         $actTime.removeClass('active ui-state-active');
         $nextActTime.addClass('active ui-state-active');
         
         uiw._focusTpActiveTime('bottom');
      } else if (eventObj.which == 38) {
         var $prevActTime = ($actTime.prev('div').length > 0) ? $actTime.prev('div') : $('div#sbip_time_picker div:last');

         $actTime.removeClass('active ui-state-active');
         $prevActTime.addClass('active ui-state-active');
         
         uiw._focusTpActiveTime('top');
      } else if (eventObj.which == 13) {
         uiw.elements.$focusedTime.val($actTime.val());
         uiw._closeTimePicker();
      } else {
         uiw._closeTimePicker();
      }
   },
   _closeTimePicker: function() {
      var uiw = this;
      
      if (uiw.elements.$timePicker.length) {
         uiw.elements.$timePicker.remove();
      }
      
      $('body').unbind('mousedown', uiw._handleTpMousedown);
      $('body').unbind('mouseup', uiw._handleTpMouseup);
      $('body').unbind('keydown', uiw._handleTpKeydown);
   },
   _updateApexItem: function() {
      var uiw = this;
      var frequency = uiw.elements.$frequency.val();
      var interval = uiw.elements.$interval.val();
      var startTime = '';
      var startHour = '';
      var startMin = '';
      var startDate;
      var startDate2;
      var startDateString;
      var endTime = '';
      var endHour = '';
      var endMin = '';
      var endDate;
      var endDateString;
      var allDay;
      var durationString;
      var calendarString;
      
      allDay = uiw.elements.$allDay.attr('checked');
      
      startDate = $.datepicker.parseDate(uiw.options.dateFormat, uiw.elements.$startDate.val());
      
      if (frequency == 'ONCE' || !uiw.elements.$endDate.val()) {
         endDate = $.datepicker.parseDate(uiw.options.dateFormat, uiw.elements.$startDate.val());
      } else {
         endDate = $.datepicker.parseDate(uiw.options.dateFormat, uiw.elements.$endDate.val());
      }
      
      if (allDay) {
         startHour = '00';
         startMin = '00';
         endHour = '00';
         endMin = '00';
         startDate.setHours(startHour, startMin, 0, 0); 
      } else {
         startTime = uiw._getTime12to24(uiw.elements.$startTime.val());
         startHour = startTime.substring(0,2);
         startMin = startTime.substring(3,5);
         startDate.setHours(startHour, startMin, 0, 0); 
      
         endTime = uiw._getTime12to24(uiw.elements.$endTime.val());
         endHour = endTime.substring(0,2);
         endMin = endTime.substring(3,5);
         endDate.setHours(endHour, endMin, 0, 0);
      }
      
      startDateString = $.datepicker.formatDate('yymmdd', startDate) + startHour + startMin;
      endDateString = (frequency == 'ONCE' || !uiw.elements.$endDate.val()) ? '' : $.datepicker.formatDate('yymmdd', endDate) + endHour + endMin;
      
      durationString = uiw._getDuration('seconds');
      
      if (frequency == 'ONCE') {
         calendarString = '';
      } else if (frequency == 'DAILY') {
         calendarString = 'FREQ=DAILY;INTERVAL=' + interval + ';';
      } else if (frequency == 'WEEKLY') {         
         calendarString = 'FREQ=WEEKLY;INTERVAL=' + interval + ';BYDAY=';
         
         $(':input[id^="sbip_schedule_byday_w"]:checked').each(function(i) {
            calendarString += this.value + ',';
         });
         
         calendarString = calendarString.replace(/,$/,';');
      } else if (frequency == 'MONTHLY') {
         var monthlyType = $(':radio[name="monthly_type"]:checked').val();
         
         calendarString = 'FREQ=MONTHLY;INTERVAL=' + interval + ';' + monthlyType + '=';
         
         if (monthlyType == 'BYMONTHDAY') {
            if ($('#sbip_schedule_monthly_type_dom').attr('checked') == true) {
               calendarString += $.datepicker.formatDate('d', startDate) + ';';
            } else { //must be last day of month
               calendarString += '-1;';
            }
         } else if (monthlyType = 'BYDAY') {
            var date;
            var dayOfWeek = $.datepicker.formatDate('D', startDate).toUpperCase();
            var dayOfWeekNum = 0;
            var ordinal;
            
            for (x=1; x<=31; x++) {               
               try {
                  date = $.datepicker.parseDate('yymmd', $.datepicker.formatDate('yymm', startDate) + x);
                  if (date > startDate) {break;}//Exit loop ASAP
                  if (dayOfWeek == $.datepicker.formatDate('D', date).toUpperCase()) {
                     dayOfWeekNum += 1;
                  }
               }
               catch (errorObj) {
                  null;
               }
               
            }
            
            ordinal = (dayOfWeekNum == 5) ? '-1' : dayOfWeekNum;

            calendarString += ordinal + dayOfWeek + ';';
         }
      } else if (frequency == 'YEARLY') {         
         calendarString = 'FREQ=YEARLY;INTERVAL=' + interval + ';';
         calendarString += 'BYMONTH=' + $.datepicker.formatDate('m', startDate) + ';';
         calendarString += 'BYMONTHDAY=' + $.datepicker.formatDate('d', startDate) + ';';
      }
      
      $('#' + this.options.scheduleItem).val(
         startDateString + '|' + endDateString + '|' + durationString + '|' + calendarString
      );
      
      return true;
   },
   _resetEditView: function() {
      var uiw = this;
      var frequency = uiw.elements.$frequency.val();
      var $daysRow = $('#sbip_schedule_days_row');
      var $endDateRow = $('#sbip_schedule_end_date_row');
      var $intervalRow = $('#sbip_schedule_interval_row');
      var $monthTypeRow = $('#sbip_schedule_monthly_type_row');
      
      if (frequency == 'ONCE') {
         $('#sbip_schedule_interval_post_text').html('');
         $daysRow.hide();
         $endDateRow.hide();
         $intervalRow.hide();
         $monthTypeRow.hide();
      } else if (frequency == 'DAILY') {
         $('#sbip_schedule_interval_post_text').html(' day(s)');
         $daysRow.hide();
         $monthTypeRow.hide();
         $intervalRow.show();
         $endDateRow.show();
      } else if (frequency == 'WEEKLY') {
         $('#sbip_schedule_interval_post_text').html(' week(s)');
         $monthTypeRow.hide();
         $intervalRow.show();
         $daysRow.show();
         $endDateRow.show();
      } else if (frequency == 'MONTHLY') {
         var $lastDayOfMonthRow = $('#sbip_schedule_monthly_type_ldom_row');
         var startDate = $.datepicker.parseDate(uiw.options.dateFormat, uiw.elements.$startDate.val());
         $('#sbip_schedule_interval_post_text').html(' month(s)');
         $daysRow.hide();
         $intervalRow.show();
         $monthTypeRow.show();
         $endDateRow.show();
         if (startDate) {
            var nextDateString = $.datepicker.formatDate('yymm', startDate) 
               + (parseInt($.datepicker.formatDate('dd', startDate)) + 1);
            var nextDate;
            
            try {
               var nextDate = $.datepicker.parseDate('yymmdd', nextDateString);
               $lastDayOfMonthRow.hide();
            } catch (errorObj) {
               $lastDayOfMonthRow.show();
            }
         } else {
            $lastDayOfMonthRow.hide();
         }
      } else if (frequency == 'YEARLY') {
         $('#sbip_schedule_interval_post_text').html(' year(s)');
         $daysRow.hide();
         $monthTypeRow.hide();
         $intervalRow.show();
         $endDateRow.show();
      }
   },
   _validateInputs: function() {
      var uiw = this;
      
      uiw.elements.$errorMessages.empty('');
      $('div#sbip_dialog *.ui-state-error:not(div#sbip_validation_errors)').removeClass('ui-state-error');
      
      if (!uiw.elements.$allDay.attr('checked')){
         uiw._validateStartTime();
         uiw._validateEndTime();
      }
      
      uiw._validateStartDate();
      
      if (uiw.elements.$frequency.val() == 'WEEKLY') {
         uiw._validateWeeklyDays();
      } else if (uiw.elements.$frequency.val() == 'MONTHLY') {
         uiw._validateMonthlyBy();
      }
      
      if (uiw.elements.$frequency.val() != 'ONCE' && uiw.elements.$endDate.val()) {
         uiw._validateEndDate();
      }
   },
   _validateStartTime: function(){
      var uiw = this;
      
      if (!uiw.elements.$startTime.val()) {
         uiw.elements.$errorMessages.append('<li>The start time must have some value</li>');
         uiw.elements.$startTime.addClass('ui-state-error');
         return;
      }
      
      if (!uiw._isValidTime(uiw.elements.$startTime.val(), uiw.values.use24hTime)) {
         uiw.elements.$errorMessages.append('<li>The start time is not valid</li>');
         uiw.elements.$startTime.addClass('ui-state-error');
         return;
      }
   },
   _validateEndTime: function(){
      var uiw = this;
      
      if (!uiw.elements.$endTime.val()) {
         uiw.elements.$errorMessages.append('<li>The end time must have some value</li>');
         uiw.elements.$endTime.addClass('ui-state-error');
         return;
      }
      
      if (!uiw._isValidTime(uiw.elements.$endTime.val(), uiw.values.use24hTime)) {
         uiw.elements.$errorMessages.append('<li>The end time is not valid</li>');
         uiw.elements.$endTime.addClass('ui-state-error');
         return;
      }
   },
   _validateStartDate: function(){
      var uiw = this;
      
      if (!uiw.elements.$startDate.val()) {
         uiw.elements.$errorMessages.append('<li>The start date must have some value</li>');
         uiw.elements.$startDate.addClass('ui-state-error');
         return;
      }
      
      if (!uiw._isValidDate(uiw.elements.$startDate.val(), uiw.options.dateFormat)) {
         uiw.elements.$errorMessages.append('<li>The start date is not valid</li>');
         uiw.elements.$startDate.addClass('ui-state-error');
         return;
      }
   },
   _validateWeeklyDays: function(){
      var uiw = this;
      
      if (!$('fieldset#sbip_schedule_byday_w input:checked').length) {
         uiw.elements.$errorMessages.append('<li>At least one day of the week must be selected</li>');
         return;
      }
   },
   _validateMonthlyBy: function() {
      var uiw = this;
      
      if (!$('fieldset#sbip_monthly_by input:checked').length) {
         uiw.elements.$errorMessages.append('<li>The monthly pattern must be selected</li>');
         return;
      }
   },
   _validateEndDate: function(){
      var uiw = this;
      var startDate;
      var endDate;
      
      if (!uiw._isValidDate(uiw.elements.$endDate.val(), uiw.options.dateFormat)) {
         uiw.elements.$errorMessages.append('<li>The end date is not valid</li>');
         uiw.elements.$endDate.addClass('ui-state-error');
         return;
      }
      
      if (uiw._isValidDate(uiw.elements.$startDate.val(), uiw.options.dateFormat)) {
         startDate = $.datepicker.parseDate(uiw.options.dateFormat, uiw.elements.$startDate.val());
         endDate = $.datepicker.parseDate(uiw.options.dateFormat, uiw.elements.$endDate.val());
         
         if (startDate > endDate) {
            uiw.elements.$errorMessages.append('<li>The end date must be on or after the start date</li>');
            uiw.elements.$endDate.addClass('ui-state-error');
            return;
         }
      }
   }
});

})(apex.jQuery);