set define off
set verify off
set serveroutput on size 1000000
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end; 
/
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040000 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,1489910202875142));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2010.05.13');
 
end;
/

prompt  Set Application ID...
 
begin
 
   -- SET APPLICATION ID
   wwv_flow.g_flow_id := nvl(wwv_flow_application_install.get_application_id,154);
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

prompt  ...plugins
--
--application/shared_components/plugins/item_type/com_skillbuilders_sbip_schedule
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 263801654014856337 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'ITEM TYPE'
 ,p_name => 'COM.SKILLBUILDERS.SBIP.SCHEDULE'
 ,p_display_name => 'SkillBuilders Schedule'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'FUNCTION js_date_format('||chr(10)||
'   p_oracle_date_format IN VARCHAR2'||chr(10)||
')'||chr(10)||
''||chr(10)||
'   RETURN VARCHAR2'||chr(10)||
''||chr(10)||
'IS'||chr(10)||
''||chr(10)||
'   l_retval VARCHAR2(30);'||chr(10)||
''||chr(10)||
'BEGIN'||chr(10)||
''||chr(10)||
'   l_retval := UPPER(p_oracle_date_format);'||chr(10)||
'   l_retval := REPLACE(l_retval, ''YYYY'', ''yy'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''RRRR'', ''yy'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''YY'', ''y'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''RR'', ''y'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''MONTH'', ''MM'');'||
''||chr(10)||
'   l_retval := REPLACE(l_retval, ''MON'', ''M'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''MM'', ''mm'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''DAY'', ''DD'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''DY'', ''D'');'||chr(10)||
'   l_retval := REPLACE(l_retval, ''DD'', ''dd'');'||chr(10)||
'   '||chr(10)||
'   RETURN l_retval;'||chr(10)||
'   '||chr(10)||
'END js_date_format;'||chr(10)||
''||chr(10)||
'FUNCTION render_sbip_schedule ('||chr(10)||
'   p_item                IN APEX_PLUGIN.T_PAGE_ITEM,'||chr(10)||
'   p_plugin              IN APEX_PL'||
'UGIN.T_PLUGIN,'||chr(10)||
'   p_value               IN VARCHAR2,'||chr(10)||
'   p_is_readonly         IN BOOLEAN,'||chr(10)||
'   p_is_printer_friendly IN BOOLEAN '||chr(10)||
')'||chr(10)||
''||chr(10)||
'   RETURN APEX_PLUGIN.T_PAGE_ITEM_RENDER_RESULT'||chr(10)||
'   '||chr(10)||
'IS'||chr(10)||
''||chr(10)||
'   l_retval         APEX_PLUGIN.T_PAGE_ITEM_RENDER_RESULT;'||chr(10)||
'   l_name           VARCHAR2(30);'||chr(10)||
'   l_date_format    VARCHAR2(30) := p_item.attribute_01;'||chr(10)||
'   l_jqueryui_theme VARCHAR2(100) := p_plugin.attribute_02;'||chr(10)||
'   l'||
'_inc_start_time CHAR(1) := p_item.attribute_03;'||chr(10)||
'   l_inc_end_time   CHAR(1) := p_item.attribute_04;'||chr(10)||
'   l_inc_all_day    CHAR(1) := p_item.attribute_05;'||chr(10)||
'   l_inc_single     CHAR(1) := p_item.attribute_06;'||chr(10)||
'   l_inc_daily      CHAR(1) := p_item.attribute_07;'||chr(10)||
'   l_inc_weekly     CHAR(1) := p_item.attribute_08;'||chr(10)||
'   l_inc_monthly    CHAR(1) := p_item.attribute_09;'||chr(10)||
'   l_inc_yearly     CHAR(1) := p_item.at'||
'tribute_10;'||chr(10)||
'   l_onload_code    VARCHAR2(32767);'||chr(10)||
'   l_crlf           CHAR(2) := CHR(13)||CHR(10);'||chr(10)||
'   '||chr(10)||
'BEGIN'||chr(10)||
''||chr(10)||
'   IF apex_application.g_debug '||chr(10)||
'   THEN'||chr(10)||
'      apex_plugin_util.debug_page_item ('||chr(10)||
'         p_plugin              => p_plugin,'||chr(10)||
'         p_page_item           => p_item,'||chr(10)||
'         p_value               => p_value,'||chr(10)||
'         p_is_readonly         => p_is_readonly,'||chr(10)||
'         p_is_printer_friendly ='||
'> p_is_printer_friendly'||chr(10)||
'      );'||chr(10)||
'   END IF;'||chr(10)||
''||chr(10)||
'   l_name := apex_plugin.get_input_name_for_page_item(false);'||chr(10)||
''||chr(10)||
'   sys.htp.p('||chr(10)||
'         ''<input type="hidden" name="'' || l_name || ''" id="'' || p_item.name || ''" '''||chr(10)||
'      || ''value="'' || p_value || ''" '' || p_item.element_attributes || '' />'''||chr(10)||
'      || ''<div id="'' || p_item.name || ''_schedule" class="sbip_schedule"></div>'''||chr(10)||
'   );'||chr(10)||
''||chr(10)||
'   apex_javascript.add_library'||
' ('||chr(10)||
'      p_name      => ''jquery.ui.sbip_schedule'','||chr(10)||
'      p_directory => p_plugin.file_prefix,'||chr(10)||
'      p_version   => NULL'||chr(10)||
'   );'||chr(10)||
''||chr(10)||
'   apex_javascript.add_library ('||chr(10)||
'      p_name      => ''jquery.ui.button.min'','||chr(10)||
'      p_directory => apex_application.g_image_prefix || ''libraries/jquery-ui/1.8/ui/minified/'','||chr(10)||
'      p_version   => NULL'||chr(10)||
'   );'||chr(10)||
''||chr(10)||
'   apex_javascript.add_library ('||chr(10)||
'      p_name      => ''jquery.effe'||
'cts.pulsate.min'','||chr(10)||
'      p_directory => apex_application.g_image_prefix || ''libraries/jquery-ui/1.8/ui/minified/'','||chr(10)||
'      p_version   => NULL'||chr(10)||
'   );'||chr(10)||
'   '||chr(10)||
'   apex_css.add_file ('||chr(10)||
'      p_name      => ''jquery.ui.sbip_schedule'','||chr(10)||
'      p_directory => p_plugin.file_prefix,'||chr(10)||
'      p_version   => NULL'||chr(10)||
'   );'||chr(10)||
'   '||chr(10)||
'   apex_css.add_file ('||chr(10)||
'      p_name      => ''jquery-ui'','||chr(10)||
'      p_directory => apex_application.g_ima'||
'ge_prefix || ''libraries/jquery-ui/1.8/themes/'' || l_jqueryui_theme || ''/'','||chr(10)||
'      p_version   => NULL'||chr(10)||
'   );'||chr(10)||
'   '||chr(10)||
'   l_date_format := js_date_format(l_date_format);'||chr(10)||
''||chr(10)||
'   l_onload_code := ''apex.jQuery("div#'' || p_item.name || ''_schedule")'''||chr(10)||
'      || ''.sbip_schedule({'' || l_crlf'||chr(10)||
'      || ''   scheduleItem:"'' ||  p_item.name || ''",'' || l_crlf'||chr(10)||
'      || ''   incStartTime:"'' || l_inc_start_time || ''",'' || l_cr'||
'lf'||chr(10)||
'      || ''   incEndTime:"'' || l_inc_end_time || ''",'' || l_crlf'||chr(10)||
'      || ''   incAllDay:"'' || l_inc_all_day || ''",'' || l_crlf'||chr(10)||
'      || ''   dateFormat:"'' || l_date_format || ''",'' || l_crlf'||chr(10)||
'      || ''   incSingle:"'' || l_inc_single || ''",'' || l_crlf'||chr(10)||
'      || ''   incDaily:"'' || l_inc_daily || ''",'' || l_crlf'||chr(10)||
'      || ''   incWeekly:"'' || l_inc_weekly || ''",'' || l_crlf'||chr(10)||
'      || ''   incMonthly:"'' || l_i'||
'nc_monthly || ''",'' || l_crlf'||chr(10)||
'      || ''   incYearly:"'' || l_inc_yearly || ''"'' || l_crlf'||chr(10)||
'      || ''});'';'||chr(10)||
'      '||chr(10)||
'   apex_javascript.add_onload_code ('||chr(10)||
'      p_code => l_onload_code'||chr(10)||
'   );'||chr(10)||
''||chr(10)||
'   l_retval.is_navigable := true;'||chr(10)||
'        '||chr(10)||
'   RETURN l_retval;'||chr(10)||
'    '||chr(10)||
'END render_sbip_schedule;'||chr(10)||
''||chr(10)||
'FUNCTION is_valid_date('||chr(10)||
'   p_date_string IN VARCHAR2'||chr(10)||
')'||chr(10)||
''||chr(10)||
'   RETURN BOOLEAN'||chr(10)||
''||chr(10)||
'IS'||chr(10)||
''||chr(10)||
'   l_test_date DATE;'||chr(10)||
'   '||chr(10)||
'BEGIN'||chr(10)||
''||chr(10)||
'   l_test'||
'_date := TO_DATE(p_date_string, ''YYYYMMDDHHMIPM'');'||chr(10)||
''||chr(10)||
'   RETURN TRUE;'||chr(10)||
''||chr(10)||
'EXCEPTION'||chr(10)||
''||chr(10)||
'   WHEN OTHERS'||chr(10)||
'   THEN'||chr(10)||
'      RETURN FALSE;'||chr(10)||
'   '||chr(10)||
'END is_valid_date;'||chr(10)||
''||chr(10)||
'FUNCTION validate_sbip_schedule('||chr(10)||
'   p_item   IN APEX_PLUGIN.T_PAGE_ITEM,'||chr(10)||
'   p_plugin IN APEX_PLUGIN.T_PLUGIN,'||chr(10)||
'   p_value  IN VARCHAR2'||chr(10)||
')'||chr(10)||
''||chr(10)||
'   RETURN APEX_PLUGIN.T_PAGE_ITEM_VALIDATION_RESULT'||chr(10)||
''||chr(10)||
'IS'||chr(10)||
''||chr(10)||
'   l_schedule_values  APEX_APPLICATION_GLOBAL.VC_ARR2;'||chr(10)||
'   l'||
'_start_date_value VARCHAR2(20);'||chr(10)||
'   l_end_date_value   VARCHAR2(20);'||chr(10)||
'   l_duration_value   VARCHAR2(10);'||chr(10)||
'   l_calendar_value   VARCHAR2(500);   '||chr(10)||
'   l_retval           APEX_PLUGIN.T_PAGE_ITEM_VALIDATION_RESULT;'||chr(10)||
''||chr(10)||
'BEGIN'||chr(10)||
''||chr(10)||
'   l_schedule_values := apex_util.string_to_table(p_value, ''|'');'||chr(10)||
'   '||chr(10)||
'   IF l_schedule_values.exists(1)'||chr(10)||
'   THEN'||chr(10)||
'      l_start_date_value := l_schedule_values(1);'||chr(10)||
''||chr(10)||
'      IF NOT is_valid'||
'_date(l_start_date_value)'||chr(10)||
'      THEN'||chr(10)||
'         l_retval.message := ''Schedule start date is not valid'';'||chr(10)||
'         RETURN l_retval;'||chr(10)||
'      END IF;'||chr(10)||
'   ELSE'||chr(10)||
'      l_retval.message := ''Schedule start date must have a value'';'||chr(10)||
'      RETURN l_retval;'||chr(10)||
'   END IF;'||chr(10)||
''||chr(10)||
'   RETURN l_retval;'||chr(10)||
'   '||chr(10)||
'END validate_sbip_schedule;'
 ,p_render_function => 'render_sbip_schedule'
 ,p_standard_attributes => 'VISIBLE:SESSION_STATE:WIDTH:HEIGHT'
 ,p_attribute_02 => 'base'
 ,p_help_text => '<br />'||chr(10)||
''
 ,p_version_identifier => '1.0.1'
 ,p_about_url => 'www.skillbuilders.com/apex'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 1692219356848008 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 263801654014856337 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'APPLICATION'
 ,p_attribute_sequence => 2
 ,p_display_sequence => 5
 ,p_prompt => 'jQuery UI Theme'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => 'start'
 ,p_display_length => 20
 ,p_max_length => 20
 ,p_is_translatable => false
 ,p_help_text => 'jQuery UI has a number of themes; there a lot like those used in APEX. Learn more at ''http://jqueryui.com/themeroller/'' (click "Gallery" to view the themes). '||chr(10)||
''||chr(10)||
'Possible values:'||chr(10)||
'1. base'||chr(10)||
'2. black-tie'||chr(10)||
'3. blitzer'||chr(10)||
'4. cupertino'||chr(10)||
'5. dark-hive'||chr(10)||
'6. dot-luv'||chr(10)||
'7. eggplant'||chr(10)||
'8. excite-bike'||chr(10)||
'9. flick'||chr(10)||
'10. hot-sneaks'||chr(10)||
'11. humanity'||chr(10)||
'12. le-frog'||chr(10)||
'13. mint-choc'||chr(10)||
'14. overcast'||chr(10)||
'15. pepper-grinder'||chr(10)||
'16. smoothness'||chr(10)||
'17. south-street'||chr(10)||
'18. start'||chr(10)||
'19. sunny'||chr(10)||
'20. swanky-purse'||chr(10)||
'21. trontastic'||chr(10)||
'22. ui-darkness'||chr(10)||
'23. ui-lightness'||chr(10)||
'24. vader'
  );
wwv_flow_api.create_plugin_attribute (
  p_id => 263857255362904031 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 263801654014856337 + wwv_flow_api.g_id_offset
 ,p_attribute_scope => 'COMPONENT'
 ,p_attribute_sequence => 1
 ,p_display_sequence => 10
 ,p_prompt => 'Date Format'
 ,p_attribute_type => 'TEXT'
 ,p_is_required => true
 ,p_default_value => 'mm/dd/yy'
 ,p_sql_min_column_count => 2
 ,p_sql_max_column_count => 2
 ,p_is_translatable => false
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '7461626C6523736269705F656469745F7461626C657B77696474683A313030253B7D0D0A6469762E736269705F7363686564756C65203E207461626C652074687B746578742D616C69676E3A72696768743B7D0D0A64697623736269705F74696D655F70';
wwv_flow_api.g_varchar2_table(2) := '69636B65727B6F766572666C6F773A206175746F3B77696474683A31303070783B7A2D696E6465783A20313130303B706F736974696F6E3A6162736F6C7574653B6261636B67726F756E643A6E6F6E6520726570656174207363726F6C6C203020302077';
wwv_flow_api.g_varchar2_table(3) := '686974653B626F726465723A31707820736F6C696420677265793B746578742D616C69676E3A63656E7465727D0D0A64697623736269705F74696D655F7069636B6572206469762E74696D657B746578742D616C69676E3A63656E7465723B7769647468';
wwv_flow_api.g_varchar2_table(4) := '3A3930253B6865696768743A323670787D0D0A64697623736269705F7363686564756C655F73746172745F616E645F656E645F74696D65737B646973706C61793A696E6C696E653B77696474683A6175746F3B7D';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3089121061892139 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 263801654014856337 + wwv_flow_api.g_id_offset
 ,p_file_name => 'jquery.ui.sbip_schedule.css'
 ,p_mime_type => 'text/css'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2866756E6374696F6E2824297B0D0A0D0A242E776964676574282275692E736269705F7363686564756C65222C207B200D0A2020206F7074696F6E733A207B0D0A20202020207363686564756C654974656D3A2027272C0D0A202020202064617465466F';
wwv_flow_api.g_varchar2_table(2) := '726D61743A20276D6D2F64642F7979272C0D0A202020202075736532346854696D653A20274E272C0D0A2020202020696E63537461727454696D653A202759272C0D0A2020202020696E63456E6454696D653A202759272C0D0A2020202020696E63416C';
wwv_flow_api.g_varchar2_table(3) := '6C4461793A202759272C0D0A2020202020696E6353696E676C653A202759272C0D0A2020202020696E634461696C793A202759272C0D0A2020202020696E635765656B6C793A202759272C0D0A2020202020696E634D6F6E7468793A202759272C0D0A20';
wwv_flow_api.g_varchar2_table(4) := '20202020696E63596561726C793A202759272C0D0A2020202020616D3A2027616D272C0D0A2020202020706D3A2027706D270D0A2020207D2C0D0A20202076616C7565733A207B0D0A202020202020617376313A2027272C0D0A20202020202061737632';
wwv_flow_api.g_varchar2_table(5) := '3A2027272C0D0A202020202020617376333A2027272C0D0A202020202020617376343A2027272C0D0A20202020202075736532346854696D653A2027272C0D0A2020202020207374617274446174653A2027272C0D0A2020202020207374617274446174';
wwv_flow_api.g_varchar2_table(6) := '65466D743A2027272C0D0A2020202020207374617274486F75723A2027272C0D0A20202020202073746172744D696E3A2027272C0D0A202020202020737461727454696D65466D743A2027272C0D0A202020202020656E64446174653A2027272C0D0A20';
wwv_flow_api.g_varchar2_table(7) := '2020202020656E6444617465466D743A2027272C0D0A202020202020656E64486F75723A2027272C0D0A202020202020656E644D696E3A2027272C0D0A202020202020656E6454696D65466D743A2027272C0D0A2020202020206475726174696F6E5365';
wwv_flow_api.g_varchar2_table(8) := '636F6E64733A2027272C202F2F38363430303A20616C6C4461794F6E203D20747275650D0A20202020202063616C656E646172537472696E673A207B0D0A202020202020202020667265713A2027272C0D0A202020202020202020696E74657276616C3A';
wwv_flow_api.g_varchar2_table(9) := '2027272C0D0A20202020202020202062796461793A2027272C0D0A20202020202020202062796D6F6E74683A2027272C0D0A20202020202020202062796D6F6E74686461793A2027270D0A2020202020207D2C0D0A20202020202070617273654572726F';
wwv_flow_api.g_varchar2_table(10) := '723A2066616C73650D0A2020207D2C0D0A202020656C656D656E74733A207B0D0A202020202020246469616C6F673A207B7D2C0D0A202020202020247363686564756C655461626C653A207B7D2C0D0A2020202020202476616C69646174696F6E457272';
wwv_flow_api.g_varchar2_table(11) := '6F72733A207B7D2C0D0A202020202020246572726F724D657373616765733A207B7D2C0D0A20202020202024737461727454696D653A207B7D2C0D0A20202020202024656E6454696D653A207B7D2C0D0A20202020202024616C6C4461793A207B7D2C0D';
wwv_flow_api.g_varchar2_table(12) := '0A20202020202024666F637573656454696D653A207B7D2C0D0A2020202020202474696D655069636B65723A207B7D2C0D0A202020202020246672657175656E63793A207B7D2C0D0A20202020202024696E74657276616C3A207B7D2C0D0A2020202020';
wwv_flow_api.g_varchar2_table(13) := '20247374617274446174653A207B7D2C0D0A20202020202024656E64446174653A207B7D0D0A2020207D2C0D0A2020205F696E69743A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A2020202020202020';
wwv_flow_api.g_varchar2_table(14) := '200D0A2020202020207569772E656C656D656E740D0A2020202020202020202E686F7665722866756E6374696F6E2829207B0D0A202020202020202020202020242874686973292E637373287B0D0A202020202020202020202020202020276F70616369';
wwv_flow_api.g_varchar2_table(15) := '7479273A27302E34272C0D0A2020202020202020202020202020202766696C746572273A27616C706861286F7061636974793D343029272C0D0A20202020202020202020202020202027637572736F72273A27706F696E746572270D0A20202020202020';
wwv_flow_api.g_varchar2_table(16) := '20202020207D293B0D0A2020202020202020207D2C2066756E6374696F6E2829207B0D0A202020202020202020202020242874686973292E637373287B0D0A202020202020202020202020202020276F706163697479273A2731272C0D0A202020202020';
wwv_flow_api.g_varchar2_table(17) := '2020202020202020202766696C746572273A276E6F6E65272C0D0A20202020202020202020202020202027637572736F72273A2764656661756C74270D0A2020202020202020202020207D293B0D0A2020202020202020207D290D0A2020202020202020';
wwv_flow_api.g_varchar2_table(18) := '202E636C69636B2866756E6374696F6E28297B0D0A202020202020202020202020242874686973292E736269705F7363686564756C65282773686F774469616C6F6727293B0D0A2020202020202020207D293B0D0A2020202020202020200D0A20202020';
wwv_flow_api.g_varchar2_table(19) := '20207569772E5F70617273654974656D56616C75657328293B0D0A2020202020207569772E7265736574446973706C61795669657728293B0D0A2020207D2C0D0A2020205F69734E756C6C3A2066756E6374696F6E2876616C756529207B0D0A20202020';
wwv_flow_api.g_varchar2_table(20) := '20206966202876616C7565203D3D3D20756E646566696E6564207C7C2076616C7565203D3D3D20272729207B0D0A20202020202020202072657475726E20747275653B0D0A2020202020207D20656C7365207B0D0A20202020202020202072657475726E';
wwv_flow_api.g_varchar2_table(21) := '2066616C73653B0D0A2020202020207D0D0A2020207D2C0D0A2020205F69734E6F744E756C6C3A2066756E6374696F6E2876616C756529207B0D0A2020202020206966202876616C7565203D3D3D20756E646566696E6564207C7C2076616C7565203D3D';
wwv_flow_api.g_varchar2_table(22) := '3D20272729207B0D0A20202020202020202072657475726E2066616C73653B0D0A2020202020207D20656C7365207B0D0A20202020202020202072657475726E20747275653B0D0A2020202020207D0D0A2020207D2C0D0A2020205F6973426F6F6C6561';
wwv_flow_api.g_varchar2_table(23) := '6E3A2066756E6374696F6E2876616C756529207B0D0A2020202020206966202876616C7565203D3D3D2074727565207C7C2076616C7565203D3D3D2066616C736529207B0D0A20202020202020202072657475726E20747275653B0D0A2020202020207D';
wwv_flow_api.g_varchar2_table(24) := '20656C7365207B0D0A20202020202020202072657475726E2066616C73653B0D0A2020202020207D0D0A2020207D2C0D0A2020205F697356616C6964446174653A2066756E6374696F6E28646174655374722C20666F726D617453747229207B0D0A2020';
wwv_flow_api.g_varchar2_table(25) := '2020202076617220756977203D20746869733B0D0A2020202020207661722072657476616C203D20747275653B0D0A2020202020200D0A202020202020747279207B0D0A202020202020202020766172206461746554657374203D20242E646174657069';
wwv_flow_api.g_varchar2_table(26) := '636B65722E70617273654461746528666F726D61745374722C2064617465537472293B0D0A2020202020207D20636174636820286572726F724F626A29207B0D0A20202020202020202072657476616C203D2066616C73653B0D0A2020202020207D0D0A';
wwv_flow_api.g_varchar2_table(27) := '2020202020200D0A20202020202072657475726E2072657476616C3B0D0A2020207D2C0D0A2020205F697356616C696454696D653A2066756E6374696F6E2874696D655374722C2075736532346854696D6529207B0D0A20202020202076617220756977';
wwv_flow_api.g_varchar2_table(28) := '203D20746869733B0D0A20202020202076617220616D506D3B0D0A20202020202076617220686F75723B0D0A202020202020766172206D696E7574653B0D0A20202020202076617220736570617261746F723B0D0A2020202020200D0A20202020202069';
wwv_flow_api.g_varchar2_table(29) := '6620287569772E5F69734E756C6C2875736532346854696D652929207B0D0A20202020202020202072657475726E2066616C73653B0D0A2020202020207D0D0A0D0A2020202020206966202875736532346854696D65203D3D3D2066616C736529207B0D';
wwv_flow_api.g_varchar2_table(30) := '0A2020202020202020206966202874696D655374722E6C656E67746820213D203729207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020200D0A202020202020202020616D506D203D';
wwv_flow_api.g_varchar2_table(31) := '2074696D655374722E737562737472696E6728352C2037293B0D0A2020202020202020200D0A20202020202020202069662028616D506D20213D207569772E6F7074696F6E732E616D20262620616D506D20213D207569772E6F7074696F6E732E706D29';
wwv_flow_api.g_varchar2_table(32) := '207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A202020202020202020686F7572203D2074696D655374722E737562737472696E6728302C2032293B0D0A20202020';
wwv_flow_api.g_varchar2_table(33) := '20202020200D0A2020202020202020206966202869734E614E28686F75722929207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A202020202020202020686F757220';
wwv_flow_api.g_varchar2_table(34) := '3D207061727365496E7428686F75722C203130293B0D0A2020202020202020200D0A20202020202020202069662028686F7572203C2031207C7C20686F7572203E20313229207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A';
wwv_flow_api.g_varchar2_table(35) := '2020202020202020207D0D0A2020202020202020200D0A2020202020202020206D696E757465203D2074696D655374722E737562737472696E6728332C2035293B0D0A2020202020202020200D0A2020202020202020206966202869734E614E286D696E';
wwv_flow_api.g_varchar2_table(36) := '7574652929207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A2020202020202020206D696E757465203D207061727365496E74286D696E7574652C203130293B0D0A';
wwv_flow_api.g_varchar2_table(37) := '2020202020202020200D0A202020202020202020696620286D696E757465203C2030207C7C206D696E757465203E20353929207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A20202020202020';
wwv_flow_api.g_varchar2_table(38) := '20200D0A202020202020202020736570617261746F72203D2074696D655374722E737562737472696E6728322C2033293B0D0A2020202020202020200D0A20202020202020202069662028736570617261746F7220213D20273A2729207B0D0A20202020';
wwv_flow_api.g_varchar2_table(39) := '202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A20202020202020202072657475726E20747275653B0D0A2020202020207D20656C7365207B2F2F5573696E6720323420686F75722066';
wwv_flow_api.g_varchar2_table(40) := '6F726D61742020200D0A2020202020202020206966202874696D655374722E6C656E67746820213D203529207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A202020';
wwv_flow_api.g_varchar2_table(41) := '202020202020686F7572203D2074696D655374722E737562737472696E6728302C2032293B0D0A2020202020202020200D0A2020202020202020206966202869734E614E28686F75722929207B0D0A20202020202020202020202072657475726E206661';
wwv_flow_api.g_varchar2_table(42) := '6C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A202020202020202020686F7572203D207061727365496E7428686F75722C203130293B0D0A2020202020202020200D0A20202020202020202069662028686F7572203C2031207C';
wwv_flow_api.g_varchar2_table(43) := '7C20686F7572203E20313229207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A2020202020202020206D696E757465203D2074696D655374722E737562737472696E';
wwv_flow_api.g_varchar2_table(44) := '6728332C2035293B0D0A2020202020202020200D0A2020202020202020206966202869734E614E286D696E7574652929207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A202020202020202020';
wwv_flow_api.g_varchar2_table(45) := '0D0A2020202020202020206D696E757465203D207061727365496E74286D696E7574652C203130293B0D0A2020202020202020200D0A202020202020202020696620286D696E757465203C2030207C7C206D696E757465203E20353929207B0D0A202020';
wwv_flow_api.g_varchar2_table(46) := '20202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A202020202020202020736570617261746F72203D2074696D655374722E737562737472696E6728322C2033293B0D0A202020202020';
wwv_flow_api.g_varchar2_table(47) := '2020200D0A20202020202020202069662028736570617261746F7220213D20273A2729207B0D0A20202020202020202020202072657475726E2066616C73653B0D0A2020202020202020207D0D0A2020202020202020200D0A2020202020202020207265';
wwv_flow_api.g_varchar2_table(48) := '7475726E20747275653B0D0A2020202020207D0D0A2020207D2C0D0A2020205F73686F774475726174696F6E5761726E696E673A2066756E6374696F6E2829207B0D0A202020202020766172207569772C2020200D0A202020202020202020686F757273';
wwv_flow_api.g_varchar2_table(49) := '31322C0D0A202020202020202020247761726E696E672C0D0A2020202020202020206475725365636F6E64733B0D0A2020202020202020200D0A202020202020756977203D20746869733B0D0A0D0A202020202020696620280D0A202020202020202020';
wwv_flow_api.g_varchar2_table(50) := '217569772E5F697356616C696454696D65287569772E656C656D656E74732E24737461727454696D652E76616C28292C207569772E76616C7565732E75736532346854696D65290D0A2020202020202020207C7C20217569772E5F697356616C69645469';
wwv_flow_api.g_varchar2_table(51) := '6D65287569772E656C656D656E74732E24656E6454696D652E76616C28292C207569772E76616C7565732E75736532346854696D65290D0A20202020202029207B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A202020202020';
wwv_flow_api.g_varchar2_table(52) := '0D0A202020202020686F7572733132203D2034333230303B0D0A202020202020247761726E696E67203D202428277472236475726174696F6E5F7761726E696E6727293B0D0A2020202020206475725365636F6E6473203D207569772E5F676574447572';
wwv_flow_api.g_varchar2_table(53) := '6174696F6E28277365636F6E647327293B0D0A2020202020200D0A202020202020696620280D0A202020202020202020217569772E656C656D656E74732E24616C6C4461792E617474722827636865636B65642729200D0A202020202020202020262620';
wwv_flow_api.g_varchar2_table(54) := '6475725365636F6E6473203E20686F75727331320D0A20202020202020202026262021247761726E696E672E6C656E6774680D0A20202020202029207B0D0A2020202020202020202428277461626C6523736269705F656469745F7461626C65203E2074';
wwv_flow_api.g_varchar2_table(55) := '626F6479203E2074723A657128312927292E6166746572280D0A2020202020202020202020202020273C74722069643D226475726174696F6E5F7761726E696E67223E2020203C74643E266E6273703B3C2F74643E3C746420616C69676E3D226C656674';
wwv_flow_api.g_varchar2_table(56) := '2220636F6C7370616E3D22322220726F777370616E3D2231223E270D0A2020202020202020202020202B20272020203C646976207374796C653D222220636C6173733D2275692D776964676574223E270D0A2020202020202020202020202B2027202020';
wwv_flow_api.g_varchar2_table(57) := '3C64697620636C6173733D2275692D73746174652D686967686C696768742075692D636F726E65722D616C6C22207374796C653D2270616464696E673A2030707420302E37656D3B223E270D0A2020202020202020202020202B20272020202020203C73';
wwv_flow_api.g_varchar2_table(58) := '70616E20636C6173733D2275692D69636F6E2075692D69636F6E2D696E666F22207374796C653D22666C6F61743A206C6566743B206D617267696E2D72696768743A20302E33656D3B223E3C2F7370616E3E270D0A2020202020202020202020202B2027';
wwv_flow_api.g_varchar2_table(59) := '2020202020205761726E696E673A204475726174696F6E206F76657220313220686F757273270D0A2020202020202020202020202B20272020203C2F6469763E270D0A2020202020202020202020202B20272020203C2F6469763E3C2F74643E3C2F7472';
wwv_flow_api.g_varchar2_table(60) := '3E270D0A202020202020202020293B0D0A2020202020207D20656C736520696620280D0A202020202020202020287569772E656C656D656E74732E24616C6C4461792E617474722827636865636B65642729200D0A2020202020202020207C7C20647572';
wwv_flow_api.g_varchar2_table(61) := '5365636F6E6473203C3D20686F7572733132290D0A202020202020202020262620247761726E696E672E6C656E6774680D0A202020202020297B0D0A202020202020202020247761726E696E672E72656D6F766528293B0D0A2020202020207D0D0A2020';
wwv_flow_api.g_varchar2_table(62) := '207D2C200D0A2020205F7368696674456E6454696D653A2066756E6374696F6E28297B0D0A20202020202076617220756977203D20746869733B0D0A202020202020766172206F726754696D6532343B0D0A202020202020766172206E657754696D6532';
wwv_flow_api.g_varchar2_table(63) := '343B0D0A20202020202076617220656E6454696D6532343B0D0A20202020202076617220737461727444617465313B0D0A20202020202076617220737461727444617465323B0D0A20202020202076617220656E64446174653B0D0A2020202020207661';
wwv_flow_api.g_varchar2_table(64) := '72206475726174696F6E5F6D733B0D0A20202020202076617220686F7572733B0D0A202020202020766172206D696E757465733B0D0A0D0A202020202020696620280D0A2020202020202020207569772E656C656D656E74732E24737461727454696D65';
wwv_flow_api.g_varchar2_table(65) := '2E76616C2829203D3D207569772E656C656D656E74732E24737461727454696D652E617474722827646174612D6F72672D74696D6527290D0A2020202020202020207C7C20217569772E5F697356616C696454696D65287569772E656C656D656E74732E';
wwv_flow_api.g_varchar2_table(66) := '24737461727454696D652E76616C28292C207569772E76616C7565732E75736532346854696D65290D0A2020202020202020207C7C20217569772E5F697356616C696454696D65287569772E656C656D656E74732E24737461727454696D652E61747472';
wwv_flow_api.g_varchar2_table(67) := '2827646174612D6F72672D74696D6527292C207569772E76616C7565732E75736532346854696D65290D0A2020202020202020207C7C20217569772E5F697356616C696454696D65287569772E656C656D656E74732E24656E6454696D652E76616C2829';
wwv_flow_api.g_varchar2_table(68) := '2C207569772E76616C7565732E75736532346854696D65290D0A20202020202029207B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A2020202020200D0A20202020202069662028217569772E76616C7565732E757365323468';
wwv_flow_api.g_varchar2_table(69) := '54696D6529207B0D0A2020202020202020206F726754696D653234203D207569772E5F67657454696D653132746F3234287569772E656C656D656E74732E24737461727454696D652E617474722827646174612D6F72672D74696D652729293B0D0A2020';
wwv_flow_api.g_varchar2_table(70) := '202020202020206E657754696D653234203D207569772E5F67657454696D653132746F3234287569772E656C656D656E74732E24737461727454696D652E76616C2829293B0D0A202020202020202020656E6454696D653234203D207569772E5F676574';
wwv_flow_api.g_varchar2_table(71) := '54696D653132746F3234287569772E656C656D656E74732E24656E6454696D652E76616C2829293B0D0A2020202020207D20656C7365207B0D0A2020202020202020206F726754696D653234203D207569772E656C656D656E74732E2473746172745469';
wwv_flow_api.g_varchar2_table(72) := '6D652E617474722827646174612D6F72672D74696D6527293B0D0A2020202020202020206E657754696D653234203D207569772E656C656D656E74732E24737461727454696D652E76616C28293B0D0A202020202020202020656E6454696D653234203D';
wwv_flow_api.g_varchar2_table(73) := '207569772E656C656D656E74732E24656E6454696D652E76616C28293B0D0A2020202020207D0D0A0D0A20202020202073746172744461746531203D206E6577204461746528323030302C20312C20312C206E657754696D6532342E737562737472696E';
wwv_flow_api.g_varchar2_table(74) := '6728302C2032292C206E657754696D6532342E737562737472696E6728332C2035292C20302C2030293B0D0A20202020202073746172744461746532203D206E6577204461746528323030302C20312C20312C206F726754696D6532342E737562737472';
wwv_flow_api.g_varchar2_table(75) := '696E6728302C2032292C206F726754696D6532342E737562737472696E6728332C2035292C20302C2030293B0D0A2020202020206475726174696F6E5F6D73203D2073746172744461746532202D20737461727444617465313B0D0A2020202020200D0A';
wwv_flow_api.g_varchar2_table(76) := '202020202020686F757273203D207061727365496E74286475726174696F6E5F6D732F28313030302A36302A363029293B0D0A2020202020206D696E75746573203D207061727365496E7428286475726174696F6E5F6D732F28313030302A3630292925';
wwv_flow_api.g_varchar2_table(77) := '3630293B0D0A2020202020200D0A202020202020656E6444617465203D206E6577204461746528323030302C20312C20312C20656E6454696D6532342E737562737472696E6728302C2032292C20656E6454696D6532342E737562737472696E6728332C';
wwv_flow_api.g_varchar2_table(78) := '2035292C20302C2030293B0D0A202020202020656E64446174652E736574486F75727328656E64446174652E676574486F7572732829202D20686F757273293B0D0A202020202020656E64446174652E7365744D696E7574657328656E64446174652E67';
wwv_flow_api.g_varchar2_table(79) := '65744D696E757465732829202D206D696E75746573293B0D0A2020202020200D0A202020202020686F757273203D20656E64446174652E676574486F75727328293B0D0A202020202020686F757273203D2028686F757273203C20313029203F20273027';
wwv_flow_api.g_varchar2_table(80) := '202B20686F757273203A20686F7572733B0D0A2020202020200D0A2020202020206D696E75746573203D20656E64446174652E6765744D696E7574657328293B0D0A2020202020206D696E75746573203D20286D696E75746573203C20313029203F2027';
wwv_flow_api.g_varchar2_table(81) := '3027202B206D696E75746573203A206D696E757465733B0D0A2020202020200D0A202020202020656E6454696D653234203D20686F757273202B20273A27202B206D696E757465733B0D0A2020202020200D0A20202020202069662028217569772E7661';
wwv_flow_api.g_varchar2_table(82) := '6C7565732E75736532346854696D6529207B0D0A2020202020202020207569772E656C656D656E74732E24656E6454696D652E76616C287569772E5F67657454696D653234746F313228656E6454696D65323429293B0D0A2020202020207D20656C7365';
wwv_flow_api.g_varchar2_table(83) := '207B0D0A2020202020202020207569772E656C656D656E74732E24656E6454696D652E76616C28656E6454696D653234293B0D0A2020202020207D0D0A2020207D2C0D0A2020205F67657454696D653132746F32343A2066756E6374696F6E2874696D65';
wwv_flow_api.g_varchar2_table(84) := '313229207B0D0A20202020202076617220756977203D20746869733B0D0A20202020202076617220686F757231323B0D0A202020202020766172206D696E3B0D0A20202020202076617220616D506D3B0D0A2020202020207661722074696D6532343B0D';
wwv_flow_api.g_varchar2_table(85) := '0A2020202020200D0A20202020202069662028217569772E5F697356616C696454696D652874696D6531322C207569772E76616C7565732E75736532346854696D652929207B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A20';
wwv_flow_api.g_varchar2_table(86) := '20202020200D0A202020202020686F75723132203D207061727365496E742874696D6531322E737562737472696E6728302C2074696D6531322E696E6465784F6628273A2729292C203130293B0D0A2020202020206D696E203D2074696D6531322E7375';
wwv_flow_api.g_varchar2_table(87) := '627374722874696D6531322E696E6465784F6628273A2729202B20312C2032293B0D0A202020202020616D506D203D2074696D6531322E7375627374722874696D6531322E696E6465784F6628273A2729202B20332C2032293B0D0A2020202020200D0A';
wwv_flow_api.g_varchar2_table(88) := '20202020202069662028616D506D203D3D207569772E6F7074696F6E732E706D20262620686F7572313220213D20313229207B0D0A20202020202020202074696D653234203D2028686F75723132202B20313229202B20273A27202B206D696E3B0D0A20';
wwv_flow_api.g_varchar2_table(89) := '20202020207D20656C73652069662028616D506D203D3D207569772E6F7074696F6E732E616D20262620686F75723132203D3D202731322729207B0D0A20202020202020202074696D653234203D2027303027202B20273A27202B206D696E3B0D0A2020';
wwv_flow_api.g_varchar2_table(90) := '202020207D20656C7365207B0D0A20202020202020202074696D653234203D2028686F75723132203C20313029203F20273027202B20686F75723132203A20686F757231323B0D0A20202020202020202074696D653234203D2074696D653234202B2027';
wwv_flow_api.g_varchar2_table(91) := '3A27202B206D696E3B0D0A2020202020207D0D0A2020202020200D0A20202020202072657475726E2074696D6532343B2020200D0A2020207D2C0D0A2020205F67657454696D653234746F31323A2066756E6374696F6E2874696D65323429207B0D0A20';
wwv_flow_api.g_varchar2_table(92) := '202020202076617220756977203D20746869733B0D0A20202020202076617220686F757232343B0D0A202020202020766172206D696E3B0D0A2020202020207661722074696D6531323B0D0A2020202020200D0A202020202020686F75723234203D2070';
wwv_flow_api.g_varchar2_table(93) := '61727365496E742874696D6532342E737562737472696E6728302C2074696D6532342E696E6465784F6628273A2729292C203130293B0D0A2020202020206D696E203D2074696D6532342E7375627374722874696D6532342E696E6465784F6628273A27';
wwv_flow_api.g_varchar2_table(94) := '29202B20312C2032293B0D0A2020202020200D0A20202020202069662028686F75723234203D3D20313229207B0D0A20202020202020202074696D653132203D202731323A27202B206D696E202B207569772E6F7074696F6E732E706D3B0D0A20202020';
wwv_flow_api.g_varchar2_table(95) := '20207D20656C73652069662028686F75723234203E20313229207B0D0A20202020202020202074696D653132203D20686F75723234202D2031323B0D0A20202020202020202074696D653132203D202874696D653132203C20313029203F20273027202B';
wwv_flow_api.g_varchar2_table(96) := '2074696D653132203A2074696D6531323B0D0A20202020202020202074696D653132203D2074696D653132202B20273A27202B206D696E202B207569772E6F7074696F6E732E706D3B0D0A2020202020207D20656C7365207B0D0A202020202020202020';
wwv_flow_api.g_varchar2_table(97) := '74696D653132203D2028686F75723234203D3D203029203F2027313227203A20686F757232343B0D0A20202020202020202074696D653132203D202874696D653132203C20313029203F20273027202B2074696D653132203A2074696D6531323B0D0A20';
wwv_flow_api.g_varchar2_table(98) := '202020202020202074696D653132203D2074696D653132202B20273A27202B206D696E202B207569772E6F7074696F6E732E616D3B0D0A2020202020207D0D0A2020202020200D0A20202020202072657475726E2074696D6531323B200D0A2020207D2C';
wwv_flow_api.g_varchar2_table(99) := '0D0A2020205F6765744475726174696F6E3A2066756E6374696F6E286D65617375726529207B0D0A202020202020766172207569773B0D0A202020202020766172206475726174696F6E537472696E673B0D0A2020202020207661722073746172744461';
wwv_flow_api.g_varchar2_table(100) := '74653B0D0A20202020202076617220656E64446174653B0D0A202020202020766172207374617274486F75723B0D0A2020202020207661722073746172744D696E3B0D0A20202020202076617220656E6454696D653B0D0A20202020202076617220656E';
wwv_flow_api.g_varchar2_table(101) := '64486F75723B0D0A20202020202076617220656E644D696E3B0D0A202020202020766172207365636F6E6473416C6C4461793B0D0A2020202020200D0A202020202020756977203D20746869733B0D0A2020202020206D656173757265203D20286D6561';
wwv_flow_api.g_varchar2_table(102) := '7375726529203F206D656173757265203A20277365636F6E6473273B0D0A202020202020737461727444617465203D20242E646174657069636B65722E706172736544617465282779796D6D6464272C2027323030313031303127293B0D0A2020202020';
wwv_flow_api.g_varchar2_table(103) := '20656E6444617465203D20242E646174657069636B65722E706172736544617465282779796D6D6464272C2027323030313031303127293B0D0A2020202020207365636F6E6473416C6C446179203D20273836343030273B0D0A2020202020200D0A2020';
wwv_flow_api.g_varchar2_table(104) := '20202020696620287569772E656C656D656E74732E24616C6C4461792E617474722827636865636B6564272929207B0D0A2020202020202020206475726174696F6E537472696E67203D207365636F6E6473416C6C4461793B200D0A2020202020207D20';
wwv_flow_api.g_varchar2_table(105) := '656C7365207B0D0A202020202020202020737461727454696D65203D207569772E5F67657454696D653132746F3234287569772E656C656D656E74732E24737461727454696D652E76616C2829293B0D0A2020202020202020207374617274486F757220';
wwv_flow_api.g_varchar2_table(106) := '3D20737461727454696D652E737562737472696E6728302C32293B0D0A20202020202020202073746172744D696E203D20737461727454696D652E737562737472696E6728332C35293B0D0A2020202020202020207374617274446174652E736574486F';
wwv_flow_api.g_varchar2_table(107) := '757273287374617274486F75722C2073746172744D696E2C20302C2030293B200D0A2020202020200D0A202020202020202020656E6454696D65203D207569772E5F67657454696D653132746F3234287569772E656C656D656E74732E24656E6454696D';
wwv_flow_api.g_varchar2_table(108) := '652E76616C2829293B0D0A202020202020202020656E64486F7572203D20656E6454696D652E737562737472696E6728302C32293B0D0A202020202020202020656E644D696E203D20656E6454696D652E737562737472696E6728332C35293B0D0A2020';
wwv_flow_api.g_varchar2_table(109) := '2020200D0A202020202020202020656E64446174652E736574486F75727328656E64486F75722C20656E644D696E2C20302C2030293B0D0A2020202020202020200D0A202020202020202020696620286D656173757265203D20277365636F6E64732729';
wwv_flow_api.g_varchar2_table(110) := '7B0D0A20202020202020202020202064697669736F72203D20313030303B0D0A2020202020202020207D0D0A2020202020202020200D0A20202020202020202069662028656E6444617465203C2073746172744461746529207B0D0A2020202020202020';
wwv_flow_api.g_varchar2_table(111) := '20202020656E64446174652E736574486F75727328656E64446174652E676574486F7572732829202B203234293B0D0A2020202020202020202020206475726174696F6E537472696E67203D202828656E64446174652D737461727444617465292F6469';
wwv_flow_api.g_varchar2_table(112) := '7669736F72293B0D0A2020202020202020207D20656C7365207B0D0A2020202020202020202020206475726174696F6E537472696E67203D202828656E64446174652D737461727444617465292F64697669736F72293B0D0A2020202020202020207D0D';
wwv_flow_api.g_varchar2_table(113) := '0A2020202020207D0D0A2020202020200D0A20202020202072657475726E207061727365496E74286475726174696F6E537472696E67293B0D0A2020207D2C0D0A2020205F70617273654974656D56616C7565733A2066756E6374696F6E2829207B0D0A';
wwv_flow_api.g_varchar2_table(114) := '20202020202076617220756977203D20746869733B0D0A202020202020766172207363686564756C65203D20242827696E7075742327202B207569772E6F7074696F6E732E7363686564756C654974656D292E76616C28293B0D0A2020202020200D0A20';
wwv_flow_api.g_varchar2_table(115) := '2020202020696620287363686564756C6529207B0D0A202020202020202020766172207363686564756C6556616C756573203D207363686564756C652E73706C697428277C27293B0D0A20202020202020202076617220737461727444617465323B202F';
wwv_flow_api.g_varchar2_table(116) := '2F64756D6D79207374617274206461746520746F2063616C632074696D652F6475726174696F6E0D0A20202020202020202076617220737461727454696D6532343B0D0A20202020202020202076617220656E6454696D6532343B0D0A20202020202020';
wwv_flow_api.g_varchar2_table(117) := '20200D0A2020202020202020207569772E76616C7565732E737631203D207363686564756C6556616C7565735B305D3B0D0A2020202020202020207569772E76616C7565732E737632203D207363686564756C6556616C7565735B315D3B0D0A20202020';
wwv_flow_api.g_varchar2_table(118) := '20202020207569772E76616C7565732E737633203D207363686564756C6556616C7565735B325D3B0D0A2020202020202020207569772E76616C7565732E737634203D207363686564756C6556616C7565735B335D3B0D0A2020202020202020200D0A20';
wwv_flow_api.g_varchar2_table(119) := '20202020202020207569772E76616C7565732E6475726174696F6E5365636F6E6473203D207061727365496E74287569772E76616C7565732E737633293B0D0A2020202020202020200D0A2020202020202020207569772E76616C7565732E7573653234';
wwv_flow_api.g_varchar2_table(120) := '6854696D65203D20287569772E6F7074696F6E732E75736532346854696D65203D3D2027592729203F2074727565203A2066616C73653B0D0A2020202020202020200D0A2020202020202020207569772E76616C7565732E7374617274486F7572203D20';
wwv_flow_api.g_varchar2_table(121) := '7061727365496E74287569772E76616C7565732E7376312E737562737472696E6728382C3130292C203130293B0D0A2020202020202020207569772E76616C7565732E73746172744D696E203D207061727365496E74287569772E76616C7565732E7376';
wwv_flow_api.g_varchar2_table(122) := '312E737562737472696E672831302C3132292C203130293B0D0A2020202020200D0A2020202020202020207569772E76616C7565732E737461727444617465203D20242E646174657069636B65722E706172736544617465282779796D6D6464272C2075';
wwv_flow_api.g_varchar2_table(123) := '69772E76616C7565732E7376312E737562737472696E6728302C3829293B0D0A2020202020202020207569772E76616C7565732E7374617274446174652E736574486F757273287569772E76616C7565732E7374617274486F75722C207569772E76616C';
wwv_flow_api.g_varchar2_table(124) := '7565732E73746172744D696E2C20302C2030293B0D0A2020202020202020207569772E76616C7565732E737461727444617465466D74203D20242E646174657069636B65722E666F726D617444617465287569772E6F7074696F6E732E64617465466F72';
wwv_flow_api.g_varchar2_table(125) := '6D61742C207569772E76616C7565732E737461727444617465293B0D0A2020202020202020200D0A20202020202020202073746172744461746532203D20242E646174657069636B65722E706172736544617465282779796D6D6464272C207569772E76';
wwv_flow_api.g_varchar2_table(126) := '616C7565732E7376312E737562737472696E6728302C3829293B0D0A202020202020202020737461727444617465322E736574486F757273287569772E76616C7565732E7374617274486F75722C207569772E76616C7565732E73746172744D696E2C20';
wwv_flow_api.g_varchar2_table(127) := '302C2030293B0D0A202020202020202020737461727444617465322E736574486F75727328737461727444617465322E676574486F7572732829202B20287569772E76616C7565732E7376332F36302F363029293B0D0A20202020202020202073746172';
wwv_flow_api.g_varchar2_table(128) := '7444617465322E7365744D696E7574657328737461727444617465322E6765744D696E757465732829202B2028287569772E76616C7565732E7376332F36302925363029293B0D0A2020202020202020207569772E76616C7565732E656E64486F757220';
wwv_flow_api.g_varchar2_table(129) := '3D20737461727444617465322E676574486F75727328293B0D0A2020202020202020207569772E76616C7565732E656E644D696E203D20737461727444617465322E6765744D696E7574657328293B0D0A2020202020202020200D0A2020202020202020';
wwv_flow_api.g_varchar2_table(130) := '20696620287569772E76616C7565732E73763229207B0D0A202020202020202020202020696620287569772E5F697356616C696444617465287569772E76616C7565732E7376312E737562737472696E6728302C38292C202779796D6D6464272929207B';
wwv_flow_api.g_varchar2_table(131) := '0D0A2020202020202020202020202020207569772E76616C7565732E656E6444617465203D20242E646174657069636B65722E706172736544617465282779796D6D6464272C207569772E76616C7565732E7376322E737562737472696E6728302C3829';
wwv_flow_api.g_varchar2_table(132) := '293B0D0A2020202020202020202020202020207569772E76616C7565732E656E64446174652E736574486F757273287569772E76616C7565732E656E64486F75722C207569772E76616C7565732E656E644D696E2C20302C2030293B0D0A202020202020';
wwv_flow_api.g_varchar2_table(133) := '2020202020202020207569772E76616C7565732E656E6444617465466D74203D20242E646174657069636B65722E666F726D617444617465287569772E6F7074696F6E732E64617465466F726D61742C207569772E76616C7565732E656E644461746529';
wwv_flow_api.g_varchar2_table(134) := '3B0D0A2020202020202020202020207D20656C7365207B0D0A2020202020202020202020202020207569772E76616C7565732E656E6444617465203D2027273B0D0A2020202020202020202020202020207569772E76616C7565732E656E644461746546';
wwv_flow_api.g_varchar2_table(135) := '6D74203D20274572726F72273B0D0A2020202020202020202020207D0D0A2020202020202020207D20656C7365207B0D0A2020202020202020202020207569772E76616C7565732E656E6444617465203D2027273B0D0A20202020202020202020202075';
wwv_flow_api.g_varchar2_table(136) := '69772E76616C7565732E656E6444617465466D74203D20272D273B0D0A2020202020202020207D0D0A2020202020202020200D0A202020202020202020737461727454696D653234203D207569772E76616C7565732E7374617274486F7572202B20273A';
wwv_flow_api.g_varchar2_table(137) := '273B0D0A202020202020202020737461727454696D653234203D20287569772E76616C7565732E73746172744D696E203D3D203029203F20737461727454696D653234202B20273027202B207569772E76616C7565732E73746172744D696E203A207374';
wwv_flow_api.g_varchar2_table(138) := '61727454696D653234202B207569772E76616C7565732E73746172744D696E3B0D0A2020202020202020200D0A2020202020202020207569772E76616C7565732E737461727454696D65466D74203D207569772E5F67657454696D653234746F31322873';
wwv_flow_api.g_varchar2_table(139) := '7461727454696D653234293B0D0A2020202020202020200D0A202020202020202020656E6454696D653234203D207569772E76616C7565732E656E64486F7572202B20273A273B0D0A202020202020202020656E6454696D653234203D20287569772E76';
wwv_flow_api.g_varchar2_table(140) := '616C7565732E656E644D696E203D3D203029203F20656E6454696D653234202B20273027202B207569772E76616C7565732E656E644D696E203A20656E6454696D653234202B207569772E76616C7565732E656E644D696E3B0D0A202020202020202020';
wwv_flow_api.g_varchar2_table(141) := '0D0A2020202020202020207569772E76616C7565732E656E6454696D65466D74203D207569772E5F67657454696D653234746F313228656E6454696D653234293B0D0A2020202020202020200D0A2020202020202020207569772E76616C7565732E6361';
wwv_flow_api.g_varchar2_table(142) := '6C656E646172537472696E672E66726571203D207569772E76616C7565732E7376342E737562737472696E67287569772E76616C7565732E7376342E696E6465784F662827465245513D27292B352C7569772E76616C7565732E7376342E696E6465784F';
wwv_flow_api.g_varchar2_table(143) := '6628273B272C207569772E76616C7565732E7376342E696E6465784F662827465245513D272929293B0D0A2020202020202020207569772E76616C7565732E63616C656E646172537472696E672E696E74657276616C203D207061727365496E74287569';
wwv_flow_api.g_varchar2_table(144) := '772E76616C7565732E7376342E737562737472696E67287569772E76616C7565732E7376342E696E6465784F662827494E54455256414C3D27292B392C7569772E76616C7565732E7376342E696E6465784F6628273B272C207569772E76616C7565732E';
wwv_flow_api.g_varchar2_table(145) := '7376342E696E6465784F662827494E54455256414C3D27292929293B0D0A2020202020202020200D0A202020202020202020696620287569772E76616C7565732E7376342E696E6465784F66282742594441593D272920213D202D3129207B0D0A202020';
wwv_flow_api.g_varchar2_table(146) := '2020202020202020207569772E76616C7565732E63616C656E646172537472696E672E6279646179203D207569772E76616C7565732E7376342E737562737472696E67287569772E76616C7565732E7376342E696E6465784F66282742594441593D2729';
wwv_flow_api.g_varchar2_table(147) := '2B362C7569772E76616C7565732E7376342E696E6465784F6628273B272C207569772E76616C7565732E7376342E696E6465784F66282742594441593D272929293B0D0A2020202020202020207D20656C7365207B0D0A20202020202020202020202075';
wwv_flow_api.g_varchar2_table(148) := '69772E76616C7565732E63616C656E646172537472696E672E6279646179203D2027273B0D0A2020202020202020207D0D0A202020202020202020696620287569772E76616C7565732E7376342E696E6465784F66282742594D4F4E54483D272920213D';
wwv_flow_api.g_varchar2_table(149) := '202D3129207B0D0A2020202020202020202020207569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E7468203D207569772E76616C7565732E7376342E737562737472696E67287569772E76616C7565732E7376342E696E6465';
wwv_flow_api.g_varchar2_table(150) := '784F66282742594D4F4E54483D27292B382C7569772E76616C7565732E7376342E696E6465784F6628273B272C207569772E76616C7565732E7376342E696E6465784F66282742594D4F4E54483D272929293B0D0A2020202020202020207D20656C7365';
wwv_flow_api.g_varchar2_table(151) := '207B0D0A2020202020202020202020207569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E7468203D2027273B0D0A2020202020202020207D0D0A202020202020202020696620287569772E76616C7565732E7376342E696E64';
wwv_flow_api.g_varchar2_table(152) := '65784F66282742594D4F4E54484441593D272920213D202D3129207B0D0A2020202020202020202020207569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E7468646179203D207569772E76616C7565732E7376342E73756273';
wwv_flow_api.g_varchar2_table(153) := '7472696E67287569772E76616C7565732E7376342E696E6465784F66282742594D4F4E54484441593D27292B31312C7569772E76616C7565732E7376342E696E6465784F6628273B272C207569772E76616C7565732E7376342E696E6465784F66282742';
wwv_flow_api.g_varchar2_table(154) := '594D4F4E54484441593D272929293B0D0A2020202020202020207D20656C7365207B0D0A2020202020202020202020207569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E7468646179203D2027273B0D0A2020202020202020';
wwv_flow_api.g_varchar2_table(155) := '207D0D0A2020202020207D20656C7365207B0D0A2020202020202020207569772E76616C7565732E737631203D2027273B0D0A2020202020202020207569772E76616C7565732E737632203D2027273B0D0A2020202020202020207569772E76616C7565';
wwv_flow_api.g_varchar2_table(156) := '732E737633203D2027273B0D0A2020202020202020207569772E76616C7565732E737634203D2027273B0D0A2020202020202020207569772E76616C7565732E6475726174696F6E5365636F6E6473203D2027273B0D0A2020202020202020207569772E';
wwv_flow_api.g_varchar2_table(157) := '76616C7565732E75736532346854696D65203D20287569772E6F7074696F6E732E75736532346854696D65203D3D2027592729203F2074727565203A2066616C73653B0D0A2020202020202020207569772E76616C7565732E7374617274486F7572203D';
wwv_flow_api.g_varchar2_table(158) := '2027273B0D0A2020202020202020207569772E76616C7565732E73746172744D696E203D2027273B0D0A2020202020202020207569772E76616C7565732E737461727444617465203D2027273B0D0A2020202020202020207569772E76616C7565732E73';
wwv_flow_api.g_varchar2_table(159) := '7461727444617465466D74203D2027273B2020202020202020200D0A2020202020202020207569772E76616C7565732E656E64486F7572203D2027273B0D0A2020202020202020207569772E76616C7565732E656E644D696E203D2027273B0D0A202020';
wwv_flow_api.g_varchar2_table(160) := '2020202020207569772E76616C7565732E656E6444617465203D2027273B0D0A2020202020202020207569772E76616C7565732E656E6444617465466D74203D2027273B0D0A2020202020202020207569772E76616C7565732E737461727454696D6546';
wwv_flow_api.g_varchar2_table(161) := '6D74203D2027273B0D0A2020202020202020207569772E76616C7565732E656E6454696D65466D74203D2027273B0D0A2020202020202020207569772E76616C7565732E63616C656E646172537472696E672E66726571203D2027273B0D0A2020202020';
wwv_flow_api.g_varchar2_table(162) := '202020207569772E76616C7565732E63616C656E646172537472696E672E696E74657276616C203D2027273B0D0A2020202020202020207569772E76616C7565732E63616C656E646172537472696E672E6279646179203D2027273B0D0A202020202020';
wwv_flow_api.g_varchar2_table(163) := '2020207569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E7468203D2027273B0D0A2020202020202020207569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E7468646179203D2027273B0D0A202020';
wwv_flow_api.g_varchar2_table(164) := '2020202020200D0A2020202020207D0D0A2020207D2C0D0A2020205F696E6974456C656D656E74733A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A2020202020207569772E656C65';
wwv_flow_api.g_varchar2_table(165) := '6D656E74732E246469616C6F67203D2024282764697623736269705F6469616C6F6727293B0D0A2020202020207569772E656C656D656E74732E247363686564756C655461626C65203D202428277461626C6523736269705F656469745F7461626C6527';
wwv_flow_api.g_varchar2_table(166) := '293B0D0A2020202020207569772E656C656D656E74732E2476616C69646174696F6E4572726F7273203D2024282764697623736269705F76616C69646174696F6E5F6572726F727327293B0D0A2020202020207569772E656C656D656E74732E24657272';
wwv_flow_api.g_varchar2_table(167) := '6F724D65737361676573203D20242827756C23736269705F6572726F725F6D6573736167657327293B0D0A2020202020207569772E656C656D656E74732E24737461727454696D65203D20242827696E70757423736269705F7363686564756C655F7374';
wwv_flow_api.g_varchar2_table(168) := '6172745F74696D6527293B0D0A2020202020207569772E656C656D656E74732E24656E6454696D65203D20242827696E70757423736269705F7363686564756C655F656E645F74696D6527293B0D0A2020202020207569772E656C656D656E74732E2461';
wwv_flow_api.g_varchar2_table(169) := '6C6C446179203D20242827696E70757423736269705F7363686564756C655F74696D655F616427293B0D0A2020202020202F2F7569772E656C656D656E74732E2474696D655069636B6572206973207472616E7369656E7420616E642073657420776865';
wwv_flow_api.g_varchar2_table(170) := '6E2061646465640D0A2020202020202F2F7569772E656C656D656E74732E24666F637573656454696D65206973207472616E7369656E7420616E6420736574207768656E20636C69636B65640D0A2020202020207569772E656C656D656E74732E246672';
wwv_flow_api.g_varchar2_table(171) := '657175656E6379203D2024282773656C65637423736269705F7363686564756C655F6672657175656E637927293B0D0A2020202020207569772E656C656D656E74732E24696E74657276616C203D2024282773656C65637423736269705F736368656475';
wwv_flow_api.g_varchar2_table(172) := '6C655F696E74657276616C27293B0D0A2020202020207569772E656C656D656E74732E24737461727444617465203D20242827696E70757423736269705F7363686564756C655F73746172745F6461746527293B0D0A2020202020207569772E656C656D';
wwv_flow_api.g_varchar2_table(173) := '656E74732E24656E6444617465203D20242827696E70757423736269705F7363686564756C655F656E645F6461746527293B0D0A2020207D2C0D0A2020207265736574446973706C6179566965773A2066756E6374696F6E2829207B0D0A202020202020';
wwv_flow_api.g_varchar2_table(174) := '76617220756977203D20746869733B0D0A202020202020766172207363686564756C6548746D6C3B0D0A2020202020200D0A202020202020696620287569772E76616C7565732E73746172744461746529207B0D0A202020202020202020736368656475';
wwv_flow_api.g_varchar2_table(175) := '6C6548746D6C203D0D0A2020202020202020202020202020273C7461626C6520636C6173733D2275692D776964676574223E270D0A2020202020202020202020202B20273C74626F64793E270D0A2020202020202020202020202B20272020203C74723E';
wwv_flow_api.g_varchar2_table(176) := '270D0A2020202020202020202020202B20272020202020203C746820636C6173733D2275692D7769646765742D686561646572223E537461727473204F6E3A3C2F74683E270D0A2020202020202020202020202B20272020202020203C746420636C6173';
wwv_flow_api.g_varchar2_table(177) := '733D2275692D7769646765742D636F6E74656E74223E27202B207569772E76616C7565732E737461727444617465466D74202B20273C2F74643E270D0A2020202020202020202020202B20272020203C2F74723E270D0A2020202020202020202020202B';
wwv_flow_api.g_varchar2_table(178) := '20272020203C74723E270D0A2020202020202020202020202B20272020202020203C746820636C6173733D2275692D7769646765742D686561646572223E54696D653A3C2F74683E273B0D0A2020202020202020202020200D0A20202020202020202069';
wwv_flow_api.g_varchar2_table(179) := '6620287569772E76616C7565732E6475726174696F6E5365636F6E6473203D3D20383634303029207B0D0A2020202020202020202020207363686564756C6548746D6C202B3D20272020202020203C746420636C6173733D2275692D7769646765742D63';
wwv_flow_api.g_varchar2_table(180) := '6F6E74656E74223E416C6C204461793C2F74643E273B0D0A2020202020202020207D20656C7365207B0D0A2020202020202020202020207363686564756C6548746D6C202B3D20272020202020203C746420636C6173733D2275692D7769646765742D63';
wwv_flow_api.g_varchar2_table(181) := '6F6E74656E74223E27202B207569772E76616C7565732E737461727454696D65466D74202B202720746F2027202B207569772E76616C7565732E656E6454696D65466D74202B20273C2F74643E273B0D0A2020202020202020207D0D0A20202020202020';
wwv_flow_api.g_varchar2_table(182) := '20200D0A2020202020202020207363686564756C6548746D6C202B3D200D0A2020202020202020202020202020272020203C2F74723E270D0A2020202020202020202020202B20272020203C74723E270D0A2020202020202020202020202B2027202020';
wwv_flow_api.g_varchar2_table(183) := '2020203C746820636C6173733D2275692D7769646765742D686561646572223E526570656174733A3C2F74683E270D0A2020202020202020202020202B20272020202020203C746420636C6173733D2275692D7769646765742D636F6E74656E74223E27';
wwv_flow_api.g_varchar2_table(184) := '202B207569772E5F63616C656E64617253756D6D617279287569772E76616C7565732E73763429202B20273C2F74643E270D0A2020202020202020202020202B20272020203C2F74723E270D0A2020202020202020202020202B20272020203C74723E27';
wwv_flow_api.g_varchar2_table(185) := '0D0A2020202020202020202020202B20272020202020203C746820636C6173733D2275692D7769646765742D686561646572223E456E64733A3C2F74683E270D0A2020202020202020202020202B20272020202020203C746420636C6173733D2275692D';
wwv_flow_api.g_varchar2_table(186) := '7769646765742D636F6E74656E74223E27202B207569772E76616C7565732E656E6444617465466D74202B20273C2F74643E270D0A2020202020202020202020202B20272020203C2F74723E270D0A2020202020202020202020202B20273C2F74626F64';
wwv_flow_api.g_varchar2_table(187) := '793E270D0A2020202020202020202020202B20273C2F7461626C653E273B0D0A2020202020207D20656C7365207B0D0A2020202020202020207363686564756C6548746D6C203D0D0A2020202020202020202020202020273C7461626C6520636C617373';
wwv_flow_api.g_varchar2_table(188) := '3D2275692D776964676574223E270D0A2020202020202020202020202B20273C74626F64793E270D0A2020202020202020202020202B20272020203C74723E270D0A2020202020202020202020202B20272020202020203C746820636C6173733D227569';
wwv_flow_api.g_varchar2_table(189) := '2D7769646765742D686561646572223E436C69636B20746F20646566696E65207363686564756C652E2E2E3C2F74683E270D0A2020202020202020202020202B20272020203C2F74723E270D0A2020202020202020202020202B20273C2F74626F64793E';
wwv_flow_api.g_varchar2_table(190) := '270D0A2020202020202020202020202B20273C2F7461626C653E273B0D0A2020202020207D0D0A2020202020202020200D0A2020202020207569772E656C656D656E742E68746D6C287363686564756C6548746D6C293B0D0A2020207D2C0D0A2020205F';
wwv_flow_api.g_varchar2_table(191) := '63616C656E64617253756D6D6172793A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A2020202020207661722072657476616C3B0D0A2020202020200D0A20202020202066756E6374696F6E206F726469';
wwv_flow_api.g_varchar2_table(192) := '6E616C286E756D29207B0D0A202020202020202020766172206C6173744E756D203D207061727365496E74286E756D2E746F537472696E6728292E737562737472282D3129293B0D0A202020202020202020696620286C6173744E756D203E2033207C7C';
wwv_flow_api.g_varchar2_table(193) := '206C6173744E756D203D3D2030207C7C206E756D203D3D203131207C7C206E756D203D3D203132207C7C206E756D203D3D20313329207B0D0A20202020202020202020202072657475726E206E756D202B20277468273B0D0A2020202020202020207D20';
wwv_flow_api.g_varchar2_table(194) := '656C736520696620286C6173744E756D203D3D203129207B0D0A20202020202020202020202072657475726E206E756D202B20277374273B0D0A2020202020202020207D20656C736520696620286C6173744E756D203D3D203229207B0D0A2020202020';
wwv_flow_api.g_varchar2_table(195) := '2020202020202072657475726E206E756D202B20276E64273B0D0A2020202020202020207D20656C736520696620286C6173744E756D203D3D203329207B0D0A20202020202020202020202072657475726E206E756D202B20277264273B0D0A20202020';
wwv_flow_api.g_varchar2_table(196) := '20202020207D0D0A2020202020207D0D0A2020202020200D0A20202020202069662028217569772E76616C7565732E73763429207B0D0A20202020202020202072657476616C203D20272D273B0D0A2020202020207D20656C7365207B20202020202020';
wwv_flow_api.g_varchar2_table(197) := '20200D0A202020202020202020696620287569772E76616C7565732E63616C656E646172537472696E672E66726571203D3D20274441494C592729207B0D0A202020202020202020202020696620287569772E76616C7565732E63616C656E6461725374';
wwv_flow_api.g_varchar2_table(198) := '72696E672E696E74657276616C203D3D203129207B0D0A20202020202020202020202020202072657476616C203D20274461696C79273B0D0A2020202020202020202020207D20656C7365207B0D0A20202020202020202020202020202072657476616C';
wwv_flow_api.g_varchar2_table(199) := '203D202745766572792027202B207569772E76616C7565732E63616C656E646172537472696E672E696E74657276616C202B20272064617973273B0D0A2020202020202020202020207D0D0A2020202020202020207D20656C736520696620287569772E';
wwv_flow_api.g_varchar2_table(200) := '76616C7565732E63616C656E646172537472696E672E66726571203D3D20275745454B4C592729207B0D0A202020202020202020202020766172206279446179446973706C6179203D2027273B0D0A202020202020202020202020766172206461797320';
wwv_flow_api.g_varchar2_table(201) := '3D207569772E76616C7565732E63616C656E646172537472696E672E62796461792E73706C697428272C27293B0D0A2020202020202020202020202020202020202020202020202020200D0A202020202020202020202020696620287569772E76616C75';
wwv_flow_api.g_varchar2_table(202) := '65732E63616C656E646172537472696E672E696E74657276616C203D3D203129207B0D0A20202020202020202020202020202072657476616C203D20275765656B6C79206F6E20273B0D0A2020202020202020202020207D20656C7365207B0D0A202020';
wwv_flow_api.g_varchar2_table(203) := '20202020202020202020202072657476616C203D202745766572792027202B207569772E76616C7565732E63616C656E646172537472696E672E696E74657276616C202B2027207765656B73206F6E20273B0D0A2020202020202020202020207D0D0A20';
wwv_flow_api.g_varchar2_table(204) := '20202020202020202020200D0A202020202020202020202020242E6561636828646179732C2066756E6374696F6E286929207B0D0A20202020202020202020202020202069662028646179732E6C656E677468203E203120262620646179732E6C656E67';
wwv_flow_api.g_varchar2_table(205) := '74682D31203D3D2069297B0D0A2020202020202020202020202020202020206279446179446973706C6179202B3D2027616E6420273B0D0A2020202020202020202020202020207D0D0A2020202020202020202020202020200D0A202020202020202020';
wwv_flow_api.g_varchar2_table(206) := '2020202020206966202874686973203D3D202753554E2729207B0D0A2020202020202020202020202020202020206279446179446973706C6179202B3D202753756E6461792C20273B0D0A2020202020202020202020202020207D20656C736520696620';
wwv_flow_api.g_varchar2_table(207) := '2874686973203D3D20274D4F4E2729207B0D0A2020202020202020202020202020202020206279446179446973706C6179202B3D20274D6F6E6461792C20273B0D0A2020202020202020202020202020207D20656C7365206966202874686973203D3D20';
wwv_flow_api.g_varchar2_table(208) := '275455452729207B0D0A2020202020202020202020202020202020206279446179446973706C6179202B3D2027547565736461792C20273B0D0A2020202020202020202020202020207D20656C7365206966202874686973203D3D20275745442729207B';
wwv_flow_api.g_varchar2_table(209) := '0D0A2020202020202020202020202020202020206279446179446973706C6179202B3D20275765646E65736461792C20273B0D0A2020202020202020202020202020207D20656C7365206966202874686973203D3D20275448552729207B0D0A20202020';
wwv_flow_api.g_varchar2_table(210) := '20202020202020202020202020206279446179446973706C6179202B3D202754687572736461792C20273B0D0A2020202020202020202020202020207D20656C7365206966202874686973203D3D20274652492729207B0D0A2020202020202020202020';
wwv_flow_api.g_varchar2_table(211) := '202020202020206279446179446973706C6179202B3D20274672696461792C20273B0D0A2020202020202020202020202020207D20656C7365206966202874686973203D3D20275341542729207B0D0A2020202020202020202020202020202020206279';
wwv_flow_api.g_varchar2_table(212) := '446179446973706C6179202B3D202753617475726461792C20273B0D0A2020202020202020202020202020207D0D0A2020202020202020202020207D293B0D0A2020202020202020202020202020200D0A20202020202020202020202072657476616C20';
wwv_flow_api.g_varchar2_table(213) := '2B3D206279446179446973706C61792E7265706C616365282F2C5C73242F2C2727293B0D0A2020202020202020202020200D0A20202020202020202020202069662028646179732E6C656E677468203D3D203229207B0D0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(214) := '20202072657476616C203D2072657476616C2E7265706C616365282F2C2F2C2727293B0D0A2020202020202020202020207D0D0A2020202020202020207D20656C736520696620287569772E76616C7565732E63616C656E646172537472696E672E6672';
wwv_flow_api.g_varchar2_table(215) := '6571203D3D20274D4F4E54484C592729207B0D0A202020202020202020202020696620287569772E76616C7565732E63616C656E646172537472696E672E696E74657276616C203D3D203129207B0D0A2020202020202020202020202020207265747661';
wwv_flow_api.g_varchar2_table(216) := '6C203D20274D6F6E74686C79206F6E2074686520273B0D0A2020202020202020202020207D20656C7365207B0D0A20202020202020202020202020202072657476616C203D202745766572792027202B207569772E76616C7565732E63616C656E646172';
wwv_flow_api.g_varchar2_table(217) := '537472696E672E696E74657276616C202B2027206D6F6E746873206F6E2074686520273B0D0A2020202020202020202020207D0D0A2020202020202020202020200D0A202020202020202020202020696620287569772E76616C7565732E63616C656E64';
wwv_flow_api.g_varchar2_table(218) := '6172537472696E672E62796D6F6E746864617929207B0D0A202020202020202020202020202020696620287569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E7468646179203D3D202D3129207B200D0A202020202020202020';
wwv_flow_api.g_varchar2_table(219) := '20202020202020202072657476616C202B3D20276C61737420646179273B0D0A2020202020202020202020202020207D20656C7365207B0D0A20202020202020202020202020202020202072657476616C202B3D206F7264696E616C287569772E76616C';
wwv_flow_api.g_varchar2_table(220) := '7565732E63616C656E646172537472696E672E62796D6F6E7468646179293B0D0A2020202020202020202020202020207D0D0A2020202020202020202020207D20656C736520696620287569772E76616C7565732E63616C656E646172537472696E672E';
wwv_flow_api.g_varchar2_table(221) := '627964617929207B0D0A202020202020202020202020202020696620287061727365496E74287569772E76616C7565732E63616C656E646172537472696E672E627964617929203D3D202D3129207B0D0A20202020202020202020202020202020202072';
wwv_flow_api.g_varchar2_table(222) := '657476616C202B3D20276C61737420273B0D0A2020202020202020202020202020207D20656C7365207B0D0A20202020202020202020202020202020202072657476616C202B3D206F7264696E616C287061727365496E74287569772E76616C7565732E';
wwv_flow_api.g_varchar2_table(223) := '63616C656E646172537472696E672E62796461792929202B202720273B0D0A2020202020202020202020202020207D0D0A2020202020202020202020202020200D0A20202020202020202020202020202072657476616C202B3D20242E64617465706963';
wwv_flow_api.g_varchar2_table(224) := '6B65722E666F726D61744461746528274444272C207569772E76616C7565732E737461727444617465293B0D0A2020202020202020202020207D0D0A2020202020202020207D20656C736520696620287569772E76616C7565732E63616C656E64617253';
wwv_flow_api.g_varchar2_table(225) := '7472696E672E66726571203D3D2027594541524C592729207B0D0A20202020202020202020202072657476616C203D2027596561726C79206F6E2074686520270D0A2020202020202020202020202020202B206F7264696E616C287569772E76616C7565';
wwv_flow_api.g_varchar2_table(226) := '732E63616C656E646172537472696E672E62796D6F6E7468646179290D0A2020202020202020202020202020202B2027206F6620270D0A2020202020202020202020202020202B20242E646174657069636B65722E666F726D61744461746528274D4D27';
wwv_flow_api.g_varchar2_table(227) := '2C207569772E76616C7565732E737461727444617465293B0D0A2020202020202020207D0D0A2020202020207D0D0A2020202020200D0A20202020202072657475726E2072657476616C3B0D0A2020207D2C0D0A20202073686F774469616C6F673A2066';
wwv_flow_api.g_varchar2_table(228) := '756E6374696F6E2829207B2020202020200D0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A202020202020766172206469616C6F6748746D6C203D0D0A202020202020202020273C6469762069643D22736269705F6469';
wwv_flow_api.g_varchar2_table(229) := '616C6F6722207469746C653D225363686564756C6522207374796C653D22646973706C61793A6E6F6E653B223E3C7461626C652069643D22736269705F656469745F7461626C65223E270D0A2020202020202020202B20273C74626F64793E270D0A2020';
wwv_flow_api.g_varchar2_table(230) := '202020202020202B20273C74723E270D0A2020202020202020202B20272020203C746420636F6C7370616E3D2232223E270D0A2020202020202020202B20272020202020203C6469762069643D22736269705F76616C69646174696F6E5F6572726F7273';
wwv_flow_api.g_varchar2_table(231) := '2220636C6173733D2275692D73746174652D6572726F722075692D636F726E65722D616C6C22207374796C653D22646973706C61793A6E6F6E65223E270D0A2020202020202020202B20272020202020202020203C756C2069643D22736269705F657272';
wwv_flow_api.g_varchar2_table(232) := '6F725F6D65737361676573223E3C2F756C3E270D0A2020202020202020202B20272020202020203C2F6469763E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20273C2F74723E270D0A202020202020202020';
wwv_flow_api.g_varchar2_table(233) := '2B20273C74723E270D0A2020202020202020202B20272020203C7464206E6F777261703D226E6F777261702220616C69676E3D22726967687422207374796C653D2277696474683A31323070783B223E270D0A2020202020202020202B20272020202020';
wwv_flow_api.g_varchar2_table(234) := '203C6C6162656C20666F723D22736269705F7363686564756C655F73746172745F74696D65223E2A2054696D653C2F6C6162656C3E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20272020203C746420616C';
wwv_flow_api.g_varchar2_table(235) := '69676E3D226C656674223E270D0A2020202020202020202B20272020202020203C6469762069643D22736269705F7363686564756C655F73746172745F616E645F656E645F74696D6573223E270D0A2020202020202020202B2027202020202020202020';
wwv_flow_api.g_varchar2_table(236) := '3C696E70757420747970653D2274657874222069643D22736269705F7363686564756C655F73746172745F74696D6522206D61786C656E6774683D2238222073697A653D223822206175746F636F6D706C6574653D224F4646223E270D0A202020202020';
wwv_flow_api.g_varchar2_table(237) := '2020202B20272020202020202020203C7370616E3E746F3C2F7370616E3E270D0A2020202020202020202B20272020202020202020203C696E70757420747970653D2274657874222069643D22736269705F7363686564756C655F656E645F74696D6522';
wwv_flow_api.g_varchar2_table(238) := '206D61786C656E6774683D2238222073697A653D223822206175746F636F6D706C6574653D224F4646223E270D0A2020202020202020202B20272020202020202020203C696E70757420747970653D22636865636B626F78222069643D22736269705F73';
wwv_flow_api.g_varchar2_table(239) := '63686564756C655F74696D655F6164222076616C75653D22414C4C444159223E270D0A2020202020202020202B20272020202020202020203C6C6162656C20666F723D22736269705F7363686564756C655F74696D655F6164223E416C6C204461793C2F';
wwv_flow_api.g_varchar2_table(240) := '6C6162656C3E270D0A2020202020202020202B20272020202020203C2F6469763E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20273C2F74723E270D0A2020202020202020202B20273C74723E270D0A2020';
wwv_flow_api.g_varchar2_table(241) := '202020202020202B20272020203C7464206E6F777261703D226E6F777261702220616C69676E3D227269676874223E270D0A2020202020202020202B20272020202020203C6C6162656C20746162696E6465783D223939392220666F723D22736269705F';
wwv_flow_api.g_varchar2_table(242) := '7363686564756C655F6672657175656E6379223E2A204672657175656E63793C2F6C6162656C3E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20272020203C746420616C69676E3D226C656674223E270D0A';
wwv_flow_api.g_varchar2_table(243) := '2020202020202020202B20272020202020203C73656C6563742069643D22736269705F7363686564756C655F6672657175656E6379222073697A653D2231223E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75';
wwv_flow_api.g_varchar2_table(244) := '653D224F4E4345223E4A757374204F6E63653C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D224441494C59223E4461696C793C2F6F7074696F6E3E270D0A2020202020202020202B';
wwv_flow_api.g_varchar2_table(245) := '20272020202020202020203C6F7074696F6E2076616C75653D225745454B4C59223E5765656B6C793C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D224D4F4E54484C59223E4D6F6E';
wwv_flow_api.g_varchar2_table(246) := '74686C793C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D22594541524C59223E596561726C793C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020203C2F7365';
wwv_flow_api.g_varchar2_table(247) := '6C6563743E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20273C2F74723E270D0A2020202020202020202B20273C74722069643D22736269705F7363686564756C655F696E74657276616C5F726F77223E27';
wwv_flow_api.g_varchar2_table(248) := '0D0A2020202020202020202B20272020203C7464206E6F777261703D226E6F777261702220616C69676E3D227269676874223E270D0A2020202020202020202B20272020202020203C6C6162656C20746162696E6465783D223939392220666F723D2273';
wwv_flow_api.g_varchar2_table(249) := '6269705F7363686564756C655F696E74657276616C223E2A205265637572732065766572793C2F6C6162656C3E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20272020203C746420616C69676E3D226C6566';
wwv_flow_api.g_varchar2_table(250) := '74223E270D0A2020202020202020202B20272020202020203C73656C6563742069643D22736269705F7363686564756C655F696E74657276616C222073697A653D2231223E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E';
wwv_flow_api.g_varchar2_table(251) := '2076616C75653D2231223E313C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D2232223E323C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F70';
wwv_flow_api.g_varchar2_table(252) := '74696F6E2076616C75653D2233223E333C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D2234223E343C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020';
wwv_flow_api.g_varchar2_table(253) := '203C6F7074696F6E2076616C75653D2235223E353C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D2236223E363C2F6F7074696F6E3E270D0A2020202020202020202B202720202020';
wwv_flow_api.g_varchar2_table(254) := '20202020203C6F7074696F6E2076616C75653D2237223E373C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D2238223E383C2F6F7074696F6E3E270D0A2020202020202020202B2027';
wwv_flow_api.g_varchar2_table(255) := '2020202020202020203C6F7074696F6E2076616C75653D2239223E393C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223130223E31303C2F6F7074696F6E3E270D0A202020202020';
wwv_flow_api.g_varchar2_table(256) := '2020202B20272020202020202020203C6F7074696F6E2076616C75653D223131223E31313C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223132223E31323C2F6F7074696F6E3E27';
wwv_flow_api.g_varchar2_table(257) := '0D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223133223E31333C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223134223E31343C2F';
wwv_flow_api.g_varchar2_table(258) := '6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223135223E31353C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D22';
wwv_flow_api.g_varchar2_table(259) := '3136223E31363C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223137223E31373C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E';
wwv_flow_api.g_varchar2_table(260) := '2076616C75653D223138223E31383C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223139223E31393C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020';
wwv_flow_api.g_varchar2_table(261) := '203C6F7074696F6E2076616C75653D223230223E32303C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223231223E32313C2F6F7074696F6E3E270D0A2020202020202020202B2027';
wwv_flow_api.g_varchar2_table(262) := '2020202020202020203C6F7074696F6E2076616C75653D223232223E32323C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223233223E32333C2F6F7074696F6E3E270D0A20202020';
wwv_flow_api.g_varchar2_table(263) := '20202020202B20272020202020202020203C6F7074696F6E2076616C75653D223234223E32343C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223235223E32353C2F6F7074696F6E';
wwv_flow_api.g_varchar2_table(264) := '3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223236223E32363C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223237223E3237';
wwv_flow_api.g_varchar2_table(265) := '3C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223238223E32383C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C7565';
wwv_flow_api.g_varchar2_table(266) := '3D223239223E32393C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020202020203C6F7074696F6E2076616C75653D223330223E33303C2F6F7074696F6E3E270D0A2020202020202020202B20272020202020203C2F73656C656374';
wwv_flow_api.g_varchar2_table(267) := '3E270D0A2020202020202020202B20272020202020203C7370616E2069643D22736269705F7363686564756C655F696E74657276616C5F706F73745F74657874223E207765656B2873293C2F7370616E3E270D0A2020202020202020202B20272020203C';
wwv_flow_api.g_varchar2_table(268) := '2F74643E270D0A2020202020202020202B20273C2F74723E270D0A2020202020202020202B20273C74722069643D22736269705F7363686564756C655F646179735F726F7722223E270D0A2020202020202020202B20272020203C7464206E6F77726170';
wwv_flow_api.g_varchar2_table(269) := '3D226E6F777261702220616C69676E3D227269676874223E270D0A2020202020202020202B20272020202020203C6C6162656C20746162696E6465783D223939392220666F723D22736269705F7363686564756C655F62796461795F77223E2A20446179';
wwv_flow_api.g_varchar2_table(270) := '2873293C2F6C6162656C3E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20272020203C746420616C69676E3D226C656674223E270D0A2020202020202020202B20272020202020203C6669656C6473657420';
wwv_flow_api.g_varchar2_table(271) := '636C6173733D22636865636B626F785F67726F7570222069643D22736269705F7363686564756C655F62796461795F77223E270D0A2020202020202020202B20272020202020202020203C7461626C653E270D0A2020202020202020202B202720202020';
wwv_flow_api.g_varchar2_table(272) := '20202020203C74626F64793E270D0A2020202020202020202B20272020202020202020203C74723E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B20272020202020202020202020202020';
wwv_flow_api.g_varchar2_table(273) := '203C696E70757420747970653D22636865636B626F78222069643D22736269705F7363686564756C655F62796461795F775F30222076616C75653D2253554E223E270D0A2020202020202020202B20272020202020202020202020202020203C6C616265';
wwv_flow_api.g_varchar2_table(274) := '6C20666F723D22736269705F7363686564756C655F62796461795F775F30223E53756E3C2F6C6162656C3E270D0A2020202020202020202B20272020202020202020202020203C2F74643E270D0A2020202020202020202B202720202020202020202020';
wwv_flow_api.g_varchar2_table(275) := '20203C74643E270D0A2020202020202020202B20272020202020202020202020202020203C696E70757420747970653D22636865636B626F78222069643D22736269705F7363686564756C655F62796461795F775F31222076616C75653D224D4F4E223E';
wwv_flow_api.g_varchar2_table(276) := '270D0A2020202020202020202B20272020202020202020202020202020203C6C6162656C20666F723D22736269705F7363686564756C655F62796461795F775F31223E4D6F6E3C2F6C6162656C3E270D0A2020202020202020202B202720202020202020';
wwv_flow_api.g_varchar2_table(277) := '20202020203C2F74643E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B20272020202020202020202020202020203C696E70757420747970653D22636865636B626F78222069643D227362';
wwv_flow_api.g_varchar2_table(278) := '69705F7363686564756C655F62796461795F775F32222076616C75653D22545545223E270D0A2020202020202020202B20272020202020202020202020202020203C6C6162656C20666F723D22736269705F7363686564756C655F62796461795F775F32';
wwv_flow_api.g_varchar2_table(279) := '223E5475653C2F6C6162656C3E270D0A2020202020202020202B20272020202020202020202020203C2F74643E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B2027202020202020202020';
wwv_flow_api.g_varchar2_table(280) := '2020202020203C696E70757420747970653D22636865636B626F78222069643D22736269705F7363686564756C655F62796461795F775F33222076616C75653D22574544223E270D0A2020202020202020202B2027202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(281) := '3C6C6162656C20666F723D22736269705F7363686564756C655F62796461795F775F33223E5765643C2F6C6162656C3E270D0A2020202020202020202B20272020202020202020202020203C2F74643E270D0A2020202020202020202B20272020202020';
wwv_flow_api.g_varchar2_table(282) := '202020203C2F74723E270D0A2020202020202020202B20272020202020202020203C74723E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B20272020202020202020202020202020203C69';
wwv_flow_api.g_varchar2_table(283) := '6E70757420747970653D22636865636B626F78222069643D22736269705F7363686564756C655F62796461795F775F34222076616C75653D22544855223E270D0A2020202020202020202B20272020202020202020202020202020203C6C6162656C2066';
wwv_flow_api.g_varchar2_table(284) := '6F723D22736269705F7363686564756C655F62796461795F775F34223E5468753C2F6C6162656C3E270D0A2020202020202020202B20272020202020202020202020203C2F74643E270D0A2020202020202020202B20272020202020202020202020203C';
wwv_flow_api.g_varchar2_table(285) := '74643E270D0A2020202020202020202B20272020202020202020202020202020203C696E70757420747970653D22636865636B626F78222069643D22736269705F7363686564756C655F62796461795F775F35222076616C75653D22465249223E270D0A';
wwv_flow_api.g_varchar2_table(286) := '2020202020202020202B20272020202020202020202020202020203C6C6162656C20666F723D22736269705F7363686564756C655F62796461795F775F35223E4672693C2F6C6162656C3E270D0A2020202020202020202B202720202020202020202020';
wwv_flow_api.g_varchar2_table(287) := '20203C2F74643E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B20272020202020202020202020202020203C696E70757420747970653D22636865636B626F78222069643D22736269705F';
wwv_flow_api.g_varchar2_table(288) := '7363686564756C655F62796461795F775F36222076616C75653D22534154223E270D0A2020202020202020202B20272020202020202020202020202020203C6C6162656C20666F723D22736269705F7363686564756C655F62796461795F775F36223E53';
wwv_flow_api.g_varchar2_table(289) := '61743C2F6C6162656C3E270D0A2020202020202020202B20272020202020202020202020203C2F74643E270D0A2020202020202020202B20272020202020202020203C2F74723E270D0A2020202020202020202B20272020202020202020203C2F74626F';
wwv_flow_api.g_varchar2_table(290) := '64793E270D0A2020202020202020202B20272020202020202020203C2F7461626C653E270D0A2020202020202020202B20272020202020203C2F6669656C647365743E270D0A2020202020202020202B20272020203C2F74643E270D0A20202020202020';
wwv_flow_api.g_varchar2_table(291) := '20202B20273C2F74723E270D0A2020202020202020202B20273C74722069643D22736269705F7363686564756C655F6D6F6E74686C795F747970655F726F77223E270D0A2020202020202020202B20272020203C7464206E6F777261703D226E6F777261';
wwv_flow_api.g_varchar2_table(292) := '702220616C69676E3D227269676874223E270D0A2020202020202020202B20272020202020203C6C6162656C20746162696E6465783D223939392220666F723D22736269705F6D6F6E74686C795F6279223E2A2042793C2F6C6162656C3E270D0A202020';
wwv_flow_api.g_varchar2_table(293) := '2020202020202B20272020203C2F74643E270D0A2020202020202020202B20272020203C746420616C69676E3D226C656674223E270D0A2020202020202020202B20272020202020203C6669656C6473657420636C6173733D22636865636B626F785F67';
wwv_flow_api.g_varchar2_table(294) := '726F7570222069643D22736269705F6D6F6E74686C795F6279223E270D0A2020202020202020202B20272020202020202020203C7461626C653E270D0A2020202020202020202B20272020202020202020203C74626F64793E270D0A2020202020202020';
wwv_flow_api.g_varchar2_table(295) := '202B20272020202020202020203C74723E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B20272020202020202020202020202020203C696E707574206E616D653D226D6F6E74686C795F74';
wwv_flow_api.g_varchar2_table(296) := '797065222069643D22736269705F7363686564756C655F6D6F6E74686C795F747970655F646F6D2220747970653D22726164696F222076616C75653D2242594D4F4E5448444159223E270D0A2020202020202020202B2027202020202020202020202020';
wwv_flow_api.g_varchar2_table(297) := '2020203C6C6162656C20666F723D22736269705F7363686564756C655F6D6F6E74686C795F747970655F646F6D223E446179206F6620746865206D6F6E74683C2F6C6162656C3E270D0A2020202020202020202B20272020202020202020202020203C2F';
wwv_flow_api.g_varchar2_table(298) := '74643E270D0A2020202020202020202B20272020202020202020203C2F74723E270D0A2020202020202020202B20272020202020202020203C74722069643D22736269705F7363686564756C655F6D6F6E74686C795F747970655F6C646F6D5F726F7722';
wwv_flow_api.g_varchar2_table(299) := '3E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B20272020202020202020202020202020203C696E707574206E616D653D226D6F6E74686C795F74797065222069643D22736269705F7363';
wwv_flow_api.g_varchar2_table(300) := '686564756C655F6D6F6E74686C795F747970655F6C646F6D2220747970653D22726164696F222076616C75653D2242594D4F4E5448444159223E270D0A2020202020202020202B20272020202020202020202020202020203C6C6162656C20666F723D22';
wwv_flow_api.g_varchar2_table(301) := '736269705F7363686564756C655F6D6F6E74686C795F747970655F6C646F6D223E4C61737420646179206F6620746865206D6F6E74683C2F6C6162656C3E270D0A2020202020202020202B20272020202020202020202020203C2F74643E270D0A202020';
wwv_flow_api.g_varchar2_table(302) := '2020202020202B20272020202020202020203C2F74723E270D0A2020202020202020202B20272020202020202020203C74723E270D0A2020202020202020202B20272020202020202020202020203C74643E270D0A2020202020202020202B2027202020';
wwv_flow_api.g_varchar2_table(303) := '2020202020202020202020203C696E707574206E616D653D226D6F6E74686C795F74797065222069643D22736269705F7363686564756C655F6D6F6E74686C795F747970655F646F772220747970653D22726164696F222076616C75653D224259444159';
wwv_flow_api.g_varchar2_table(304) := '223E270D0A2020202020202020202B20272020202020202020202020202020203C6C6162656C20666F723D22736269705F7363686564756C655F6D6F6E74686C795F747970655F646F77223E446179206F6620746865207765656B3C2F6C6162656C3E27';
wwv_flow_api.g_varchar2_table(305) := '0D0A2020202020202020202B20272020202020202020202020203C2F74643E270D0A2020202020202020202B20272020202020202020203C2F74723E270D0A2020202020202020202B20272020202020202020203C2F74626F64793E270D0A2020202020';
wwv_flow_api.g_varchar2_table(306) := '202020202B20272020202020202020203C2F7461626C653E270D0A2020202020202020202B20272020202020203C2F6669656C647365743E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20273C2F74723E27';
wwv_flow_api.g_varchar2_table(307) := '0D0A2020202020202020202B20273C74723E270D0A2020202020202020202B20272020203C746420616C69676E3D227269676874223E270D0A2020202020202020202B20272020202020203C6C6162656C20746162696E6465783D223939392220666F72';
wwv_flow_api.g_varchar2_table(308) := '3D22736269705F7363686564756C655F73746172745F64617465223E2A20537461727420446174653C2F6C6162656C3E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20272020203C746420616C69676E3D22';
wwv_flow_api.g_varchar2_table(309) := '6C656674223E270D0A2020202020202020202B20272020202020203C696E70757420747970653D2274657874222069643D22736269705F7363686564756C655F73746172745F64617465222073697A653D223135223E270D0A2020202020202020202B20';
wwv_flow_api.g_varchar2_table(310) := '272020203C2F74643E270D0A2020202020202020202B20273C2F74723E270D0A2020202020202020202B20273C74722069643D22736269705F7363686564756C655F656E645F646174655F726F77223E270D0A2020202020202020202B20272020203C74';
wwv_flow_api.g_varchar2_table(311) := '64206E6F777261703D226E6F777261702220616C69676E3D227269676874223E270D0A2020202020202020202B20272020202020203C6C6162656C20746162696E6465783D223939392220666F723D22736269705F7363686564756C655F656E645F6461';
wwv_flow_api.g_varchar2_table(312) := '7465223E456E6420446174653C2F6C6162656C3E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20272020203C746420616C69676E3D226C656674223E270D0A2020202020202020202B20272020202020203C';
wwv_flow_api.g_varchar2_table(313) := '696E70757420747970653D2274657874222069643D22736269705F7363686564756C655F656E645F64617465222073697A653D223135223E270D0A2020202020202020202B20272020203C2F74643E270D0A2020202020202020202B20273C2F74723E27';
wwv_flow_api.g_varchar2_table(314) := '0D0A2020202020202020202B20273C2F74626F64793E270D0A2020202020202020202B20273C2F7461626C653E3C2F6469763E273B0D0A2020202020202020200D0A202020202020242827626F647927292E617070656E64280D0A202020202020202020';
wwv_flow_api.g_varchar2_table(315) := '6469616C6F6748746D6C0D0A202020202020293B0D0A2020202020200D0A2020202020207569772E5F70617273654974656D56616C75657328293B0D0A2020202020207569772E5F696E6974456C656D656E747328293B0D0A2020202020200D0A202020';
wwv_flow_api.g_varchar2_table(316) := '202020696620287569772E76616C7565732E6475726174696F6E5365636F6E6473203D3D20383634303029207B0D0A2020202020202020207569772E656C656D656E74732E24616C6C4461792E617474722827636865636B6564272C2027636865636B65';
wwv_flow_api.g_varchar2_table(317) := '6427293B0D0A20202020202020202024282764697623736269705F7363686564756C655F73746172745F616E645F656E645F74696D6573203E202A3A6E6F7428696E70757423736269705F7363686564756C655F74696D655F61642C6C6162656C292729';
wwv_flow_api.g_varchar2_table(318) := '2E6869646528293B0D0A2020202020207D20656C7365207B0D0A2020202020202020207569772E656C656D656E74732E24737461727454696D652E76616C287569772E76616C7565732E737461727454696D65466D74293B0D0A20202020202020202075';
wwv_flow_api.g_varchar2_table(319) := '69772E656C656D656E74732E24656E6454696D652E76616C287569772E76616C7565732E656E6454696D65466D74293B0D0A2020202020207D0D0A202020202020202020200D0A2020202020207569772E656C656D656E74732E24616C6C4461792E636C';
wwv_flow_api.g_varchar2_table(320) := '69636B2866756E6374696F6E2829207B0D0A20202020202020202024616C6C446179203D20242874686973293B0D0A2020202020202020200D0A2020202020202020206966202824616C6C4461792E617474722827636865636B65642729203D3D3D2074';
wwv_flow_api.g_varchar2_table(321) := '72756529207B0D0A20202020202020202020202024282764697623736269705F7363686564756C655F73746172745F616E645F656E645F74696D6573203E202A3A6E6F7428696E70757423736269705F7363686564756C655F74696D655F61642C6C6162';
wwv_flow_api.g_varchar2_table(322) := '656C2927292E6869646528293B0D0A2020202020202020207D20656C7365207B0D0A20202020202020202020202024282764697623736269705F7363686564756C655F73746172745F616E645F656E645F74696D6573203E202A3A6E6F7428696E707574';
wwv_flow_api.g_varchar2_table(323) := '23736269705F7363686564756C655F74696D655F61642C6C6162656C2927292E73686F7728293B0D0A2020202020202020207D0D0A2020202020202020200D0A2020202020202020207569772E5F73686F774475726174696F6E5761726E696E6728293B';
wwv_flow_api.g_varchar2_table(324) := '0D0A2020202020207D293B0D0A2020202020200D0A2020202020207569772E656C656D656E74732E246672657175656E63790D0A2020202020202020202E76616C287569772E76616C7565732E63616C656E646172537472696E672E66726571290D0A20';
wwv_flow_api.g_varchar2_table(325) := '20202020202020202E62696E6428276368616E6765272C2066756E6374696F6E2829207B0D0A2020202020202020202020207569772E5F7265736574456469745669657728293B0D0A2020202020202020207D293B0D0A2020202020202020200D0A2020';
wwv_flow_api.g_varchar2_table(326) := '202020207569772E656C656D656E74732E24696E74657276616C2E76616C287569772E76616C7565732E63616C656E646172537472696E672E696E74657276616C293B0D0A2020202020200D0A202020202020696620287569772E76616C7565732E6361';
wwv_flow_api.g_varchar2_table(327) := '6C656E646172537472696E672E66726571203D3D20275745454B4C592729207B0D0A2020202020202020207661722064617973203D207569772E76616C7565732E63616C656E646172537472696E672E62796461792E73706C697428272C27293B0D0A20';
wwv_flow_api.g_varchar2_table(328) := '20202020202020200D0A202020202020202020242E6561636828646179732C2066756E6374696F6E28692C2076616C297B0D0A2020202020202020202020202428273A696E7075745B69645E3D22736269705F7363686564756C655F62796461795F7722';
wwv_flow_api.g_varchar2_table(329) := '5D5B76616C75653D2227202B2076616C202B2027225D27292E617474722827636865636B6564272C27636865636B656427293B0D0A2020202020202020207D293B0D0A2020202020207D20656C736520696620287569772E76616C7565732E63616C656E';
wwv_flow_api.g_varchar2_table(330) := '646172537472696E672E66726571203D3D20274D4F4E54484C592729207B2020202020202020200D0A202020202020202020696620287569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E746864617929207B0D0A2020202020';
wwv_flow_api.g_varchar2_table(331) := '20202020202020696620287061727365496E74287569772E76616C7565732E63616C656E646172537472696E672E62796D6F6E746864617929203D3D202D3129207B0D0A20202020202020202020202020202024282723736269705F7363686564756C65';
wwv_flow_api.g_varchar2_table(332) := '5F6D6F6E74686C795F747970655F6C646F6D27292E617474722827636865636B6564272C27636865636B656427293B0D0A2020202020202020202020207D20656C7365207B0D0A20202020202020202020202020202024282723736269705F7363686564';
wwv_flow_api.g_varchar2_table(333) := '756C655F6D6F6E74686C795F747970655F646F6D27292E617474722827636865636B6564272C27636865636B656427293B0D0A2020202020202020202020207D0D0A2020202020202020207D20656C736520696620287569772E76616C7565732E63616C';
wwv_flow_api.g_varchar2_table(334) := '656E646172537472696E672E627964617929207B0D0A20202020202020202020202024282723736269705F7363686564756C655F6D6F6E74686C795F747970655F646F7727292E617474722827636865636B6564272C27636865636B656427293B0D0A20';
wwv_flow_api.g_varchar2_table(335) := '20202020202020207D0D0A2020202020207D0D0A2020202020202020200D0A2020202020207569772E656C656D656E74732E247374617274446174650D0A2020202020202020202E76616C287569772E76616C7565732E737461727444617465466D7429';
wwv_flow_api.g_varchar2_table(336) := '0D0A2020202020202020202E6368616E67652866756E6374696F6E2829207B0D0A2020202020202020202020207569772E5F7265736574456469745669657728293B0D0A2020202020202020207D293B0D0A2020202020200D0A20202020202069662028';
wwv_flow_api.g_varchar2_table(337) := '7569772E76616C7565732E656E644461746529207B0D0A2020202020202020207569772E656C656D656E74732E24656E64446174652E76616C287569772E76616C7565732E656E6444617465466D74293B0D0A2020202020207D0D0A2020202020200D0A';
wwv_flow_api.g_varchar2_table(338) := '2020202020207569772E5F7265736574456469745669657728293B0D0A2020202020200D0A202020202020242827696E70757423736269705F7363686564756C655F73746172745F646174652C20696E70757423736269705F7363686564756C655F656E';
wwv_flow_api.g_varchar2_table(339) := '645F6461746527292E646174657069636B6572287B0D0A20202020202020202064617465466F726D61743A207569772E6F7074696F6E732E64617465466F726D61740D0A2020202020207D293B0D0A2020202020200D0A2020202020207569772E656C65';
wwv_flow_api.g_varchar2_table(340) := '6D656E74732E246469616C6F672E6469616C6F67287B0D0A202020202020202020726573697A61626C653A2066616C73652C0D0A2020202020202020206D6F64616C3A20747275652C0D0A20202020202020202077696474683A203435302C0D0A090909';
wwv_flow_api.g_varchar2_table(341) := '627574746F6E733A207B0D0A09090909274F6B273A2066756E6374696F6E2829207B0D0A2020202020202020202020202020207569772E5F76616C6964617465496E7075747328293B0D0A2020202020202020202020202020200D0A2020202020202020';
wwv_flow_api.g_varchar2_table(342) := '2020202020202069662028242827756C23736269705F6572726F725F6D65737361676573206C6927292E6C656E67746829207B0D0A2020202020202020202020202020202020207569772E656C656D656E74732E2476616C69646174696F6E4572726F72';
wwv_flow_api.g_varchar2_table(343) := '730D0A2020202020202020202020202020202020202020202E73686F7728290D0A2020202020202020202020202020202020202020202E656666656374282770756C73617465272C207B74696D65733A20337D2C2027736C6F7727293B0D0A2020202020';
wwv_flow_api.g_varchar2_table(344) := '202020202020202020207D20656C7365207B0D0A2020202020202020202020202020202020207569772E5F757064617465417065784974656D28293B0D0A2020202020202020202020202020202020207569772E5F70617273654974656D56616C756573';
wwv_flow_api.g_varchar2_table(345) := '28293B0D0A2020202020202020202020202020202020207569772E7265736574446973706C61795669657728293B0D0A202020202020202020202020202020202020242874686973292E6469616C6F672827636C6F736527293B0D0A2020202020202020';
wwv_flow_api.g_varchar2_table(346) := '202020202020207D0D0A090909097D2C0D0A0909090943616E63656C3A2066756E6374696F6E2829207B0D0A0909090909242874686973292E6469616C6F672827636C6F736527293B0D0A090909097D0D0A0909097D2C0D0A202020202020202020636C';
wwv_flow_api.g_varchar2_table(347) := '6F73653A2066756E6374696F6E2829207B0D0A2020202020202020202020207569772E656C656D656E74732E247374617274446174652E646174657069636B6572282764657374726F7927293B0D0A2020202020202020202020207569772E656C656D65';
wwv_flow_api.g_varchar2_table(348) := '6E74732E24656E64446174652E646174657069636B6572282764657374726F7927293B0D0A2020202020202020202020207569772E5F636C6F736554696D655069636B657228293B0D0A202020202020202020202020242874686973292E6469616C6F67';
wwv_flow_api.g_varchar2_table(349) := '282764657374726F7927293B0D0A2020202020202020202020207569772E656C656D656E74732E246469616C6F672E72656D6F766528293B0D0A2020202020202020207D0D0A2020202020207D293B0D0A2020202020200D0A202020202020242827696E';
wwv_flow_api.g_varchar2_table(350) := '70757423736269705F7363686564756C655F73746172745F74696D652C696E70757423736269705F7363686564756C655F656E645F74696D6527290D0A2020202020202020202E747269676765722827626C75722729202F2F6469616C6F67206C696B65';
wwv_flow_api.g_varchar2_table(351) := '7320746F2073657420666F6375730D0A2020202020202020202E666F6375732866756E6374696F6E2829207B0D0A202020202020202020202020242874686973292E747269676765722827636C69636B27293B200D0A2020202020202020202020207265';
wwv_flow_api.g_varchar2_table(352) := '7475726E2066616C73653B0D0A2020202020202020207D290D0A2020202020202020202E636C69636B2866756E6374696F6E2829207B0D0A2020202020202020202020207569772E656C656D656E74732E24666F637573656454696D65203D2024287468';
wwv_flow_api.g_varchar2_table(353) := '6973293B0D0A2020202020202020202020207569772E656C656D656E74732E24666F637573656454696D652E617474722827646174612D6F72672D74696D65272C207569772E656C656D656E74732E24666F637573656454696D652E76616C2829293B0D';
wwv_flow_api.g_varchar2_table(354) := '0A2020202020202020202020207569772E5F73686F7754696D655069636B657228293B0D0A2020202020202020207D290D0A2020202020202020202E626C75722866756E6374696F6E2829207B2F2F52656D6F7665207370616365737320616E64206164';
wwv_flow_api.g_varchar2_table(355) := '64206C656164696E6720223022206966206F6D69747465640D0A202020202020202020202020766172202474696D65203D20242874686973293B0D0A2020202020202020202020207661722074696D65537472203D202474696D652E76616C28293B0D0A';
wwv_flow_api.g_varchar2_table(356) := '202020202020202020202020766172206E657754696D655374723B0D0A2020202020202020202020200D0A20202020202020202020202074696D65537472203D2074696D655374722E7265706C616365282F5C732F672C202727293B0D0A202020202020';
wwv_flow_api.g_varchar2_table(357) := '2020202020202474696D652E76616C2874696D65537472293B0D0A2020202020202020202020200D0A202020202020202020202020747279207B0D0A202020202020202020202020202020696620280D0A20202020202020202020202020202020202074';
wwv_flow_api.g_varchar2_table(358) := '696D655374722E73756273747228302C312920213D20300D0A2020202020202020202020202020202020202626207061727365496E742874696D655374722E73756273747228302C32292C20313029203E3D2030200D0A20202020202020202020202020';
wwv_flow_api.g_varchar2_table(359) := '20202020202626207061727365496E742874696D655374722E73756273747228302C32292C20313029203C203130200D0A20202020202020202020202020202029207B0D0A2020202020202020202020202020202020206E657754696D65537472203D20';
wwv_flow_api.g_varchar2_table(360) := '273027202B2074696D655374723B0D0A2020202020202020202020202020202020200D0A202020202020202020202020202020202020696620287569772E5F697356616C696454696D65286E657754696D655374722C207569772E76616C7565732E7573';
wwv_flow_api.g_varchar2_table(361) := '6532346854696D652929207B0D0A2020202020202020202020202020202020202020202474696D652E76616C286E657754696D65537472293B0D0A2020202020202020202020202020202020207D0D0A2020202020202020202020202020207D0D0A2020';
wwv_flow_api.g_varchar2_table(362) := '202020202020202020207D20636174636820286572726F7229207B0D0A2020202020202020202020202020206E756C6C3B0D0A2020202020202020202020207D2020202020202020202020200D0A2020202020202020207D293B0D0A2020202020202020';
wwv_flow_api.g_varchar2_table(363) := '200D0A2020202020207569772E656C656D656E74732E24737461727454696D652E6368616E67652866756E6374696F6E2829207B0D0A2020202020202020207569772E5F7368696674456E6454696D6528293B0D0A2020202020202020207569772E5F73';
wwv_flow_api.g_varchar2_table(364) := '686F774475726174696F6E5761726E696E6728293B0D0A2020202020207D293B0D0A2020202020200D0A2020202020207569772E656C656D656E74732E24656E6454696D652E6368616E67652866756E6374696F6E2829207B0D0A202020202020202020';
wwv_flow_api.g_varchar2_table(365) := '7569772E5F73686F774475726174696F6E5761726E696E6728293B0D0A2020202020207D293B0D0A2020202020200D0A2020202020202428272375692D646174657069636B65722D64697627292E63737328277A2D696E646578272C31313030293B0D0A';
wwv_flow_api.g_varchar2_table(366) := '2020207D2C0D0A2020205F73686F7754696D655069636B65723A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A202020202020766172202473656C656374656454696D653B0D0A20202020202076617220';
wwv_flow_api.g_varchar2_table(367) := '74696D654865696768743B0D0A2020202020207661722074696D65496E6465783B0D0A202020202020766172207363726F6C6C546F703B0D0A2020202020200D0A2020202020206966202824282764697623736269705F74696D655F7069636B65722729';
wwv_flow_api.g_varchar2_table(368) := '2E6C656E677468203D3D203029207B0D0A202020202020202020242827626F647927292E617070656E6428273C6469762069643D22736269705F74696D655F7069636B65722220646174612D666F723D2227202B200D0A20202020202020202020202075';
wwv_flow_api.g_varchar2_table(369) := '69772E656C656D656E74732E24666F637573656454696D652E61747472282769642729202B200D0A202020202020202020202020272220636C6173733D2275692D77696467657422207374796C653D227669736962696C6974793A68696464656E223E3C';
wwv_flow_api.g_varchar2_table(370) := '2F6469763E27293B0D0A2020202020202020200D0A2020202020202020207569772E656C656D656E74732E2474696D655069636B6572203D2024282764697623736269705F74696D655F7069636B657227293B0D0A2020202020202020200D0A20202020';
wwv_flow_api.g_varchar2_table(371) := '20202020207569772E5F6C6F6164547054696D657328293B0D0A2020202020202020200D0A20202020202020202024282764697623736269705F74696D655F7069636B6572206469762E74696D6527290D0A2020202020202020202020202E627574746F';
wwv_flow_api.g_varchar2_table(372) := '6E28290D0A2020202020202020202020202E6D6F7573656F75742866756E6374696F6E2829207B0D0A202020202020202020202020202020696620282124282764697623736269705F74696D655F7069636B6572206469762E61637469766527292E6861';
wwv_flow_api.g_varchar2_table(373) := '73436C617373282775692D73746174652D616374697665272929207B0D0A20202020202020202020202020202020202024282764697623736269705F74696D655F7069636B6572206469762E61637469766527292E616464436C617373282775692D7374';
wwv_flow_api.g_varchar2_table(374) := '6174652D61637469766527290D0A2020202020202020202020202020207D0D0A2020202020202020202020207D293B0D0A2020202020202020200D0A2020202020202020207569772E5F736574547041637469766554696D6528293B0D0A202020202020';
wwv_flow_api.g_varchar2_table(375) := '2020200D0A2020202020202020202473656C656374656454696D65203D2024282764697623736269705F74696D655F7069636B6572206469762E61637469766527293B0D0A20202020202020202074696D65486569676874203D202473656C6563746564';
wwv_flow_api.g_varchar2_table(376) := '54696D652E6F757465724865696768742874727565293B0D0A2020202020202020200D0A2020202020202020207569772E656C656D656E74732E2474696D655069636B65720D0A2020202020202020202020202E637373287B0D0A202020202020202020';
wwv_flow_api.g_varchar2_table(377) := '20202020202027746F70273A207569772E656C656D656E74732E24666F637573656454696D652E6F666673657428292E746F70202B207569772E656C656D656E74732E24666F637573656454696D652E6F7574657248656967687428292C0D0A20202020';
wwv_flow_api.g_varchar2_table(378) := '2020202020202020202020276C656674273A207569772E656C656D656E74732E24666F637573656454696D652E6F666673657428292E6C6566742C0D0A20202020202020202020202020202027686569676874273A2074696D65486569676874202A2037';
wwv_flow_api.g_varchar2_table(379) := '202B20277078272C0D0A202020202020202020202020202020277669736962696C697479273A202776697369626C65270D0A2020202020202020202020207D293B0D0A2020202020202020202020200D0A2020202020202020207569772E5F666F637573';
wwv_flow_api.g_varchar2_table(380) := '547041637469766554696D65282763656E74657227293B0D0A2020202020202020200D0A202020202020202020242827626F647927292E62696E6428276D6F757365646F776E272C207B7569773A207569777D2C207569772E5F68616E646C6554704D6F';
wwv_flow_api.g_varchar2_table(381) := '757365646F776E293B0D0A202020202020202020242827626F647927292E62696E6428276D6F7573657570272C207B7569773A207569777D2C207569772E5F68616E646C6554704D6F7573657570293B0D0A202020202020202020242827626F64792729';
wwv_flow_api.g_varchar2_table(382) := '2E62696E6428276B6579646F776E272C207B7569773A207569777D2C207569772E5F68616E646C6554704B6579646F776E293B0D0A2020202020207D0D0A2020207D2C0D0A2020205F6C6F6164547054696D65733A2066756E6374696F6E2829207B0D0A';
wwv_flow_api.g_varchar2_table(383) := '20202020202076617220756977203D20746869733B0D0A20202020202076617220646174653B0D0A20202020202076617220686F75723B0D0A202020202020766172206D696E3B0D0A20202020202076617220616D706D3B0D0A2020202020200D0A2020';
wwv_flow_api.g_varchar2_table(384) := '20202020696620287569772E656C656D656E74732E24666F637573656454696D652E76616C2829200D0A2020202020202020202626207569772E5F697356616C696454696D65287569772E656C656D656E74732E24666F637573656454696D652E76616C';
wwv_flow_api.g_varchar2_table(385) := '28292C207569772E76616C7565732E75736532346854696D65290D0A20202020202029207B0D0A20202020202020202064617465203D206E6577204461746528323030302C20312C20312C20302C207569772E656C656D656E74732E24666F6375736564';
wwv_flow_api.g_varchar2_table(386) := '54696D652E76616C28292E737562737472696E6728332C2035292C20302C2030293B0D0A2020202020207D20656C736520696620287569772E656C656D656E74732E24666F637573656454696D652E61747472282769642729203D3D2027736269705F73';
wwv_flow_api.g_varchar2_table(387) := '63686564756C655F656E645F74696D6527200D0A2020202020202020202626207569772E656C656D656E74732E24737461727454696D652E76616C2829200D0A2020202020202020202626207569772E5F697356616C696454696D65287569772E656C65';
wwv_flow_api.g_varchar2_table(388) := '6D656E74732E24737461727454696D652E76616C28292C207569772E76616C7565732E75736532346854696D65290D0A20202020202029207B0D0A20202020202020202064617465203D206E6577204461746528323030302C20312C20312C20302C2075';
wwv_flow_api.g_varchar2_table(389) := '69772E656C656D656E74732E24737461727454696D652E76616C28292E737562737472696E6728332C2035292C20302C2030293B0D0A2020202020207D20656C7365207B0D0A20202020202020202064617465203D206E6577204461746528323030302C';
wwv_flow_api.g_varchar2_table(390) := '20312C20312C20302C20302C20302C2030293B0D0A2020202020207D0D0A0D0A20202020202069662028646174652E6765744D696E757465732829203E3D20333029207B0D0A202020202020202020646174652E7365744D696E7574657328646174652E';
wwv_flow_api.g_varchar2_table(391) := '6765744D696E757465732829202D203330293B0D0A2020202020207D0D0A2020202020200D0A202020202020666F722028783D303B20783C3D34373B20782B2B29207B0D0A202020202020202020686F7572203D20646174652E676574486F7572732829';
wwv_flow_api.g_varchar2_table(392) := '3B0D0A202020202020202020616D706D203D20686F7572203C3D203131203F207569772E6F7074696F6E732E616D203A207569772E6F7074696F6E732E706D3B0D0A202020202020202020686F7572203D20686F7572203C3D203131203F20686F757220';
wwv_flow_api.g_varchar2_table(393) := '3A20686F7572202D2031323B0D0A202020202020202020686F7572203D20686F7572203D3D2030203F203132203A20686F75723B0D0A202020202020202020686F7572203D20686F75722E746F537472696E6728292E6C656E677468203D3D2032203F20';
wwv_flow_api.g_varchar2_table(394) := '686F75722E746F537472696E672829203A20273027202B20686F75722E746F537472696E6728293B0D0A2020202020202020206D696E203D20646174652E6765744D696E7574657328292E746F537472696E6728292E6C656E677468203D3D2032203F20';
wwv_flow_api.g_varchar2_table(395) := '646174652E6765744D696E7574657328292E746F537472696E672829203A20273027202B20646174652E6765744D696E7574657328292E746F537472696E6728293B0D0A2020202020202020200D0A2020202020202020207569772E656C656D656E7473';
wwv_flow_api.g_varchar2_table(396) := '2E2474696D655069636B65722E617070656E6428273C64697620636C6173733D2274696D65223E27202B20686F7572202B20273A27202B206D696E202B20616D706D202B20273C2F6469763E27293B0D0A2020202020202020200D0A2020202020202020';
wwv_flow_api.g_varchar2_table(397) := '20646174652E7365744D696E7574657328646174652E6765744D696E757465732829202B203330293B0D0A2020202020207D0D0A2020207D2C0D0A2020205F736574547041637469766554696D653A2066756E6374696F6E2829207B0D0A202020202020';
wwv_flow_api.g_varchar2_table(398) := '76617220756977203D20746869733B0D0A2020202020207661722074696D65537472696E673B0D0A2020202020200D0A202020202020696620287569772E656C656D656E74732E24666F637573656454696D652E76616C2829200D0A2020202020202020';
wwv_flow_api.g_varchar2_table(399) := '202626207569772E5F697356616C696454696D65287569772E656C656D656E74732E24666F637573656454696D652E76616C28292C207569772E76616C7565732E75736532346854696D652929207B2F2F466F637573207468652074696D6520696E2074';
wwv_flow_api.g_varchar2_table(400) := '686520696E7075740D0A20202020202020202074696D65537472696E67203D207569772E656C656D656E74732E24666F637573656454696D652E76616C28293B0D0A2020202020207D20656C736520696620287569772E656C656D656E74732E24666F63';
wwv_flow_api.g_varchar2_table(401) := '7573656454696D652E61747472282769642729203D3D2027736269705F7363686564756C655F656E645F74696D65270D0A2020202020202020202626207569772E656C656D656E74732E24737461727454696D652E76616C2829200D0A20202020202020';
wwv_flow_api.g_varchar2_table(402) := '20202626207569772E5F697356616C696454696D65287569772E656C656D656E74732E24737461727454696D652E76616C28292C207569772E76616C7565732E75736532346854696D65290D0A20202020202029207B2F2F466F63757320746865207469';
wwv_flow_api.g_varchar2_table(403) := '6D652066726F6D2074686520737461727420696E707574202B206F6E6520686F75720D0A2020202020202020207661722074696D653234203D207569772E5F67657454696D653132746F3234287569772E656C656D656E74732E24737461727454696D65';
wwv_flow_api.g_varchar2_table(404) := '2E76616C2829293B0D0A202020202020202020766172207374617274486F7572203D2074696D6532342E737562737472696E6728302C2032293B0D0A2020202020202020207661722073746172744D696E203D2074696D6532342E737562737472696E67';
wwv_flow_api.g_varchar2_table(405) := '28332C2035293B0D0A202020202020202020766172206375727244617465203D206E6577204461746528323030302C20312C20312C207374617274486F75722C2073746172744D696E2C20302C2030293B0D0A20202020202020202073746172744D696E';
wwv_flow_api.g_varchar2_table(406) := '203D2073746172744D696E2E746F537472696E6728292E6C656E677468203D3D2032203F2073746172744D696E203A20223022202B2073746172744D696E3B0D0A20202020202020202063757272446174652E736574486F757273286375727244617465';
wwv_flow_api.g_varchar2_table(407) := '2E676574486F7572732829202B2031293B0D0A20202020202020202076617220637572724F724E657874486F7572203D2063757272446174652E676574486F75727328293B0D0A202020202020202020766172206E657874416D506D203D20637572724F';
wwv_flow_api.g_varchar2_table(408) := '724E657874486F7572203C3D203131203F207569772E6F7074696F6E732E616D203A207569772E6F7074696F6E732E706D3B0D0A202020202020202020637572724F724E657874486F7572203D20637572724F724E657874486F7572203C3D203131203F';
wwv_flow_api.g_varchar2_table(409) := '20637572724F724E657874486F7572203A20637572724F724E657874486F7572202D2031323B0D0A202020202020202020637572724F724E657874486F7572203D20637572724F724E657874486F7572203D3D2030203F203132203A20637572724F724E';
wwv_flow_api.g_varchar2_table(410) := '657874486F75723B0D0A202020202020202020637572724F724E657874486F7572203D20637572724F724E657874486F75722E746F537472696E6728292E6C656E677468203D3D2032203F20637572724F724E657874486F7572203A20223022202B2063';
wwv_flow_api.g_varchar2_table(411) := '7572724F724E657874486F75723B0D0A20202020202020202074696D65537472696E67203D20637572724F724E657874486F7572202B20273A27202B2073746172744D696E202B206E657874416D506D3B0D0A2020202020207D20656C7365207B2F2F46';
wwv_flow_api.g_varchar2_table(412) := '6F637573207468652063757272656E742066756C6C206F722068616C6620686F75723B2061646420616E20686F757220666F722074686520656E642074696D650D0A202020202020202020766172206375727244617465203D206E657720446174652829';
wwv_flow_api.g_varchar2_table(413) := '3B0D0A20202020202020202076617220637572724D696E203D2063757272446174652E6765744D696E7574657328293B0D0A20202020202020202076617220637572724F724E657874486F7572203D2028637572724D696E203E20333029203F20286375';
wwv_flow_api.g_varchar2_table(414) := '7272446174652E676574486F7572732829203D3D20323329203F2030203A2063757272446174652E676574486F7572732829202B2031203A2063757272446174652E676574486F75727328293B0D0A202020202020202020766172206E657874416D506D';
wwv_flow_api.g_varchar2_table(415) := '203D20637572724F724E657874486F7572203C3D203131203F207569772E6F7074696F6E732E616D203A207569772E6F7074696F6E732E706D3B0D0A202020202020202020637572724F724E657874486F7572203D2028637572724F724E657874486F75';
wwv_flow_api.g_varchar2_table(416) := '72203C3D20313129203F20637572724F724E657874486F7572203A20637572724F724E657874486F7572202D2031323B0D0A202020202020202020637572724F724E657874486F7572203D2028637572724F724E657874486F7572203D3D203029203F20';
wwv_flow_api.g_varchar2_table(417) := '3132203A20637572724F724E657874486F75723B0D0A202020202020202020637572724F724E657874486F7572203D20287569772E656C656D656E74732E24666F637573656454696D652E61747472282769642729203D3D2027736269705F7363686564';
wwv_flow_api.g_varchar2_table(418) := '756C655F656E645F74696D652729203F2028637572724F724E657874486F7572203D3D20313229203F2031203A20637572724F724E657874486F7572202B2031203A20637572724F724E657874486F75723B0D0A202020202020202020637572724F724E';
wwv_flow_api.g_varchar2_table(419) := '657874486F7572203D20637572724F724E657874486F75722E746F537472696E6728292E6C656E677468203D3D2032203F20637572724F724E657874486F75722E746F537472696E672829203A20273027202B20637572724F724E657874486F75722E74';
wwv_flow_api.g_varchar2_table(420) := '6F537472696E6728293B0D0A202020202020202020766172206E6578744D696E203D2028637572724D696E203E20333029203F2027303027203A20273330273B0D0A20202020202020202074696D65537472696E67203D20637572724F724E657874486F';
wwv_flow_api.g_varchar2_table(421) := '7572202B20273A27202B206E6578744D696E202B206E657874416D506D3B0D0A2020202020207D200D0A2020202020200D0A20202020202024282764697623736269705F74696D655F7069636B6572206469762E74696D653A636F6E7461696E73282227';
wwv_flow_api.g_varchar2_table(422) := '202B2074696D65537472696E67202B2027222927292E616464436C61737328276163746976652075692D73746174652D61637469766527293B0D0A2020207D2C0D0A2020205F666F637573547041637469766554696D653A2066756E6374696F6E286C6F';
wwv_flow_api.g_varchar2_table(423) := '636174696F6E29207B0D0A20202020202076617220756977203D20746869733B0D0A202020202020766172202461637454696D65203D2024282764697623736269705F74696D655F7069636B6572206469762E61637469766527293B0D0A202020202020';
wwv_flow_api.g_varchar2_table(424) := '7661722061637454696D65496E646578203D2024282764697623736269705F74696D655F7069636B6572206469762E74696D6527292E696E646578282461637454696D65293B0D0A2020202020207661722061637454696D65486569676874203D202461';
wwv_flow_api.g_varchar2_table(425) := '637454696D652E6F757465724865696768742874727565293B0D0A202020202020766172207363726F6C6C546F703B0D0A2020202020200D0A202020202020696620286C6F636174696F6E203D3D202763656E7465722729207B0D0A2020202020202020';
wwv_flow_api.g_varchar2_table(426) := '206966202861637454696D65496E646578203C3D203229207B0D0A2020202020202020202020207363726F6C6C546F70203D20303B0D0A2020202020202020207D20656C7365207B0D0A2020202020202020202020207363726F6C6C546F70203D202861';
wwv_flow_api.g_varchar2_table(427) := '637454696D65496E646578202D203329202A2061637454696D654865696768743B0D0A2020202020202020207D0D0A2020202020207D20656C736520696620286C6F636174696F6E203D3D2027626F74746F6D2729207B0D0A2020202020202020206966';
wwv_flow_api.g_varchar2_table(428) := '202861637454696D65496E646578203D3D203029207B0D0A2020202020202020202020207569772E5F666F637573547041637469766554696D652827746F7027293B0D0A2020202020202020207D20656C7365207B0D0A20202020202020202020202076';
wwv_flow_api.g_varchar2_table(429) := '61722074696D655069636B6572426F74746F6D203D207569772E656C656D656E74732E2474696D655069636B65722E6F666673657428292E746F70202B207569772E656C656D656E74732E2474696D655069636B65722E68656967687428293B0D0A2020';
wwv_flow_api.g_varchar2_table(430) := '202020202020202020207661722061637454696D65426F74746F6D203D202461637454696D652E6F666673657428292E746F70202B2061637454696D654865696768740D0A2020202020202020202020200D0A2020202020202020202020206966202874';
wwv_flow_api.g_varchar2_table(431) := '696D655069636B6572426F74746F6D202D2061637454696D65426F74746F6D203C203029207B0D0A2020202020202020202020202020207569772E656C656D656E74732E2474696D655069636B65722E7363726F6C6C546F70282861637454696D65496E';
wwv_flow_api.g_varchar2_table(432) := '646578202D203629202A2061637454696D65486569676874290D0A2020202020202020202020207D0D0A2020202020202020207D0D0A2020202020207D20656C736520696620286C6F636174696F6E203D3D2027746F702729207B0D0A20202020202020';
wwv_flow_api.g_varchar2_table(433) := '20206966202861637454696D65496E646578203D3D20343729207B0D0A2020202020202020202020207569772E5F666F637573547041637469766554696D652827626F74746F6D27293B0D0A2020202020202020207D20656C7365207B0D0A2020202020';
wwv_flow_api.g_varchar2_table(434) := '202020202020207661722074696D655069636B6572546F70203D207569772E656C656D656E74732E2474696D655069636B65722E6F666673657428292E746F703B0D0A2020202020202020202020207661722061637454696D65546F70203D2024616374';
wwv_flow_api.g_varchar2_table(435) := '54696D652E6F666673657428292E746F703B0D0A2020202020202020202020200D0A2020202020202020202020206966202874696D655069636B6572546F70202D2061637454696D65546F70203E203029207B0D0A202020202020202020202020202020';
wwv_flow_api.g_varchar2_table(436) := '7569772E656C656D656E74732E2474696D655069636B65722E7363726F6C6C546F70282861637454696D65496E64657829202A2061637454696D65486569676874290D0A2020202020202020202020207D0D0A2020202020202020207D0D0A2020202020';
wwv_flow_api.g_varchar2_table(437) := '207D0D0A2020202020200D0A2020202020207569772E656C656D656E74732E2474696D655069636B65722E7363726F6C6C546F70287363726F6C6C546F70293B0D0A2020207D2C0D0A2020205F68616E646C6554704D6F757365646F776E3A2066756E63';
wwv_flow_api.g_varchar2_table(438) := '74696F6E286576656E744F626A29207B0D0A20202020202076617220756977203D206576656E744F626A2E646174612E7569773B0D0A2020202020207661722024746172676574203D2024286576656E744F626A2E746172676574293B0D0A2020202020';
wwv_flow_api.g_varchar2_table(439) := '200D0A20202020202069662028247461726765742E706172656E7473282764697623736269705F74696D655F7069636B657227292E6C656E6774680D0A2020202020202020207C7C20247461726765742E61747472282769642729203D3D202773626970';
wwv_flow_api.g_varchar2_table(440) := '5F74696D655F7069636B65722729207B0D0A20202020202020202072657475726E20747275653B0D0A2020202020207D20656C73652069662028247461726765742E61747472282769642729203D3D207569772E656C656D656E74732E24666F63757365';
wwv_flow_api.g_varchar2_table(441) := '6454696D652E6174747228276964272929207B0D0A202020202020202020247461726765742E666F63757328293B0D0A20202020202020202072657475726E20747275653B0D0A2020202020207D20656C7365207B0D0A2020202020202020207569772E';
wwv_flow_api.g_varchar2_table(442) := '5F636C6F736554696D655069636B657228293B0D0A2020202020202020207569772E656C656D656E74732E24666F637573656454696D652E626C757228293B0D0A20202020202020202072657475726E20747275653B0D0A2020202020207D0D0A202020';
wwv_flow_api.g_varchar2_table(443) := '7D2C0D0A2020205F68616E646C6554704D6F75736575703A2066756E6374696F6E286576656E744F626A29207B0D0A20202020202076617220756977203D206576656E744F626A2E646174612E7569773B0D0A2020202020207661722024746172676574';
wwv_flow_api.g_varchar2_table(444) := '203D2024286576656E744F626A2E746172676574293B0D0A2020202020200D0A20202020202069662028247461726765742E706172656E7473282764697623736269705F74696D655F7069636B657227292E6C656E67746829207B0D0A20202020202020';
wwv_flow_api.g_varchar2_table(445) := '20207569772E656C656D656E74732E24666F637573656454696D652E76616C28247461726765742E746578742829293B0D0A2020202020202020207569772E5F636C6F736554696D655069636B657228293B0D0A2020202020202020207569772E656C65';
wwv_flow_api.g_varchar2_table(446) := '6D656E74732E24666F637573656454696D652E7472696767657228276368616E676527293B0D0A20202020202020202072657475726E20747275653B0D0A2020202020207D20656C7365207B0D0A20202020202020202072657475726E20747275653B0D';
wwv_flow_api.g_varchar2_table(447) := '0A2020202020207D0D0A2020207D2C0D0A2020205F68616E646C6554704B6579646F776E3A2066756E6374696F6E286576656E744F626A29207B0D0A20202020202076617220756977203D206576656E744F626A2E646174612E7569773B0D0A20202020';
wwv_flow_api.g_varchar2_table(448) := '2020766172202461637454696D65203D2024282764697623736269705F74696D655F7069636B6572206469762E61637469766527293B0D0A2020202020200D0A202020202020696620286576656E744F626A2E7768696368203D3D20343029207B0D0A20';
wwv_flow_api.g_varchar2_table(449) := '202020202020202076617220246E65787441637454696D65203D20282461637454696D652E6E657874282764697627292E6C656E677468203E203029203F202461637454696D652E6E65787428276469762729203A2024282764697623736269705F7469';
wwv_flow_api.g_varchar2_table(450) := '6D655F7069636B6572206469763A666972737427293B0D0A0D0A2020202020202020202461637454696D652E72656D6F7665436C61737328276163746976652075692D73746174652D61637469766527293B0D0A202020202020202020246E6578744163';
wwv_flow_api.g_varchar2_table(451) := '7454696D652E616464436C61737328276163746976652075692D73746174652D61637469766527293B0D0A2020202020202020200D0A2020202020202020207569772E5F666F637573547041637469766554696D652827626F74746F6D27293B0D0A2020';
wwv_flow_api.g_varchar2_table(452) := '202020207D20656C736520696620286576656E744F626A2E7768696368203D3D20333829207B0D0A20202020202020202076617220247072657641637454696D65203D20282461637454696D652E70726576282764697627292E6C656E677468203E2030';
wwv_flow_api.g_varchar2_table(453) := '29203F202461637454696D652E7072657628276469762729203A2024282764697623736269705F74696D655F7069636B6572206469763A6C61737427293B0D0A0D0A2020202020202020202461637454696D652E72656D6F7665436C6173732827616374';
wwv_flow_api.g_varchar2_table(454) := '6976652075692D73746174652D61637469766527293B0D0A202020202020202020247072657641637454696D652E616464436C61737328276163746976652075692D73746174652D61637469766527293B0D0A2020202020202020200D0A202020202020';
wwv_flow_api.g_varchar2_table(455) := '2020207569772E5F666F637573547041637469766554696D652827746F7027293B0D0A2020202020207D20656C736520696620286576656E744F626A2E7768696368203D3D20313329207B0D0A2020202020202020207569772E656C656D656E74732E24';
wwv_flow_api.g_varchar2_table(456) := '666F637573656454696D652E76616C282461637454696D652E76616C2829293B0D0A2020202020202020207569772E5F636C6F736554696D655069636B657228293B0D0A2020202020207D20656C7365207B0D0A2020202020202020207569772E5F636C';
wwv_flow_api.g_varchar2_table(457) := '6F736554696D655069636B657228293B0D0A2020202020207D0D0A2020207D2C0D0A2020205F636C6F736554696D655069636B65723A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A';
wwv_flow_api.g_varchar2_table(458) := '202020202020696620287569772E656C656D656E74732E2474696D655069636B65722E6C656E67746829207B0D0A2020202020202020207569772E656C656D656E74732E2474696D655069636B65722E72656D6F766528293B0D0A2020202020207D0D0A';
wwv_flow_api.g_varchar2_table(459) := '2020202020200D0A202020202020242827626F647927292E756E62696E6428276D6F757365646F776E272C207569772E5F68616E646C6554704D6F757365646F776E293B0D0A202020202020242827626F647927292E756E62696E6428276D6F75736575';
wwv_flow_api.g_varchar2_table(460) := '70272C207569772E5F68616E646C6554704D6F7573657570293B0D0A202020202020242827626F647927292E756E62696E6428276B6579646F776E272C207569772E5F68616E646C6554704B6579646F776E293B0D0A2020207D2C0D0A2020205F757064';
wwv_flow_api.g_varchar2_table(461) := '617465417065784974656D3A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A202020202020766172206672657175656E6379203D207569772E656C656D656E74732E246672657175656E63792E76616C28';
wwv_flow_api.g_varchar2_table(462) := '293B0D0A20202020202076617220696E74657276616C203D207569772E656C656D656E74732E24696E74657276616C2E76616C28293B0D0A20202020202076617220737461727454696D65203D2027273B0D0A202020202020766172207374617274486F';
wwv_flow_api.g_varchar2_table(463) := '7572203D2027273B0D0A2020202020207661722073746172744D696E203D2027273B0D0A202020202020766172207374617274446174653B0D0A20202020202076617220737461727444617465323B0D0A20202020202076617220737461727444617465';
wwv_flow_api.g_varchar2_table(464) := '537472696E673B0D0A20202020202076617220656E6454696D65203D2027273B0D0A20202020202076617220656E64486F7572203D2027273B0D0A20202020202076617220656E644D696E203D2027273B0D0A20202020202076617220656E6444617465';
wwv_flow_api.g_varchar2_table(465) := '3B0D0A20202020202076617220656E6444617465537472696E673B0D0A20202020202076617220616C6C4461793B0D0A202020202020766172206475726174696F6E537472696E673B0D0A2020202020207661722063616C656E646172537472696E673B';
wwv_flow_api.g_varchar2_table(466) := '0D0A2020202020200D0A202020202020616C6C446179203D207569772E656C656D656E74732E24616C6C4461792E617474722827636865636B656427293B0D0A2020202020200D0A202020202020737461727444617465203D20242E646174657069636B';
wwv_flow_api.g_varchar2_table(467) := '65722E706172736544617465287569772E6F7074696F6E732E64617465466F726D61742C207569772E656C656D656E74732E247374617274446174652E76616C2829293B0D0A2020202020200D0A202020202020696620286672657175656E6379203D3D';
wwv_flow_api.g_varchar2_table(468) := '20274F4E434527207C7C20217569772E656C656D656E74732E24656E64446174652E76616C282929207B0D0A202020202020202020656E6444617465203D20242E646174657069636B65722E706172736544617465287569772E6F7074696F6E732E6461';
wwv_flow_api.g_varchar2_table(469) := '7465466F726D61742C207569772E656C656D656E74732E247374617274446174652E76616C2829293B0D0A2020202020207D20656C7365207B0D0A202020202020202020656E6444617465203D20242E646174657069636B65722E706172736544617465';
wwv_flow_api.g_varchar2_table(470) := '287569772E6F7074696F6E732E64617465466F726D61742C207569772E656C656D656E74732E24656E64446174652E76616C2829293B0D0A2020202020207D0D0A2020202020200D0A20202020202069662028616C6C44617929207B0D0A202020202020';
wwv_flow_api.g_varchar2_table(471) := '2020207374617274486F7572203D20273030273B0D0A20202020202020202073746172744D696E203D20273030273B0D0A202020202020202020656E64486F7572203D20273030273B0D0A202020202020202020656E644D696E203D20273030273B0D0A';
wwv_flow_api.g_varchar2_table(472) := '2020202020202020207374617274446174652E736574486F757273287374617274486F75722C2073746172744D696E2C20302C2030293B200D0A2020202020207D20656C7365207B0D0A202020202020202020737461727454696D65203D207569772E5F';
wwv_flow_api.g_varchar2_table(473) := '67657454696D653132746F3234287569772E656C656D656E74732E24737461727454696D652E76616C2829293B0D0A2020202020202020207374617274486F7572203D20737461727454696D652E737562737472696E6728302C32293B0D0A2020202020';
wwv_flow_api.g_varchar2_table(474) := '2020202073746172744D696E203D20737461727454696D652E737562737472696E6728332C35293B0D0A2020202020202020207374617274446174652E736574486F757273287374617274486F75722C2073746172744D696E2C20302C2030293B200D0A';
wwv_flow_api.g_varchar2_table(475) := '2020202020200D0A202020202020202020656E6454696D65203D207569772E5F67657454696D653132746F3234287569772E656C656D656E74732E24656E6454696D652E76616C2829293B0D0A202020202020202020656E64486F7572203D20656E6454';
wwv_flow_api.g_varchar2_table(476) := '696D652E737562737472696E6728302C32293B0D0A202020202020202020656E644D696E203D20656E6454696D652E737562737472696E6728332C35293B0D0A202020202020202020656E64446174652E736574486F75727328656E64486F75722C2065';
wwv_flow_api.g_varchar2_table(477) := '6E644D696E2C20302C2030293B0D0A2020202020207D0D0A2020202020200D0A202020202020737461727444617465537472696E67203D20242E646174657069636B65722E666F726D617444617465282779796D6D6464272C2073746172744461746529';
wwv_flow_api.g_varchar2_table(478) := '202B207374617274486F7572202B2073746172744D696E3B0D0A202020202020656E6444617465537472696E67203D20286672657175656E6379203D3D20274F4E434527207C7C20217569772E656C656D656E74732E24656E64446174652E76616C2829';
wwv_flow_api.g_varchar2_table(479) := '29203F202727203A20242E646174657069636B65722E666F726D617444617465282779796D6D6464272C20656E644461746529202B20656E64486F7572202B20656E644D696E3B0D0A2020202020200D0A2020202020206475726174696F6E537472696E';
wwv_flow_api.g_varchar2_table(480) := '67203D207569772E5F6765744475726174696F6E28277365636F6E647327293B0D0A2020202020200D0A202020202020696620286672657175656E6379203D3D20274F4E43452729207B0D0A20202020202020202063616C656E646172537472696E6720';
wwv_flow_api.g_varchar2_table(481) := '3D2027273B0D0A2020202020207D20656C736520696620286672657175656E6379203D3D20274441494C592729207B0D0A20202020202020202063616C656E646172537472696E67203D2027465245513D4441494C593B494E54455256414C3D27202B20';
wwv_flow_api.g_varchar2_table(482) := '696E74657276616C202B20273B273B0D0A2020202020207D20656C736520696620286672657175656E6379203D3D20275745454B4C592729207B2020202020202020200D0A20202020202020202063616C656E646172537472696E67203D202746524551';
wwv_flow_api.g_varchar2_table(483) := '3D5745454B4C593B494E54455256414C3D27202B20696E74657276616C202B20273B42594441593D273B0D0A2020202020202020200D0A2020202020202020202428273A696E7075745B69645E3D22736269705F7363686564756C655F62796461795F77';
wwv_flow_api.g_varchar2_table(484) := '225D3A636865636B656427292E656163682866756E6374696F6E286929207B0D0A20202020202020202020202063616C656E646172537472696E67202B3D20746869732E76616C7565202B20272C273B0D0A2020202020202020207D293B0D0A20202020';
wwv_flow_api.g_varchar2_table(485) := '20202020200D0A20202020202020202063616C656E646172537472696E67203D2063616C656E646172537472696E672E7265706C616365282F2C242F2C273B27293B0D0A2020202020207D20656C736520696620286672657175656E6379203D3D20274D';
wwv_flow_api.g_varchar2_table(486) := '4F4E54484C592729207B0D0A202020202020202020766172206D6F6E74686C7954797065203D202428273A726164696F5B6E616D653D226D6F6E74686C795F74797065225D3A636865636B656427292E76616C28293B0D0A2020202020202020200D0A20';
wwv_flow_api.g_varchar2_table(487) := '202020202020202063616C656E646172537472696E67203D2027465245513D4D4F4E54484C593B494E54455256414C3D27202B20696E74657276616C202B20273B27202B206D6F6E74686C7954797065202B20273D273B0D0A2020202020202020200D0A';
wwv_flow_api.g_varchar2_table(488) := '202020202020202020696620286D6F6E74686C7954797065203D3D202742594D4F4E54484441592729207B0D0A2020202020202020202020206966202824282723736269705F7363686564756C655F6D6F6E74686C795F747970655F646F6D27292E6174';
wwv_flow_api.g_varchar2_table(489) := '74722827636865636B65642729203D3D207472756529207B0D0A20202020202020202020202020202063616C656E646172537472696E67202B3D20242E646174657069636B65722E666F726D617444617465282764272C2073746172744461746529202B';
wwv_flow_api.g_varchar2_table(490) := '20273B273B0D0A2020202020202020202020207D20656C7365207B202F2F6D757374206265206C61737420646179206F66206D6F6E74680D0A20202020202020202020202020202063616C656E646172537472696E67202B3D20272D313B273B0D0A2020';
wwv_flow_api.g_varchar2_table(491) := '202020202020202020207D0D0A2020202020202020207D20656C736520696620286D6F6E74686C7954797065203D202742594441592729207B0D0A20202020202020202020202076617220646174653B0D0A202020202020202020202020766172206461';
wwv_flow_api.g_varchar2_table(492) := '794F665765656B203D20242E646174657069636B65722E666F726D617444617465282744272C20737461727444617465292E746F55707065724361736528293B0D0A202020202020202020202020766172206461794F665765656B4E756D203D20303B0D';
wwv_flow_api.g_varchar2_table(493) := '0A202020202020202020202020766172206F7264696E616C3B0D0A2020202020202020202020200D0A202020202020202020202020666F722028783D313B20783C3D33313B20782B2B29207B2020202020202020202020202020200D0A20202020202020';
wwv_flow_api.g_varchar2_table(494) := '2020202020202020747279207B0D0A20202020202020202020202020202020202064617465203D20242E646174657069636B65722E706172736544617465282779796D6D64272C20242E646174657069636B65722E666F726D617444617465282779796D';
wwv_flow_api.g_varchar2_table(495) := '6D272C2073746172744461746529202B2078293B0D0A2020202020202020202020202020202020206966202864617465203E2073746172744461746529207B627265616B3B7D2F2F45786974206C6F6F7020415341500D0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(496) := '202020202020696620286461794F665765656B203D3D20242E646174657069636B65722E666F726D617444617465282744272C2064617465292E746F557070657243617365282929207B0D0A202020202020202020202020202020202020202020646179';
wwv_flow_api.g_varchar2_table(497) := '4F665765656B4E756D202B3D20313B0D0A2020202020202020202020202020202020207D0D0A2020202020202020202020202020207D0D0A202020202020202020202020202020636174636820286572726F724F626A29207B0D0A202020202020202020';
wwv_flow_api.g_varchar2_table(498) := '2020202020202020206E756C6C3B0D0A2020202020202020202020202020207D0D0A2020202020202020202020202020200D0A2020202020202020202020207D0D0A2020202020202020202020200D0A2020202020202020202020206F7264696E616C20';
wwv_flow_api.g_varchar2_table(499) := '3D20286461794F665765656B4E756D203D3D203529203F20272D3127203A206461794F665765656B4E756D3B0D0A0D0A20202020202020202020202063616C656E646172537472696E67202B3D206F7264696E616C202B206461794F665765656B202B20';
wwv_flow_api.g_varchar2_table(500) := '273B273B0D0A2020202020202020207D0D0A2020202020207D20656C736520696620286672657175656E6379203D3D2027594541524C592729207B2020202020202020200D0A20202020202020202063616C656E646172537472696E67203D2027465245';
wwv_flow_api.g_varchar2_table(501) := '513D594541524C593B494E54455256414C3D27202B20696E74657276616C202B20273B273B0D0A20202020202020202063616C656E646172537472696E67202B3D202742594D4F4E54483D27202B20242E646174657069636B65722E666F726D61744461';
wwv_flow_api.g_varchar2_table(502) := '746528276D272C2073746172744461746529202B20273B273B0D0A20202020202020202063616C656E646172537472696E67202B3D202742594D4F4E54484441593D27202B20242E646174657069636B65722E666F726D617444617465282764272C2073';
wwv_flow_api.g_varchar2_table(503) := '746172744461746529202B20273B273B0D0A2020202020207D0D0A2020202020200D0A2020202020202428272327202B20746869732E6F7074696F6E732E7363686564756C654974656D292E76616C280D0A202020202020202020737461727444617465';
wwv_flow_api.g_varchar2_table(504) := '537472696E67202B20277C27202B20656E6444617465537472696E67202B20277C27202B206475726174696F6E537472696E67202B20277C27202B2063616C656E646172537472696E670D0A202020202020293B0D0A2020202020200D0A202020202020';
wwv_flow_api.g_varchar2_table(505) := '72657475726E20747275653B0D0A2020207D2C0D0A2020205F726573657445646974566965773A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A202020202020766172206672657175656E6379203D2075';
wwv_flow_api.g_varchar2_table(506) := '69772E656C656D656E74732E246672657175656E63792E76616C28293B0D0A202020202020766172202464617973526F77203D2024282723736269705F7363686564756C655F646179735F726F7727293B0D0A2020202020207661722024656E64446174';
wwv_flow_api.g_varchar2_table(507) := '65526F77203D2024282723736269705F7363686564756C655F656E645F646174655F726F7727293B0D0A2020202020207661722024696E74657276616C526F77203D2024282723736269705F7363686564756C655F696E74657276616C5F726F7727293B';
wwv_flow_api.g_varchar2_table(508) := '0D0A20202020202076617220246D6F6E746854797065526F77203D2024282723736269705F7363686564756C655F6D6F6E74686C795F747970655F726F7727293B0D0A2020202020200D0A202020202020696620286672657175656E6379203D3D20274F';
wwv_flow_api.g_varchar2_table(509) := '4E43452729207B0D0A20202020202020202024282723736269705F7363686564756C655F696E74657276616C5F706F73745F7465787427292E68746D6C282727293B0D0A2020202020202020202464617973526F772E6869646528293B0D0A2020202020';
wwv_flow_api.g_varchar2_table(510) := '2020202024656E6444617465526F772E6869646528293B0D0A20202020202020202024696E74657276616C526F772E6869646528293B0D0A202020202020202020246D6F6E746854797065526F772E6869646528293B0D0A2020202020207D20656C7365';
wwv_flow_api.g_varchar2_table(511) := '20696620286672657175656E6379203D3D20274441494C592729207B0D0A20202020202020202024282723736269705F7363686564756C655F696E74657276616C5F706F73745F7465787427292E68746D6C28272064617928732927293B0D0A20202020';
wwv_flow_api.g_varchar2_table(512) := '20202020202464617973526F772E6869646528293B0D0A202020202020202020246D6F6E746854797065526F772E6869646528293B0D0A20202020202020202024696E74657276616C526F772E73686F7728293B0D0A20202020202020202024656E6444';
wwv_flow_api.g_varchar2_table(513) := '617465526F772E73686F7728293B0D0A2020202020207D20656C736520696620286672657175656E6379203D3D20275745454B4C592729207B0D0A20202020202020202024282723736269705F7363686564756C655F696E74657276616C5F706F73745F';
wwv_flow_api.g_varchar2_table(514) := '7465787427292E68746D6C2827207765656B28732927293B0D0A202020202020202020246D6F6E746854797065526F772E6869646528293B0D0A20202020202020202024696E74657276616C526F772E73686F7728293B0D0A2020202020202020202464';
wwv_flow_api.g_varchar2_table(515) := '617973526F772E73686F7728293B0D0A20202020202020202024656E6444617465526F772E73686F7728293B0D0A2020202020207D20656C736520696620286672657175656E6379203D3D20274D4F4E54484C592729207B0D0A20202020202020202076';
wwv_flow_api.g_varchar2_table(516) := '617220246C6173744461794F664D6F6E7468526F77203D2024282723736269705F7363686564756C655F6D6F6E74686C795F747970655F6C646F6D5F726F7727293B0D0A20202020202020202076617220737461727444617465203D20242E6461746570';
wwv_flow_api.g_varchar2_table(517) := '69636B65722E706172736544617465287569772E6F7074696F6E732E64617465466F726D61742C207569772E656C656D656E74732E247374617274446174652E76616C2829293B0D0A20202020202020202024282723736269705F7363686564756C655F';
wwv_flow_api.g_varchar2_table(518) := '696E74657276616C5F706F73745F7465787427292E68746D6C2827206D6F6E746828732927293B0D0A2020202020202020202464617973526F772E6869646528293B0D0A20202020202020202024696E74657276616C526F772E73686F7728293B0D0A20';
wwv_flow_api.g_varchar2_table(519) := '2020202020202020246D6F6E746854797065526F772E73686F7728293B0D0A20202020202020202024656E6444617465526F772E73686F7728293B0D0A2020202020202020206966202873746172744461746529207B0D0A202020202020202020202020';
wwv_flow_api.g_varchar2_table(520) := '766172206E65787444617465537472696E67203D20242E646174657069636B65722E666F726D617444617465282779796D6D272C2073746172744461746529200D0A2020202020202020202020202020202B20287061727365496E7428242E6461746570';
wwv_flow_api.g_varchar2_table(521) := '69636B65722E666F726D61744461746528276464272C207374617274446174652929202B2031293B0D0A202020202020202020202020766172206E657874446174653B0D0A2020202020202020202020200D0A202020202020202020202020747279207B';
wwv_flow_api.g_varchar2_table(522) := '0D0A202020202020202020202020202020766172206E65787444617465203D20242E646174657069636B65722E706172736544617465282779796D6D6464272C206E65787444617465537472696E67293B0D0A202020202020202020202020202020246C';
wwv_flow_api.g_varchar2_table(523) := '6173744461794F664D6F6E7468526F772E6869646528293B0D0A2020202020202020202020207D20636174636820286572726F724F626A29207B0D0A202020202020202020202020202020246C6173744461794F664D6F6E7468526F772E73686F772829';
wwv_flow_api.g_varchar2_table(524) := '3B0D0A2020202020202020202020207D0D0A2020202020202020207D20656C7365207B0D0A202020202020202020202020246C6173744461794F664D6F6E7468526F772E6869646528293B0D0A2020202020202020207D0D0A2020202020207D20656C73';
wwv_flow_api.g_varchar2_table(525) := '6520696620286672657175656E6379203D3D2027594541524C592729207B0D0A20202020202020202024282723736269705F7363686564756C655F696E74657276616C5F706F73745F7465787427292E68746D6C2827207965617228732927293B0D0A20';
wwv_flow_api.g_varchar2_table(526) := '20202020202020202464617973526F772E6869646528293B0D0A202020202020202020246D6F6E746854797065526F772E6869646528293B0D0A20202020202020202024696E74657276616C526F772E73686F7728293B0D0A2020202020202020202465';
wwv_flow_api.g_varchar2_table(527) := '6E6444617465526F772E73686F7728293B0D0A2020202020207D0D0A2020207D2C0D0A2020205F76616C6964617465496E707574733A2066756E6374696F6E2829207B0D0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A';
wwv_flow_api.g_varchar2_table(528) := '2020202020207569772E656C656D656E74732E246572726F724D657373616765732E656D707479282727293B0D0A20202020202024282764697623736269705F6469616C6F67202A2E75692D73746174652D6572726F723A6E6F74286469762373626970';
wwv_flow_api.g_varchar2_table(529) := '5F76616C69646174696F6E5F6572726F72732927292E72656D6F7665436C617373282775692D73746174652D6572726F7227293B0D0A2020202020200D0A20202020202069662028217569772E656C656D656E74732E24616C6C4461792E617474722827';
wwv_flow_api.g_varchar2_table(530) := '636865636B65642729297B0D0A2020202020202020207569772E5F76616C6964617465537461727454696D6528293B0D0A2020202020202020207569772E5F76616C6964617465456E6454696D6528293B0D0A2020202020207D0D0A2020202020200D0A';
wwv_flow_api.g_varchar2_table(531) := '2020202020207569772E5F76616C696461746553746172744461746528293B0D0A2020202020200D0A202020202020696620287569772E656C656D656E74732E246672657175656E63792E76616C2829203D3D20275745454B4C592729207B0D0A202020';
wwv_flow_api.g_varchar2_table(532) := '2020202020207569772E5F76616C69646174655765656B6C794461797328293B0D0A2020202020207D20656C736520696620287569772E656C656D656E74732E246672657175656E63792E76616C2829203D3D20274D4F4E54484C592729207B0D0A2020';
wwv_flow_api.g_varchar2_table(533) := '202020202020207569772E5F76616C69646174654D6F6E74686C79427928293B0D0A2020202020207D0D0A2020202020200D0A202020202020696620287569772E656C656D656E74732E246672657175656E63792E76616C282920213D20274F4E434527';
wwv_flow_api.g_varchar2_table(534) := '202626207569772E656C656D656E74732E24656E64446174652E76616C282929207B0D0A2020202020202020207569772E5F76616C6964617465456E644461746528293B0D0A2020202020207D0D0A2020207D2C0D0A2020205F76616C69646174655374';
wwv_flow_api.g_varchar2_table(535) := '61727454696D653A2066756E6374696F6E28297B0D0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A20202020202069662028217569772E656C656D656E74732E24737461727454696D652E76616C282929207B0D0A2020';
wwv_flow_api.g_varchar2_table(536) := '202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E5468652073746172742074696D65206D757374206861766520736F6D652076616C75653C2F6C693E27293B0D0A2020202020202020';
wwv_flow_api.g_varchar2_table(537) := '207569772E656C656D656E74732E24737461727454696D652E616464436C617373282775692D73746174652D6572726F7227293B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A2020202020200D0A2020202020206966202821';
wwv_flow_api.g_varchar2_table(538) := '7569772E5F697356616C696454696D65287569772E656C656D656E74732E24737461727454696D652E76616C28292C207569772E76616C7565732E75736532346854696D652929207B0D0A2020202020202020207569772E656C656D656E74732E246572';
wwv_flow_api.g_varchar2_table(539) := '726F724D657373616765732E617070656E6428273C6C693E5468652073746172742074696D65206973206E6F742076616C69643C2F6C693E27293B0D0A2020202020202020207569772E656C656D656E74732E24737461727454696D652E616464436C61';
wwv_flow_api.g_varchar2_table(540) := '7373282775692D73746174652D6572726F7227293B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A2020207D2C0D0A2020205F76616C6964617465456E6454696D653A2066756E6374696F6E28297B0D0A202020202020766172';
wwv_flow_api.g_varchar2_table(541) := '20756977203D20746869733B0D0A2020202020200D0A20202020202069662028217569772E656C656D656E74732E24656E6454696D652E76616C282929207B0D0A2020202020202020207569772E656C656D656E74732E246572726F724D657373616765';
wwv_flow_api.g_varchar2_table(542) := '732E617070656E6428273C6C693E54686520656E642074696D65206D757374206861766520736F6D652076616C75653C2F6C693E27293B0D0A2020202020202020207569772E656C656D656E74732E24656E6454696D652E616464436C61737328277569';
wwv_flow_api.g_varchar2_table(543) := '2D73746174652D6572726F7227293B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A2020202020200D0A20202020202069662028217569772E5F697356616C696454696D65287569772E656C656D656E74732E24656E6454696D';
wwv_flow_api.g_varchar2_table(544) := '652E76616C28292C207569772E76616C7565732E75736532346854696D652929207B0D0A2020202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E54686520656E642074696D65206973';
wwv_flow_api.g_varchar2_table(545) := '206E6F742076616C69643C2F6C693E27293B0D0A2020202020202020207569772E656C656D656E74732E24656E6454696D652E616464436C617373282775692D73746174652D6572726F7227293B0D0A20202020202020202072657475726E3B0D0A2020';
wwv_flow_api.g_varchar2_table(546) := '202020207D0D0A2020207D2C0D0A2020205F76616C69646174655374617274446174653A2066756E6374696F6E28297B0D0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A20202020202069662028217569772E656C656D';
wwv_flow_api.g_varchar2_table(547) := '656E74732E247374617274446174652E76616C282929207B0D0A2020202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E5468652073746172742064617465206D757374206861766520';
wwv_flow_api.g_varchar2_table(548) := '736F6D652076616C75653C2F6C693E27293B0D0A2020202020202020207569772E656C656D656E74732E247374617274446174652E616464436C617373282775692D73746174652D6572726F7227293B0D0A20202020202020202072657475726E3B0D0A';
wwv_flow_api.g_varchar2_table(549) := '2020202020207D0D0A2020202020200D0A20202020202069662028217569772E5F697356616C696444617465287569772E656C656D656E74732E247374617274446174652E76616C28292C207569772E6F7074696F6E732E64617465466F726D61742929';
wwv_flow_api.g_varchar2_table(550) := '207B0D0A2020202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E5468652073746172742064617465206973206E6F742076616C69643C2F6C693E27293B0D0A20202020202020202075';
wwv_flow_api.g_varchar2_table(551) := '69772E656C656D656E74732E247374617274446174652E616464436C617373282775692D73746174652D6572726F7227293B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A2020207D2C0D0A2020205F76616C69646174655765';
wwv_flow_api.g_varchar2_table(552) := '656B6C79446179733A2066756E6374696F6E28297B0D0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A20202020202069662028212428276669656C6473657423736269705F7363686564756C655F62796461795F772069';
wwv_flow_api.g_varchar2_table(553) := '6E7075743A636865636B656427292E6C656E67746829207B0D0A2020202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E4174206C65617374206F6E6520646179206F66207468652077';
wwv_flow_api.g_varchar2_table(554) := '65656B206D7573742062652073656C65637465643C2F6C693E27293B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A2020207D2C0D0A2020205F76616C69646174654D6F6E74686C7942793A2066756E6374696F6E2829207B0D';
wwv_flow_api.g_varchar2_table(555) := '0A20202020202076617220756977203D20746869733B0D0A2020202020200D0A20202020202069662028212428276669656C6473657423736269705F6D6F6E74686C795F627920696E7075743A636865636B656427292E6C656E67746829207B0D0A2020';
wwv_flow_api.g_varchar2_table(556) := '202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E546865206D6F6E74686C79207061747465726E206D7573742062652073656C65637465643C2F6C693E27293B0D0A20202020202020';
wwv_flow_api.g_varchar2_table(557) := '202072657475726E3B0D0A2020202020207D0D0A2020207D2C0D0A2020205F76616C6964617465456E64446174653A2066756E6374696F6E28297B0D0A20202020202076617220756977203D20746869733B0D0A20202020202076617220737461727444';
wwv_flow_api.g_varchar2_table(558) := '6174653B0D0A20202020202076617220656E64446174653B0D0A2020202020200D0A20202020202069662028217569772E5F697356616C696444617465287569772E656C656D656E74732E24656E64446174652E76616C28292C207569772E6F7074696F';
wwv_flow_api.g_varchar2_table(559) := '6E732E64617465466F726D61742929207B0D0A2020202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E54686520656E642064617465206973206E6F742076616C69643C2F6C693E2729';
wwv_flow_api.g_varchar2_table(560) := '3B0D0A2020202020202020207569772E656C656D656E74732E24656E64446174652E616464436C617373282775692D73746174652D6572726F7227293B0D0A20202020202020202072657475726E3B0D0A2020202020207D0D0A2020202020200D0A2020';
wwv_flow_api.g_varchar2_table(561) := '20202020696620287569772E5F697356616C696444617465287569772E656C656D656E74732E247374617274446174652E76616C28292C207569772E6F7074696F6E732E64617465466F726D61742929207B0D0A20202020202020202073746172744461';
wwv_flow_api.g_varchar2_table(562) := '7465203D20242E646174657069636B65722E706172736544617465287569772E6F7074696F6E732E64617465466F726D61742C207569772E656C656D656E74732E247374617274446174652E76616C2829293B0D0A202020202020202020656E64446174';
wwv_flow_api.g_varchar2_table(563) := '65203D20242E646174657069636B65722E706172736544617465287569772E6F7074696F6E732E64617465466F726D61742C207569772E656C656D656E74732E24656E64446174652E76616C2829293B0D0A2020202020202020200D0A20202020202020';
wwv_flow_api.g_varchar2_table(564) := '202069662028737461727444617465203E20656E644461746529207B0D0A2020202020202020202020207569772E656C656D656E74732E246572726F724D657373616765732E617070656E6428273C6C693E54686520656E642064617465206D75737420';
wwv_flow_api.g_varchar2_table(565) := '6265206F6E206F722061667465722074686520737461727420646174653C2F6C693E27293B0D0A2020202020202020202020207569772E656C656D656E74732E24656E64446174652E616464436C617373282775692D73746174652D6572726F7227293B';
wwv_flow_api.g_varchar2_table(566) := '0D0A20202020202020202020202072657475726E3B0D0A2020202020202020207D0D0A2020202020207D0D0A2020207D0D0A7D293B0D0A0D0A7D2928617065782E6A5175657279293B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 3146304930583030 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 263801654014856337 + wwv_flow_api.g_id_offset
 ,p_file_name => 'jquery.ui.sbip_schedule.js'
 ,p_mime_type => 'application/x-javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

commit;
begin 
execute immediate 'begin dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
prompt  ...done
